var game;
(function (game) {
    //物理世界
    var xjChipmunk = (function () {
        function xjChipmunk() {
            this._debugNode = null;
            //初始化物理世界
            this.initPhysics();
        }
        xjChipmunk.prototype.getNode = function () {
            return this._debugNode;
        };
        xjChipmunk.prototype.initPhysics = function () {
            var width = 1280;
            var height = 768;
            this._worldSpace = new cp.Space();
            this._worldSpace.gravity = cp.v(0, -200); //设置重力  重力向下为 200
            var staticBody = this._worldSpace.staticBody;
            var walls = [
                new cp.SegmentShape(staticBody, cp.v(0, 0), cp.v(width, 0), 20),
                new cp.SegmentShape(staticBody, cp.v(0, height), cp.v(width, height), 20),
                new cp.SegmentShape(staticBody, cp.v(0, 0), cp.v(0, height), 20),
                new cp.SegmentShape(staticBody, cp.v(width, 0), cp.v(width, height), 20)
            ];
            for (var i = 0; i < walls.length; i++) {
                var shape = walls[i];
                shape.setElasticity(1); //设置弹性系数
                shape.setFriction(1); //设置摩擦力
                this._worldSpace.addStaticShape(shape);
            }
            this._debugNode = new cc.PhysicsDebugNode(this._worldSpace);
            this._debugNode.visible = true;
        };
        xjChipmunk.prototype.update = function (t) {
            //物理世界时间流速
            this._worldSpace.step(t);
        };
        return xjChipmunk;
    }());
    game.xjChipmunk = xjChipmunk;
})(game || (game = {}));
//# sourceMappingURL=xjChipmunk.js.map