module game
{
    //物理世界
    export class xjChipmunk
    {
        _debugNode = null
        _worldSpace
        constructor()
        {
            //初始化物理世界
            this.initPhysics();
        }
        getNode()
        {
            return this._debugNode
        }
        initPhysics()
        {
            let width = 1280;
            let height = 768;

            this._worldSpace = new cp.Space();
            this._worldSpace.gravity = cp.v(0, -200);     //设置重力  重力向下为 200

            let staticBody = this._worldSpace.staticBody;
            let walls = [
                new cp.SegmentShape(staticBody, cp.v(0, 0), cp.v(width, 0), 20),    //最后一个参数是墙的厚度 , 很重要 , 没有厚度的墙体容易被穿透.
                new cp.SegmentShape(staticBody, cp.v(0, height), cp.v(width, height), 20),
                new cp.SegmentShape(staticBody, cp.v(0, 0), cp.v(0, height), 20),
                new cp.SegmentShape(staticBody, cp.v(width, 0), cp.v(width, height), 20)
            ];
            for (let i = 0; i < walls.length; i++)
            {
                let shape:cp.SegmentShape = walls[i];
                shape.setElasticity(1);     //设置弹性系数
                shape.setFriction(1);       //设置摩擦力
                this._worldSpace.addStaticShape(shape);
            }
            this._debugNode = new cc.PhysicsDebugNode(this._worldSpace);
            this._debugNode.visible = true
        }
        update( t )
        {
            //物理世界时间流速
            this._worldSpace.step(t);
        }
    }
}
