module game
{
    export function getRandoneInArray( arr:Array<any>)
    {
        return arr[Math.floor(Math.random() * ( arr.length - .1))]
    }
    export function isstring (str):boolean{
        return (typeof str=='string')&&str.constructor==String;
    }

    export function isArray(obj){
        return (typeof obj=='object') && obj.constructor == Array;
    }

    export function isNumber(obj){
        return (typeof obj=='number')&&obj.constructor==Number;
    }

    export function isObject(obj){
        return (typeof obj=='object') && obj.constructor == Object;
    }

    export function isNull( obj ):boolean
    {
        return obj == null
    }
    export function isFunction(obj){
        return (typeof obj == 'function') && obj.constructor == Function;
    }

    export function getCurTime():string
    {
        return "2017-06-10 09:10:20"
    }

    //正整数
    export function isInt( s  ):boolean
    {
        var re = /^[0-9]*[1-9][0-9]*$/
        return re.test(s) ; //测试 返回true或false
    }
    //正浮点数
    export function isFloat( s ):boolean
    {
        var re = /^(-?\d+)(\.\d+)?$/
        return re.test(s)
    }
    export function isEmail( s ):boolean
    {
        var re = /^\w +[@]\w +[.][\w.] +$/
        return re.test(s)
    }
    ////用户名正则，4到16位（字母，数字，下划线，减号）
    export function  regTest( s ):boolean
    {
        var re =  /^[a-zA-Z0-9_-]{4,16}$/;
        return re.test(s)
    }
    //密码强度正则，最少6位，包括至少1个大写字母，1个小写字母，1个数字，1个特殊字符
    export function  passwordTest( s ):boolean
    {
        var re =  /^.*(?=.{6,})(?=.*\d)(?=.*[A-Z])(?=.*[a-z])(?=.*[!@#$%^&*? ]).*$/;
        return re.test(s)
    }
    //手机号正则
    export function isPhoneNumber( s ):boolean
    {
        var re = /^((13[0-9])|(14[5|7])|(15([0-3]|[5-9]))|(18[0,5-9]))\d{8}$/;
        return re.test(s)
    }
    //身份证号（18位）正则
    export function isIDCard( s ):boolean
    {
        var re = /^[1-9]\d{5}(18|19|([23]\d))\d{2}((0[1-9])|(10|11|12))(([0-2][1-9])|10|20|30|31)\d{3}[0-9Xx]$/;
        return re.test(s)
    }
    //包含中文正则
    export function includeChinese( s ):boolean
    {
        var re = /[\u4E00-\u9FA5]/;
        return re.test(s)
    }
    export function getOS() {
        if(cc.sys.isNative)
        {
            return "null"
        }
        //获取用户代理
        var ua = navigator.userAgent;
        if (ua.indexOf("Windows NT 5.1") != -1) return "Windows XP";
        if (ua.indexOf("Windows NT 6.0") != -1) return "Windows Vista";
        if (ua.indexOf("Windows NT 6.1") != -1) return "Windows 7";
        if (ua.indexOf("Windows NT 10.0") != -1) return "Windows 10";
        if (ua.indexOf("iPhone") != -1) return "iPhone";
        if (ua.indexOf("iPad") != -1) return "iPad";
        if (ua.indexOf("Linux") != -1) {
            var index = ua.indexOf("Android");
            if (index != -1) {
        //os以及版本
                var os = ua.slice(index, index+13);

        //手机型号
                var index1 = ua.lastIndexOf(";");
                var index2 = ua.indexOf("Build");
                var type = ua.slice(index1+1, index2);
                return type + os;
            } else {
                return "Linux";
            }
        }

    return "未知操作系统";
}

}