var game;
(function (game) {
    //体力恢复系统 ,全部使用时间戳计算
    var energyMgr = (function () {
        function energyMgr() {
            this.m_isInit = false; //初始化状态，在获得服务器上玩家存档后
            this.m_curServerTime = 0; //当前服务器时间，在体力值未满状态下，每十秒刷新一下
            this.m_lastrecoverTime = 0; //时间戳
            this.m_recoverTime = 0; //恢复一格体力所需时间
            //每十秒获取服务器时间计算一次体力
            this.m_time10s = 10;
        }
        energyMgr.getMe = function () {
            if (!energyMgr.g_instance) {
                energyMgr.g_instance = new energyMgr();
            }
            return energyMgr.g_instance;
        };
        energyMgr.prototype.updateCurtime = function (time) {
            //防止服务器时间异常导致的错误
            if (time < 1505126082000) {
                return;
            }
            this.m_curServerTime = new Date(time).getTime();
            if (!this.m_isInit)
                return;
            this.m_lastrecoverTime = game.fileMgr.getMe().m_play_doc.coreData.recoverTime;
            // console.log("当前服务器时间 :" + this.m_curServerTime + "  上次体力恢复时间 :" + this.m_lastrecoverTime )
            var distime_ms = this.m_curServerTime - this.m_lastrecoverTime;
            //长时间未登陆时间计算较长，直接重置为20格体力恢复的时间
            var max = game.g_max_energy;
            if (game.dataMgr.getMe().getViplevel() >= game.g_tilishangxianunlock) {
                max = game.g_max_energy * 2;
            }
            if (distime_ms >= this.m_recoverTime * max) {
                distime_ms = this.m_recoverTime * max;
            }
            var isrecover = false;
            while ((distime_ms - this.m_recoverTime) >= 0) {
                distime_ms -= this.m_recoverTime;
                game.dataMgr.getMe().recoverEnergy();
                isrecover = true;
            }
            //恢复体力才更新存档数据
            // if(isrecover)
            // {
            //     httpMgr.getMe().sendMsg(g_httpType.type_httpSaveGameData)
            // }
        };
        energyMgr.prototype.init = function (lastrecoverTime) {
            console.log("energy init...");
            this.m_isInit = true;
            this.m_lastrecoverTime = lastrecoverTime;
            this.m_recoverTime = game.g_recoverTime * 60 * 1000;
            this.updateCurtime(this.m_curServerTime);
            // httpMgr.getMe().sendMsg(g_httpType.type_httpSaveGameData)
        };
        energyMgr.prototype.loop_10s = function (t) {
            this.m_time10s -= t;
            if (this.m_time10s > 0) {
                return;
            }
            this.m_time10s = 10;
            game.httpMgr.getMe().sendMsg(game.g_httpType.type_httpGetServerTime);
        };
        energyMgr.prototype.loop = function (t) {
            if (!this.m_isInit) {
                return;
            }
            if (game.dataMgr.getMe().getenergy() >= game.g_max_energy) {
                return;
            }
            this.loop_10s(t);
        };
        energyMgr.g_instance = null;
        return energyMgr;
    }());
    game.energyMgr = energyMgr;
})(game || (game = {}));
//# sourceMappingURL=energyMgr.js.map