module game
{
    //体力恢复系统 ,全部使用时间戳计算
    export class energyMgr
    {
        private  static g_instance:energyMgr = null
        static getMe():energyMgr
        {
            if(!energyMgr.g_instance)
            {
                energyMgr.g_instance = new energyMgr()
            }
            return energyMgr.g_instance
        }

        m_isInit:boolean = false    //初始化状态，在获得服务器上玩家存档后
        m_curServerTime:number = 0  //当前服务器时间，在体力值未满状态下，每十秒刷新一下
        m_lastrecoverTime:number = 0 //时间戳
        m_recoverTime:number = 0    //恢复一格体力所需时间
        m_curDate;//服务器时间
        updateCurtime( time )
        {
            //防止服务器时间异常导致的错误
            if( time < 1505126082000  )
            {
                return
            }
            this.m_curServerTime = new Date(time).getTime()

            if( ! this.m_isInit)
                return

            this.m_lastrecoverTime = fileMgr.getMe().m_play_doc.coreData.recoverTime
            // console.log("当前服务器时间 :" + this.m_curServerTime + "  上次体力恢复时间 :" + this.m_lastrecoverTime )
            let distime_ms = this.m_curServerTime -  this.m_lastrecoverTime
            //长时间未登陆时间计算较长，直接重置为20格体力恢复的时间
            let max:number = g_max_energy;
            if(dataMgr.getMe().getViplevel() >= g_tilishangxianunlock){
                max = g_max_energy * 2;
            }

            if(distime_ms >= this.m_recoverTime * max)
            {
                distime_ms = this.m_recoverTime * max
            }
            let isrecover = false
            while ((distime_ms - this.m_recoverTime) >= 0)
            {
                distime_ms -= this.m_recoverTime
                dataMgr.getMe().recoverEnergy()
                isrecover = true
            }
            //恢复体力才更新存档数据
            // if(isrecover)
            // {
            //     httpMgr.getMe().sendMsg(g_httpType.type_httpSaveGameData)
            // }
        }

        init( lastrecoverTime:number )
        {
            console.log("energy init...")
            this.m_isInit = true
            this.m_lastrecoverTime = lastrecoverTime
            this.m_recoverTime = g_recoverTime * 60 * 1000
            this.updateCurtime(this.m_curServerTime)
            // httpMgr.getMe().sendMsg(g_httpType.type_httpSaveGameData)
        }
        //每十秒获取服务器时间计算一次体力
        m_time10s = 10
        loop_10s( t )
        {
            this.m_time10s -= t
            if( this.m_time10s > 0 )
            {
                return
            }
            this.m_time10s = 10
            httpMgr.getMe().sendMsg(g_httpType.type_httpGetServerTime)
        }


        loop( t )
        {
            if( !this.m_isInit )
            {
                return
            }
            if( dataMgr.getMe().getenergy() >= g_max_energy)
            {
                return
            }
            this.loop_10s( t )
        }
    }
}