var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var BulletData = (function () {
        function BulletData() {
        }
        BulletData.prototype.toString = function () {
            return "scale :" + this.scale + "\n"
                + "speedMin :" + this.speedMin + "\n"
                + "speedMax :" + this.speedMax + "\n"
                + "earthDamage :" + this.earthDamage + "\n"
                + "g :" + this.g + "\n"
                + "hard :" + this.hard + "\n"
                + "boomRange :" + this.boomRange + "\n"
                + "boomSpine :" + this.boomSpine + "\n"
                + "boomScale :" + this.boomScale + "\n"
                + "shoujiSpine :" + this.shoujiSpine + "\n"
                + "shoujiAnimation :" + this.shoujiAnimation + "\n"
                + "shoujiScale :" + this.shoujiScale + "\n"
                + "damageType :" + this.damageType + "\n"
                + "filpX :" + this.filpX + "\n";
        };
        return BulletData;
    }());
    game.BulletData = BulletData;
    var baseBullet = (function (_super) {
        __extends(baseBullet, _super);
        function baseBullet() {
            _super.apply(this, arguments);
            this.m_timer = 0;
        }
        baseBullet.create = function (data) {
            var bullet = new baseBullet();
            bullet.initData(data);
            return bullet;
        };
        baseBullet.prototype.initData = function (data) {
            this.m_bulletData = data;
            this.loadres();
            this.setPosition(this.m_bulletData.m_pos);
            this.m_canMove = true;
            // this.m_oldPos = this.getPosition();
            this.m_roledir = this.m_bulletData.m_roledir;
            game.cameraMgr.getMe().reset(this.getPosition(), this);
        };
        baseBullet.prototype.canRotation = function () {
            return this.m_bulletData.filpX == 0;
            // return true;
        };
        baseBullet.prototype.updateRotation = function (oldPos, newPos) {
            var shootVector = cc.pNormalize(cc.pSub(oldPos, newPos));
            var degrees = cc.radiansToDegrees(cc.pToAngle(shootVector));
            if (this.m_bulletData.m_roledir > 0) {
                this.setRotation(180 - degrees);
            }
            else {
                this.setRotation(-degrees);
            }
        };
        baseBullet.prototype.update = function (dt) {
            if (!this.m_canMove)
                return;
            this.m_timer += dt;
            this.m_pos = this.getPosition();
            if (this.m_pos.x < 0 || this.m_pos.x > 2000 || this.m_pos.y < 0 || this.m_pos.y > 3000) {
                this.moveEnd();
                return;
            }
            this.m_pos.y -= this.m_timer * this.m_bulletData.g;
            this.m_pos = cc.pAdd(this.m_pos, cc.pMult(this.m_bulletData.m_dir, this.m_bulletData.m_speed * dt));
            // let x = this.m_bulletData.m_dir.x * this.m_bulletData.m_speed * dt;
            // let y = this.m_bulletData.m_dir.y * this.m_bulletData.m_speed * dt;
            // this.m_pos.x = this.m_pos.x +x;
            // this.m_pos.y = this.m_pos.x +y;
            // cc.log("time:",this.m_timer);
            /*            let x = this.m_bulletData.m_speed * this.m_bulletData.m_dir.x * this.m_timer;
             let y = ((this.m_bulletData.m_speed * this.m_bulletData.m_dir.y) * 2 - this.m_bulletData.g * this.m_timer) * this.m_timer / 2;
             this.m_pos = cc.pAdd(this.m_oldPos, cc.p(x, y));*/
            if (game.sceneMgr.getMe().getCurScene().m_tileMap.canMove(this.m_pos)) {
                if (this.canRotation()) {
                    this.updateRotation(this.getPosition(), this.m_pos);
                }
                this.move();
            }
            else {
                this.m_timer = 0;
                var hard = game.sceneMgr.getMe().getCurScene().m_tileMap.getGIDHard(this.m_pos);
                // cc.log(hard);
                this.m_bulletData.m_speed = this.m_bulletData.m_speed * this.m_bulletData.hard * hard;
                if (this.m_bulletData.m_speed < game.g_other_config.bulletMinSpeed) {
                    if (this.m_bulletData.damageType == "boom") {
                        this.boom(this.m_pos);
                    }
                    this.moveEnd();
                }
            }
        };
        baseBullet.prototype.getSpeed = function () {
            return this.m_bulletData.m_speed;
        };
        baseBullet.prototype.move = function () {
            this.setPosition(this.m_pos);
            this.dealphy(this.m_pos);
        };
        baseBullet.prototype.moveEnd = function () {
            this.m_canMove = false;
            cc.log("moveEnd");
            game.bulletMgr.getMe().removeBullet(this.__instanceId);
        };
        baseBullet.prototype.dealphy = function (pos) {
            var roleMap;
            if (this.m_bulletData.m_isplayer) {
                if (game.sceneMgr.getMe().getCurScene() instanceof game.fightAiscene) {
                    var rolemgr = game.roleMgr.getMe();
                    roleMap = rolemgr.m_matcher_map;
                }
                else if (game.sceneMgr.getMe().getCurScene() instanceof game.PVP_fight) {
                    var rolemgr = game.roleMgr.getMe();
                    roleMap = rolemgr.m_matcher_map;
                }
                else {
                    roleMap = game.roleMgr.getMe().m_monster_map;
                }
            }
            else {
                roleMap = game.roleMgr.getMe().m_player_map;
            }
            for (var i = 0; i < roleMap.size; ++i) {
                this.m_dealTarget = roleMap.getByIndex(i);
                if (this.m_dealTarget.isDead())
                    continue;
                if (this.m_dealTarget.dealPhy(pos)) {
                    if (this.m_bulletData.damageType == "boom") {
                        this.boom(pos);
                    }
                    else {
                        this.hit();
                    }
                    this.moveEnd();
                    return;
                }
            }
        };
        baseBullet.prototype.hit = function () {
            cc.log("子弹撞击伤害", this.m_dealTarget.getName());
            this.m_dealTarget.onDamage(this.m_bulletData.shoujiSpine, this.m_bulletData.shoujiAnimation, this.m_bulletData.shoujiScale, this.m_bulletData.m_roleId, false);
        };
        baseBullet.prototype.boom = function (pos) {
            if (!this.m_dealTarget) {
                this.m_dealTarget = game.roleMgr.getMe().m_AllRole_map.getByIndex(this.m_bulletData.m_roleId);
            }
            cc.log("子弹会爆炸", this.m_dealTarget.getName());
            var ret = game.spineMgr.getMe().createSpineOncePlay(this.m_bulletData.boomSpine, this.m_bulletData.boomAnimation, game.roleMgr.getMe().getNode(), pos);
            ret.setScale(this.m_bulletData.boomScale);
            // 炸人 // 炸地面
            this.boomRole();
            this.boomGround(this.m_bulletData.boomRange);
        };
        baseBullet.prototype.boomRole = function () {
            for (var i = 0; i < game.roleMgr.getMe().m_AllRole_map.size; ++i) {
                this.m_dealTarget = game.roleMgr.getMe().m_AllRole_map.getByIndex(i);
                if (this.m_dealTarget.isDead())
                    continue;
                // if(cc.rectIntersectsRect(this.m_dealTarget.getshoujizudang(),this.getshoujizudang())){
                //     this.m_dealTarget.onDamage(this.m_bulletData.shoujiSpine, this.m_bulletData.shoujiAnimation, this.m_bulletData.shoujiScale, this.m_bulletData.m_roleId, true);
                // }
                // let dis = cc.pDistance(this.m_dealTarget.getBoneWroldPosition("shoujizudang"), this.getBoneWroldPosition("gongjizudang1"));
                // if (dis < this.m_bulletData.boomRange) {
                //     this.m_dealTarget.onDamage(this.m_bulletData.shoujiSpine, this.m_bulletData.shoujiAnimation, this.m_bulletData.shoujiScale, this.m_bulletData.m_roleId, true);
                // }
                this.dealBoomRole(this.m_dealTarget);
            }
        };
        baseBullet.prototype.dealBoomRole = function (role) {
            var rect = role.getshoujizudang();
            var p = cc.p(rect.x, rect.y);
            if (this.dealtwo(p, role)) {
                return;
            }
            p = cc.p(rect.x, rect.y + rect.height);
            if (this.dealtwo(p, role)) {
                return;
            }
            p = cc.p(rect.x + rect.width, rect.y + rect.height);
            if (this.dealtwo(p, role)) {
                return;
            }
            p = cc.p(rect.x + rect.width, rect.y);
            if (this.dealtwo(p, role)) {
                return;
            }
            p = cc.p(rect.x + rect.width / 2, rect.y + rect.height / 2);
            if (this.dealtwo(p, role)) {
                return;
            }
        };
        baseBullet.prototype.dealtwo = function (p, role) {
            var dis = cc.pDistance(p, this.getPosition());
            if (dis < this.m_bulletData.boomRange) {
                role.onDamage(this.m_bulletData.shoujiSpine, this.m_bulletData.shoujiAnimation, this.m_bulletData.shoujiScale, this.m_bulletData.m_roleId, true);
                return true;
            }
            return false;
        };
        baseBullet.prototype.boomGroundEx = function (range) {
            if (range < 25) {
                return 25;
            }
            if (range < 50) {
                return 50;
            }
            if (range < 75) {
                return 75;
            }
            if (range < 100) {
                return 100;
            }
            if (range < 125) {
                return 125;
            }
            if (range < 150) {
                return 150;
            }
            if (range < 175) {
                return 175;
            }
            if (range < 200) {
                return 200;
            }
            if (range < 255) {
                return 255;
            }
            return 0;
        };
        baseBullet.prototype.boomGround = function (range) {
            this.dealGroudByDegress(5, range);
            range = this.boomGroundEx(range);
            switch (range) {
                case 255:
                    this.dealGroudByDegress(5, 255);
                case 200:
                    this.dealGroudByDegress(5, 200);
                case 175:
                    this.dealGroudByDegress(5, 175);
                case 150:
                    this.dealGroudByDegress(10, 150);
                case 125:
                    this.dealGroudByDegress(10, 125);
                case 100:
                    this.dealGroudByDegress(20, 100);
                case 75:
                    this.dealGroudByDegress(20, 75);
                case 50:
                    this.dealGroudByDegress(20, 50);
                case 25:
                    this.dealGroudByDegress(20, 25);
                case 0:
                    this.dealGroudByDegress(360, 0);
            }
        };
        baseBullet.prototype.dealGroudByDegress = function (degress, distance) {
            for (var i = 0; i < 360 / degress; ++i) {
                game.sceneMgr.getMe().getCurScene().m_tileMap.reMoveSpriteByWorldPosition(game.pForDegressAndDistance(this.m_pos, 360 / degress * i, distance), this.m_bulletData.earthDamage, this.__instanceId);
            }
        };
        baseBullet.prototype.loadres = function () {
            this.m_SpineNode = game.spineMgr.getMe().loadSpine(this.m_bulletData.res, this.getNode(), 4);
            this.m_SpineNode.setAnimation(0, this.m_bulletData.resAnimation, true);
            this.m_SpineNode.setScale(this.m_bulletData.scale);
            this.m_scale = this.m_bulletData.scale;
            if (this.m_bulletData.m_roledir > 0) {
                this.m_SpineNode.setScaleX(-1 * this.m_SpineNode.getScale());
                this.setRotation(-this.m_bulletData.m_angle);
            }
            else {
                this.setRotation(180 - this.m_bulletData.m_angle);
            }
            return true;
        };
        baseBullet.prototype.zanting = function (flag) {
            if (flag) {
                this.m_SpineNode.pause();
            }
            else {
                this.m_SpineNode.resume();
            }
        };
        baseBullet.prototype.shutdown = function () {
            this.m_canMove = false;
            if (this.m_SpineNode) {
                this.removeChild(this.m_SpineNode.getNode());
                this.m_SpineNode = null;
            }
        };
        baseBullet.prototype.getshoujizudang = function () {
            var rect = this.m_SpineNode.getBoundingBoxBySlotName("gongjizudang1");
            var root = this.getPosition();
            rect.x = root.x + (rect.x - root.x) * this.m_scale;
            rect.y = root.y + (rect.y - root.y) * this.m_scale;
            rect.width *= this.m_scale;
            rect.height *= this.m_scale;
            return rect;
        };
        baseBullet.prototype.getBoneWroldPosition = function (bonename) {
            var pspBone = this.m_SpineNode.getBoneWorldPos_Root(bonename);
            if (pspBone) {
                var buff = cc.p(pspBone.x * this.getScale() * this.m_SpineNode.getScaleX(), pspBone.y * this.getScale());
                var buff1 = this.getPosition();
                return cc.pAdd(buff, buff1);
            }
            else {
                // uiMgr.getMe().show_ui_MessageBox(true, "error SkeletonAnimation_Ex::getBoneWorldPos   " + this.m_name + "没有这个骨骼 ：" + bonename);
                return null;
            }
        };
        return baseBullet;
    }(game.xjNode));
    game.baseBullet = baseBullet;
})(game || (game = {}));
//# sourceMappingURL=baseBullet.js.map