var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var crossBullet = (function (_super) {
        __extends(crossBullet, _super);
        function crossBullet() {
            _super.apply(this, arguments);
            this.roleArr = new game.Map();
        }
        crossBullet.create = function (data) {
            var bullet = new crossBullet();
            bullet.initData(data);
            return bullet;
        };
        crossBullet.prototype.update = function (dt) {
            if (!this.m_canMove)
                return;
            this.m_timer += dt;
            this.m_pos = this.getPosition();
            if (this.m_pos.x < 0 || this.m_pos.x > 2000 || this.m_pos.y < 0 || this.m_pos.y > 3000) {
                this.moveEnd();
                return;
            }
            this.m_pos.y -= this.m_timer * this.m_bulletData.g;
            this.m_pos = cc.pAdd(this.m_pos, cc.pMult(this.m_bulletData.m_dir, this.m_bulletData.m_speed * dt));
            if (game.sceneMgr.getMe().getCurScene().m_tileMap.canMove(this.m_pos)) {
                if (this.canRotation()) {
                    this.updateRotation(this.getPosition(), this.m_pos);
                }
                this.move();
            }
            else {
                this.m_timer = 0;
                var hard = game.sceneMgr.getMe().getCurScene().m_tileMap.getGIDHard(this.m_pos);
                this.m_bulletData.m_speed = this.m_bulletData.m_speed * this.m_bulletData.hard * hard;
                this.roleArr.clear();
                if (this.m_bulletData.m_speed < game.g_other_config.bulletMinSpeed) {
                    if (this.m_bulletData.damageType == "boom") {
                        this.boom(this.m_pos);
                    }
                    this.moveEnd();
                }
            }
        };
        crossBullet.prototype.dealphy = function (pos) {
            var roleMap;
            if (this.m_bulletData.m_isplayer) {
                if (game.sceneMgr.getMe().getCurScene() instanceof game.fightAiscene) {
                    var rolemgr = game.roleMgr.getMe();
                    roleMap = rolemgr.m_matcher_map;
                }
                else if (game.sceneMgr.getMe().getCurScene() instanceof game.PVP_fight) {
                    var rolemgr = game.roleMgr.getMe();
                    roleMap = rolemgr.m_matcher_map;
                }
                else {
                    roleMap = game.roleMgr.getMe().m_monster_map;
                }
            }
            else {
                roleMap = game.roleMgr.getMe().m_player_map;
            }
            for (var i = 0; i < roleMap.size; ++i) {
                this.m_dealTarget = roleMap.getByIndex(i);
                if (this.m_dealTarget.isDead())
                    continue;
                if (this.m_dealTarget.dealPhy(pos)) {
                    if (!this.roleArr.get(this.m_dealTarget.__instanceId)) {
                        this.roleArr.set(this.m_dealTarget.__instanceId, 1);
                        this.hit();
                    }
                }
            }
        };
        return crossBullet;
    }(game.baseBullet));
    game.crossBullet = crossBullet;
})(game || (game = {}));
//# sourceMappingURL=crossBullet.js.map