module game {
    export class crossBullet extends baseBullet {
        roleArr: Map<number,number> = new Map<number,number>();

        static create(data: BulletData) {
            let bullet = new crossBullet();
            bullet.initData(data);
            return bullet;
        }

        update(dt) {
            if (!this.m_canMove) return;
            this.m_timer += dt;
            this.m_pos = this.getPosition();
            if (this.m_pos.x < 0 || this.m_pos.x > 2000 || this.m_pos.y < 0 || this.m_pos.y > 3000) {
                this.moveEnd();
                return;
            }
            this.m_pos.y -= this.m_timer * this.m_bulletData.g;
            this.m_pos = cc.pAdd(this.m_pos, cc.pMult(this.m_bulletData.m_dir, this.m_bulletData.m_speed * dt));

            if (sceneMgr.getMe().getCurScene().m_tileMap.canMove(this.m_pos)) {
                if (this.canRotation()) {
                    this.updateRotation(this.getPosition(), this.m_pos);
                }
                this.move();
            } else {
                this.m_timer = 0;
                let hard = sceneMgr.getMe().getCurScene().m_tileMap.getGIDHard(this.m_pos);
                this.m_bulletData.m_speed = this.m_bulletData.m_speed * this.m_bulletData.hard * hard;
                this.roleArr.clear();
                if (this.m_bulletData.m_speed < g_other_config.bulletMinSpeed) {
                    if (this.m_bulletData.damageType == "boom") {
                        this.boom(this.m_pos);
                    }
                    this.moveEnd();
                }
            }
        }

        dealphy(pos: cc.Vec2) {
            let roleMap;
            if (this.m_bulletData.m_isplayer) {
                if(sceneMgr.getMe().getCurScene() instanceof fightAiscene){
                    let rolemgr = <roleMgr_ai>roleMgr.getMe();
                    roleMap = rolemgr.m_matcher_map;
                }
                else if(sceneMgr.getMe().getCurScene() instanceof PVP_fight){
                    let rolemgr = <roleMgr_pvp>roleMgr.getMe();
                    roleMap = rolemgr.m_matcher_map;
                }
                else{
                    roleMap = roleMgr.getMe().m_monster_map;
                }
            } else {
                roleMap = roleMgr.getMe().m_player_map;
            }
            for (let i = 0; i < roleMap.size; ++i) {
                this.m_dealTarget = roleMap.getByIndex(i);
                if (this.m_dealTarget.isDead()) continue;
                if (this.m_dealTarget.dealPhy(pos)) {
                    if (!this.roleArr.get(this.m_dealTarget.__instanceId)) {
                        this.roleArr.set(this.m_dealTarget.__instanceId, 1);
                        this.hit();
                    }
                }
            }
        }
    }
}