module game {
    export class HeroData {
        name: string;
        skin: string;
        title: string | number;
        titleLevel: number;
        weapon: Array<any> = new Array<any>();
    }
    export class PVPData {
        acc: string;
        name: string;
        level: number;
        curHero: HeroData = new HeroData();
        curFollower: HeroData = new HeroData();
        viplevel: number;
        rank_score: number;
        extraAtt: number;
        extraDef: number;
        extraHP: number;
        extraPower: number;
        sceneName: string;
    }
    export function getPVPData() {
        let data = new PVPData();
        let playData = dataMgr.getMe().getPlayDoc();
        data.acc = iapMgr.getMe().getaccount();
        data.name = playData.coreData.name;
        data.level = playData.coreData.level;
        data.curHero.name = playData.coreData.curHero;
        data.curHero.skin = dataMgr.getMe().getHeroSkin(data.curHero.name);
        data.curHero.title = dataMgr.getMe().getTittle(data.curHero.name);
        data.curHero.titleLevel = dataMgr.getMe().getTittlelevel(data.curHero.title);
        data.curHero.weapon = playData[data.curHero.name + "_weapon"];

        if (playData.coreData.curFollower) {
            data.curFollower.name = playData.coreData.curFollower;
            data.curFollower.skin = dataMgr.getMe().getHeroSkin(data.curFollower.name);
            data.curFollower.title = dataMgr.getMe().getTittle(data.curFollower.name);
            data.curFollower.titleLevel = dataMgr.getMe().getTittlelevel(data.curFollower.title);
            data.curFollower.weapon = playData[data.curFollower.name + "_weapon"];
        }

        data.viplevel = playData.coreData.viplevel;
        data.rank_score = playData.coreData.rank_score;
        data.extraAtt = playData.coreData.extraAtt;
        data.extraDef = playData.coreData.extraDef;
        data.extraHP = playData.coreData.extraHP;
        data.extraPower = playData.coreData.extraPower;

        return data;
    }

    export class proto_fightPVP extends protoBuffBase<tongyong_s> {
        static g_insta: proto_fightPVP = null;
        m_isP1: boolean;
        m_data: PVPData;

        static getMe(): proto_fightPVP {
            return protoBuffBase.getMe(proto_fightPVP);
        };

        constructor(path: string = "tongyong.proto") {
            super(path, protoMessType.fightPVP);
        }

        callback(data: tongyong_s) {
            cc.log("打玩家...");
            if(ui_paiweiloading.getMe()){
                ui_paiweiloading.getMe().m_isPvp = true;
            }
            sync_start.getMe().m_state = 0;
            this.m_isP1 = (data.int32var1 == 1);
            this.m_data = JSON.parse(data.strvar7);
            this.initRole();
        }

        initRole() {
            // 先展示数据一下再退出  初始化匹配数据
            let data:pipeiData = new pipeiData();
            if (this.m_isP1) {
                data.sceneName = proto_data.getMe().m_sceneName;
            } else {
                data.sceneName = this.m_data.sceneName;
            }
            data.roleName1 = this.m_data.curHero.name;
            data.roleSkin1 = this.m_data.curHero.skin;
            data.title1 = this.m_data.curHero.title;
            data.titleLevel1 = this.m_data.curHero.titleLevel;

            data.roleName2 = this.m_data.curFollower.name;
            data.roleSkin2 = this.m_data.curFollower.skin;
            data.title2 = this.m_data.curFollower.title;
            data.titleLevel2 = this.m_data.curFollower.titleLevel;
            data.nickName = this.m_data.name;
            data.level    = this.m_data.level;
            // console.log("zz:" + JSON.stringify(data))
           if( data){
               if(ui_paiweiloading.getMe()){
                   ui_paiweiloading.getMe().succeedCallBack(data);
               }else {
                   proto_out.getMe().send();
               }
               proto_pvpLogin.getMe().m_data = data;
           }

            // ui_paiweiloading.ShowOrHide(false);
            // sceneMgr.getMe().selectScene(e_SceneType.SceneType_pvp, data.sceneName);
        }

    }
}