var game;
(function (game) {
    var RoundManager = (function () {
        function RoundManager() {
            this.m_round = 0;
            this.m_curRoleIndex = 0;
            this.m_maxRoleIndex = 0;
            this.m_isOver = false;
            this.m_canHideTimer = false;
            this.m_buyonce = false;
        }
        RoundManager.getMe = function () {
            // console.log("sceneMgr.getMe().m_curScene:" + sceneMgr.getMe().m_curScene)
            if (game.sceneMgr.getMe().m_curScene instanceof game.fightAiscene) {
                if (!game.RoundManager_ai.g_instance) {
                    game.RoundManager_ai.g_instance = new game.RoundManager_ai();
                }
                return game.RoundManager_ai.g_instance;
            }
            if (game.sceneMgr.getMe().m_curScene instanceof game.PVP_fight) {
                if (!game.RoundManager_pvp.g_instance) {
                    game.RoundManager_pvp.g_instance = new game.RoundManager_pvp();
                }
                return game.RoundManager_pvp.g_instance;
            }
            if (!RoundManager.g_instance) {
                RoundManager.g_instance = new RoundManager();
            }
            return RoundManager.g_instance;
        };
        RoundManager.prototype.init = function () {
            this.m_isOver = false;
            this.m_round = 0;
            this.m_curRoleIndex = 0;
            this.m_maxRoleIndex = 0;
            this.m_canHideTimer = false;
            this.m_timer = 30;
        };
        RoundManager.prototype.start = function () {
            // let a = setInterval(() => {
            this.m_curRoleIndex = 0;
            this.updateControlRole();
            // clearInterval(a);
            // }, 1000);
        };
        RoundManager.prototype.nextRound = function () {
            this.m_round++;
            this.m_curRoleIndex = 0;
        };
        RoundManager.prototype.nextStep = function () {
            if (this.m_isOver)
                return;
            game.ui_selectWeapon.ShowOrHide(false);
            RoundManager.gameEnd();
            if (game.shengliOrshibai.getMe())
                return;
            if (game.ui_win.getMe() || game.ui_lose.getMe())
                return;
            this.m_curRoleIndex++;
            if (this.m_curRoleIndex >= this.m_maxRoleIndex) {
                this.nextRound();
            }
            this.updateControlRole();
            // cc.log("aaaaaaaaaaaaaaaaaa",this.m_curRoleIndex);
            // cc.log("player dead :",roleMgr.getMe().m_deadNum_player);
            // cc.log("monster dead :",roleMgr.getMe().m_deadNum_monster);
        };
        RoundManager.gameEndEx = function () {
            if (game.sceneMgr.getMe().m_curScene instanceof game.fightAiscene) {
                game.RoundManager_ai.gameEnd();
            }
            if (game.sceneMgr.getMe().m_curScene instanceof game.PVP_fight) {
                game.RoundManager_pvp.gameEnd();
            }
            if (game.sceneMgr.getMe().m_curScene instanceof game.fightscene) {
                RoundManager.gameEnd();
            }
        };
        RoundManager.gameEnd = function () {
            var _this = this;
            if (RoundManager.getMe().m_isOver)
                return;
            if (game.dataMgr.getMe().isUnlockYindao("f5") && !game.dataMgr.getMe().isUnlockYindao("z1")) {
                if (game.roleMgr.getMe().isMonsterAllDead()) {
                    game.shengliOrshibai.ShowOrHide(true, true);
                }
                else if (game.roleMgr.getMe().isPlayerAllDead()) {
                    game.shengliOrshibai.ShowOrHide(true, false);
                }
            }
            else {
                if (game.roleMgr.getMe().isMonsterAllDead()) {
                    cc.log("胜利");
                    RoundManager.getMe().m_isOver = true;
                    if (game.sceneMgr.getMe().getCurSceneType() == game.e_SceneType.SceneType_fight) {
                        game.ui_win.ShowOrHide(true, game.sceneMgr.getMe().getCurSceneInfo());
                    }
                }
                else if (game.roleMgr.getMe().isPlayerAllDead()) {
                    cc.log("失败");
                    RoundManager.getMe().m_isOver = true;
                    var price_1 = game.Version_mgr.getInstance().getDiamondPriceBystr("fuhuoCost");
                    if (RoundManager.getMe().m_buyonce) {
                        // ui_lose.ShowOrHide(true, sceneMgr.getMe().getCurSceneInfo());
                        return;
                    }
                    game.ui_fuhuo.ShowOrHide(true, "是否花费" + price_1 + "钻石复活角色?", function () {
                        RoundManager.getMe().m_buyonce = true;
                        game.buy_mgr.getInstance().buyFuhuo_buy(RoundManager.getMe().fuhuoSucceedCallBack, _this, price_1, function () {
                            game.rootScene.getMe().zanting(false);
                            if (!game.dataMgr.getMe().isUnlockYindao("s1")) {
                                game.ui_yindao_shibai1.ShowOrHide(true);
                            }
                            game.ui_lose.ShowOrHide(true, game.sceneMgr.getMe().getCurSceneInfo());
                        });
                    }, function () {
                        game.rootScene.getMe().zanting(false);
                        RoundManager.getMe().m_buyonce = true;
                        if (!game.dataMgr.getMe().isUnlockYindao("s1")) {
                            game.ui_yindao_shibai1.ShowOrHide(true);
                        }
                        game.ui_lose.ShowOrHide(true, game.sceneMgr.getMe().getCurSceneInfo());
                    });
                }
            }
        };
        //复活成功的回调
        RoundManager.prototype.fuhuoSucceedCallBack = function () {
            game.rootScene.getMe().zanting(false);
            RoundManager.getMe().m_isOver = false;
            RoundManager.getMe().m_buyonce = false;
            for (var p = 0; p < game.roleMgr.getMe().m_player_map.size; p++) {
                var player_1 = game.roleMgr.getMe().m_player_map.getByIndex(p);
                player_1.fuhuo();
                RoundManager.getMe().start();
            }
        };
        RoundManager.prototype.updateControlRole = function () {
            if (this.m_isOver)
                return;
            if (game.roleMgr.getMe() == null) {
                return;
            }
            this.m_timer = 90;
            this.m_canHideTimer = false;
            game.playControl.getMe().setDefault();
            var role = game.roleMgr.getMe().m_AllRole_map.get(this.m_curRoleIndex);
            if (game.ui_zhandoujiemian.getMe()) {
                game.ui_zhandoujiemian.getMe().setuitexiao(role.m_name, role);
                game.ui_zhandoujiemian.getMe().setHP(role.getHp(), role.getMaxHp());
            }
            // if (role.m_debuffCount > 0) {
            //     role.m_debuffCount--;
            //     // role.onDamage()
            //     if (role.m_buffName) {
            //         let data = g_buff_config[role.m_buffName];
            //         role.onDamage_ex(data.shoujiSpine, data.shoujiAnimation, data.shoujiScale, data.damage);
            //     }
            // }
            if (role.isDead()) {
                this.nextStep();
                return;
            }
            role.setCurPower(role.getMaxPower());
            if (role instanceof game.player) {
                game.roleMgr.getMe().m_curRole = role;
                // roleMgr.getMe().m_curRole.m_controlerState.m_isStayForce = false;
                // if( !roleMgr.getMe().m_curRole.m_controlerState.m_isStayForce){
                //     console.log("zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz")
                // }
                role.changeState_Ex(game.g_AiType.g_AiType_idle);
                game.uiMgr.getMe().show_OnceAnimation("round.json", function () {
                    game.ui_selectWeapon.ShowOrHide(true);
                }.bind(this));
            }
            game.cameraMgr.getMe().reset(role.getPosition(), role);
            if (role instanceof game.monster) {
                // bulletMgr.getMe().initDeleteBulletNum(getWeaponConfig()[role.getName()]["0"].shootNum);
                role.m_controlerState.begin();
                this.m_timer = 10;
            }
            if (game.ui_arraw.getMe()) {
                game.ui_arraw.getMe().setRole(role);
            }
        };
        RoundManager.prototype.loop = function (t) {
            if (this.m_isOver)
                return;
            if (game.rootScene.getMe().iszanting()) {
                return;
            }
            if (game.ui_win.getMe() || game.ui_lose.getMe()) {
                return;
            }
            this.m_timer -= t;
            if (!this.m_canHideTimer) {
                if (game.ui_zhandoujiemian.getMe()) {
                    game.ui_zhandoujiemian.getMe().roundCountdown(this.m_timer);
                }
            }
            if (this.m_timer > 0) {
                if (game.ui_zhandoujiemian.getMe()) {
                    if (game.roleMgr.getMe() == null) {
                        return;
                    }
                    if (game.roleMgr.getMe().getControlPlayer() == null) {
                        return;
                    }
                    var role = game.roleMgr.getMe().m_AllRole_map.get(this.m_curRoleIndex);
                    if (role.m_name != game.roleMgr.getMe().getControlPlayer().m_name) {
                        return;
                    }
                    game.ui_zhandoujiemian.getMe().setHP(role.getHp(), role.getMaxHp());
                }
            }
            if (this.m_timer <= 0) {
                game.roleMgr.getMe().m_curRole.m_controlerState.m_isStayForce = false;
                this.nextStep();
            }
            if (game.ui_arraw.getMe())
                game.ui_arraw.getMe().setArrawPos();
        };
        RoundManager.prototype.shutdown = function () {
            this.m_isOver = true;
            this.m_curRoleIndex = 0;
            this.m_maxRoleIndex = 0;
        };
        return RoundManager;
    }());
    game.RoundManager = RoundManager;
})(game || (game = {}));
//# sourceMappingURL=RoundManager.js.map