module game {
    export class RoundManager {
        public static g_instance: RoundManager;

        public static getMe(): RoundManager {
            // console.log("sceneMgr.getMe().m_curScene:" + sceneMgr.getMe().m_curScene)
            if (sceneMgr.getMe().m_curScene instanceof fightAiscene) {
                if (!RoundManager_ai.g_instance) {
                    RoundManager_ai.g_instance = new RoundManager_ai();
                }
                return RoundManager_ai.g_instance;
            }
            if (sceneMgr.getMe().m_curScene instanceof PVP_fight) {
                if (!RoundManager_pvp.g_instance) {
                    RoundManager_pvp.g_instance = new RoundManager_pvp();
                }
                return RoundManager_pvp.g_instance;
            }
            if (!RoundManager.g_instance) {
                RoundManager.g_instance = new RoundManager();
            }
            return RoundManager.g_instance;
        }

        m_timer: number; // 回合倒计时
        m_round: number = 0;
        m_curRoleIndex: number = 0;
        m_maxRoleIndex: number = 0;
        m_isOver: boolean = false;
        m_canHideTimer: boolean = false;

        init() {
            this.m_isOver = false;
            this.m_round = 0;
            this.m_curRoleIndex = 0;
            this.m_maxRoleIndex = 0;
            this.m_canHideTimer = false;
            this.m_timer = 30;
        }

        start() {
            // let a = setInterval(() => {
            this.m_curRoleIndex = 0;
            this.updateControlRole();
            // clearInterval(a);
            // }, 1000);
        }

        nextRound() {
            this.m_round++;
            this.m_curRoleIndex = 0;
        }

        nextStep() {
            if (this.m_isOver) return;
            ui_selectWeapon.ShowOrHide(false);
            RoundManager.gameEnd();
            if (shengliOrshibai.getMe()) return;
            if (ui_win.getMe() || ui_lose.getMe()) return;
            this.m_curRoleIndex++;
            if (this.m_curRoleIndex >= this.m_maxRoleIndex) {
                this.nextRound();
            }
            this.updateControlRole();
            // cc.log("aaaaaaaaaaaaaaaaaa",this.m_curRoleIndex);
            // cc.log("player dead :",roleMgr.getMe().m_deadNum_player);
            // cc.log("monster dead :",roleMgr.getMe().m_deadNum_monster);
        }

        static gameEndEx() {
            if (sceneMgr.getMe().m_curScene instanceof fightAiscene) {
                RoundManager_ai.gameEnd();
            }
            if (sceneMgr.getMe().m_curScene instanceof PVP_fight) {
                RoundManager_pvp.gameEnd();
            }
            if (sceneMgr.getMe().m_curScene instanceof fightscene) {
                RoundManager.gameEnd();
            }
        }

        static gameEnd() {
            if (RoundManager.getMe().m_isOver) return;
            if (dataMgr.getMe().isUnlockYindao("f5") && !dataMgr.getMe().isUnlockYindao("z1")) {
                if (roleMgr.getMe().isMonsterAllDead()) {
                    shengliOrshibai.ShowOrHide(true, true);
                } else if (roleMgr.getMe().isPlayerAllDead()) {
                    shengliOrshibai.ShowOrHide(true, false);
                }
            }
            else {
                if (roleMgr.getMe().isMonsterAllDead()) {
                    cc.log("胜利");
                    RoundManager.getMe().m_isOver = true;
                    if (sceneMgr.getMe().getCurSceneType() == e_SceneType.SceneType_fight) {
                        ui_win.ShowOrHide(true, sceneMgr.getMe().getCurSceneInfo());
                    }
                } else if (roleMgr.getMe().isPlayerAllDead()) {
                    cc.log("失败");
                    RoundManager.getMe().m_isOver = true;
                    let price = Version_mgr.getInstance().getDiamondPriceBystr("fuhuoCost");
                    if (RoundManager.getMe().m_buyonce) {//购买失败之后无法购买
                        // ui_lose.ShowOrHide(true, sceneMgr.getMe().getCurSceneInfo());
                        return;
                    }
                    ui_fuhuo.ShowOrHide(true, "是否花费" + price + "钻石复活角色?",
                        () => {
                            RoundManager.getMe().m_buyonce = true;
                            buy_mgr.getInstance().buyFuhuo_buy(RoundManager.getMe().fuhuoSucceedCallBack, this, price, () => {
                                rootScene.getMe().zanting(false);
                                if (!dataMgr.getMe().isUnlockYindao("s1")) {
                                    ui_yindao_shibai1.ShowOrHide(true);
                                }
                                ui_lose.ShowOrHide(true, sceneMgr.getMe().getCurSceneInfo());
                            });
                        }, () => {
                            rootScene.getMe().zanting(false);
                            RoundManager.getMe().m_buyonce = true;
                            if (!dataMgr.getMe().isUnlockYindao("s1")) {
                                ui_yindao_shibai1.ShowOrHide(true);
                            }
                            ui_lose.ShowOrHide(true, sceneMgr.getMe().getCurSceneInfo());
                        });

                    // ui_messageBox2.ShowOrHide(true,"是否花费" +  RoundManager.getMe().m_fuhuocost + "钻石复活角色?", ()=>{
                    //     rootScene.getMe().zanting(true);
                    //     RoundManager.getMe().m_isOver = true;
                    //     // buy_mgr.getInstance().shoppingByDiamond( RoundManager.getMe().m_fuhuocost,"复活角色",
                    //     //     RoundManager.getMe().fuhuoSucceedCallBack,RoundManager.getMe().fuhuoFailedCallBack)
                    // },RoundManager.getMe().fuhuoFailedCallBack);
                }
            }
        }

        //复活成功的回调
        fuhuoSucceedCallBack() {
            rootScene.getMe().zanting(false);
            RoundManager.getMe().m_isOver = false;
            RoundManager.getMe().m_buyonce = false;
            for (let p = 0; p < roleMgr.getMe().m_player_map.size; p++) {
                let player: player = roleMgr.getMe().m_player_map.getByIndex(p);
                player.fuhuo();
                RoundManager.getMe().start();
            }
        }

        updateControlRole() {
            if (this.m_isOver) return;
            if (roleMgr.getMe() == null) {
                return;
            }
            this.m_timer = 90;
            this.m_canHideTimer = false;
            playControl.getMe().setDefault();
            let role = roleMgr.getMe().m_AllRole_map.get(this.m_curRoleIndex);
            if (ui_zhandoujiemian.getMe()) {
                ui_zhandoujiemian.getMe().setuitexiao(role.m_name, role);
                ui_zhandoujiemian.getMe().setHP(role.getHp(), role.getMaxHp())
            }
            // if (role.m_debuffCount > 0) {
            //     role.m_debuffCount--;
            //     // role.onDamage()
            //     if (role.m_buffName) {
            //         let data = g_buff_config[role.m_buffName];
            //         role.onDamage_ex(data.shoujiSpine, data.shoujiAnimation, data.shoujiScale, data.damage);
            //     }
            // }
            if (role.isDead()) {
                this.nextStep();
                return;
            }
            role.setCurPower(role.getMaxPower());
            if (role instanceof player) {
                roleMgr.getMe().m_curRole = role;
                // roleMgr.getMe().m_curRole.m_controlerState.m_isStayForce = false;
                // if( !roleMgr.getMe().m_curRole.m_controlerState.m_isStayForce){
                //     console.log("zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz")
                // }
                role.changeState_Ex(g_AiType.g_AiType_idle);
                uiMgr.getMe().show_OnceAnimation("round.json", function () {
                    ui_selectWeapon.ShowOrHide(true);
                }.bind(this));

                // if (ui_arraw.getMe()) {
                //     ui_arraw.getMe().setArrawPos(cc.pAdd(role.getPosition(), role.m_arrawPos));
                // }
            }
            cameraMgr.getMe().reset(role.getPosition(), role);
            if (role instanceof monster) {
                // bulletMgr.getMe().initDeleteBulletNum(getWeaponConfig()[role.getName()]["0"].shootNum);
                role.m_controlerState.begin();
                this.m_timer = 10;
            }
            if (ui_arraw.getMe()) {
                ui_arraw.getMe().setRole(role);
            }
        }

        m_buyonce = false;
        loop(t) {
            if (this.m_isOver) return;
            if (rootScene.getMe().iszanting()) {
                return;
            }
            if (ui_win.getMe() || ui_lose.getMe()) {
                return;
            }
            this.m_timer -= t;
            if (!this.m_canHideTimer) {
                if (ui_zhandoujiemian.getMe()) {
                    ui_zhandoujiemian.getMe().roundCountdown(this.m_timer);
                }
            }
            if (this.m_timer > 0) {
                if (ui_zhandoujiemian.getMe()) {
                    if (roleMgr.getMe() == null) {
                        return;
                    }
                    if (roleMgr.getMe().getControlPlayer() == null) {
                        return;
                    }
                    let role = roleMgr.getMe().m_AllRole_map.get(this.m_curRoleIndex);
                    if (role.m_name != roleMgr.getMe().getControlPlayer().m_name) {
                        return;
                    }
                    ui_zhandoujiemian.getMe().setHP(role.getHp(), role.getMaxHp());
                }
            }
            if (this.m_timer <= 0) {
                roleMgr.getMe().m_curRole.m_controlerState.m_isStayForce = false;
                this.nextStep();
            }
            if (ui_arraw.getMe())
                ui_arraw.getMe().setArrawPos();
        }

        shutdown() {
            this.m_isOver = true;
            this.m_curRoleIndex = 0;
            this.m_maxRoleIndex = 0;
        }
    }
}