"use strict";
/**
 * Created by xieli on 2016/4/24.
 */
module game {
    export class aiBase {
        public m_stateType: string;
        m_object_role: baseRole;
        m_endTime_tiqian: number = 0.15;
        m_dir: cc.Vec2 = cc.p(0, 0);

        constructor(role: baseRole) {
            this.m_object_role = role;
        }

        onFrameEvent(type, event) {
            if (type == "Start") {
            }
            else if (type == "End") {
                this.Complete();
            }
            else if (type == "event") {
                this.Event(event);
            }
            return true;
        }

        /**
         * @return {boolean}
         */
        ExternalEvent(key?, data?): boolean {
            return true;
        }

        /**
         * @return {boolean}
         */
        InternalEvent(key?, data?) {
            return true;
        }

        update(t) {
            if (this.m_endTime_tiqian > 0) {
                let curtime = this.m_object_role.m_SpineNode.getAnimationSurplusTime();
                if (curtime < this.m_endTime_tiqian) {
                    this.Complete();
                }
            }
            return true;
        }

        /**
         * @return {boolean}
         */
        Complete() {
            return true;
        }

        /**
         * @return {boolean}
         */
        Event(event) {
            let name = event.data.name;
            cc.log(name);
            // if (rootScene.getMe().isLowCpu_10fps()) {
            //     return;
            // }
            // if (rootScene.getMe().isLowCpu()) {
            //     let randnum = random0To1();
            //     if (randnum > 0.5) {
            //         return;
            //     }
            // }
            if (name.indexOf("texiao") > -1) {
                this.onTexiao(name);
                return true;
            }
            //发射子弹
            if (name.indexOf("fashe") > -1) {
                this.OnFireBullet();
                return true;
            }
            //伤害处理
            if (name.indexOf("shanghai") > -1) {
                this.OnDamage();
                return true;
            }
            return true;
        }

        onTexiao(name: string) {
            let ss = name.split("_");
            spineMgr.getMe().createSpineOncePlay(ss[1], ss[2], this.m_object_role.getNode(), this.m_object_role.getBoneRelationPosition(ss[0]));
        }

        OnFireBullet() {
        }

        OnDamage() {

        }
    }

    export class aiBase_run extends aiBase {
        constructor(role) {
            super(role);
            this.m_stateType = g_AiType.g_AiType_run;
        }

        m_isJump: boolean = false;
        m_oldPos: cc.Vec2;
        m_validPos: cc.Vec2 = cc.p(0, 0);
        m_height: number = sceneMgr.getMe().getCurScene().m_tileMap.getTileSize().height;

        InternalEvent(key, data) {
            this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.m_SpineNode.setToSetupPose();
            this.m_object_role.playAnimation("yidong", true);

            if (data && data.x) {
                this.m_dir = cc.pNormalize(data);
            }
            this.m_object_role.setDir(this.m_dir.x);
            return true;
        }

        ExternalEvent(key, data) {
            this.m_object_role.startResetPosition();
            return true;
        }

        update(t: number) {
            if (this.m_object_role.getCurPower() <= 0) {
                return true;
            }
            if (this.m_isJump) return true;
            this.m_oldPos = this.m_object_role.getPosition();
            let newpos = cc.pAdd(this.m_oldPos, cc.pMult(this.m_dir, this.m_object_role.getSpeed() * t));
            if (newpos.x < 0 || newpos.x > 2000 || newpos.y < 0 || newpos.y > 1200) {
                return true;
            }
            this.m_validPos.y = newpos.y;
            if (this.m_object_role.getDir() > 0) {
                this.m_validPos.x = newpos.x + this.m_object_role.m_jumpData.s;
            } else {
                this.m_validPos.x = newpos.x - this.m_object_role.m_jumpData.s;
            }
            if (sceneMgr.getMe().getCurScene().m_tileMap.canMove(this.m_validPos)) {
                if (this.m_object_role.m_height == 2) {
                    if (!sceneMgr.getMe().getCurScene().m_tileMap.canMove(cc.pAdd(this.m_validPos, cc.p(0, this.m_height * 2 - 10))))
                        return true;
                }
                else if (this.m_object_role.m_height == 3) {
                    if (!sceneMgr.getMe().getCurScene().m_tileMap.canMove(cc.pAdd(this.m_validPos, cc.p(0, this.m_height * 3 - 10))))
                        return true;
                }
                this.move(newpos);
            } else {
                if (sceneMgr.getMe().getCurScene().m_tileMap.canMove(cc.pAdd(this.m_validPos, cc.p(0, this.m_height)))) {
                    this.jump();
                }
            }
            return true;
        }

        jump() {
            this.m_isJump = true;
            // this.m_object_role.playAnimation("tiaoyue", false);
            let p = cc.p(0, 0);
            let w = this.m_object_role.m_jumpData.x;
            if (this.m_object_role.getDir() > 0) {
                p.x += w;
            } else {
                p.x -= w;
            }
            p.y += this.m_object_role.m_jumpData.y * g_other_config.jump_height_per;
            let act = cc.jumpBy(g_other_config.jump_time, p, this.m_object_role.m_jumpData.y, 1);
            let seq = cc.sequence(act, cc.callFunc(function () {
                // this.m_object_role.playAnimation("yidong", true);
                this.m_isJump = false;
            }.bind(this), this, null));
            this.m_object_role.runAction(seq);

            this.m_object_role.setCurPower(this.m_object_role.getCurPower() - 50);
        }

        move(newpos: cc.Vec2) {
            this.m_object_role.setPosition(newpos);
            if(!this.m_isJump)
                this.m_object_role.setCurPower(this.m_object_role.getCurPower() - Math.abs(newpos.x - this.m_oldPos.x));
        }
    }
}