var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var baseRole = (function (_super) {
        __extends(baseRole, _super);
        function baseRole() {
            _super.apply(this, arguments);
            this.m_canDelete = false;
            this.m_once_rect = true;
            this.m_timer = 0;
            this.m_maxGForce = game.g_other_config.max_gravity_speed;
            this.canExit = true;
        }
        baseRole.prototype.initProperty = function (config) {
            this.isPvp = game.sceneMgr.getMe().getCurScene() instanceof game.PVP_fight;
            this.m_speed = config.runSpeed;
            this.m_height = config.height;
            this.m_jumpData = config.jump;
            this.setHp(this.getMaxHp());
            // this.m_debuffCount = 0;
            // this.m_buffName = "";
            this.create_baseRole_js();
        };
        // chipmunk_body;
        baseRole.prototype.create_baseRole_js = function () {
            if (cc.sys.isNative) {
                if (this.m_baseRole_js)
                    return;
                this.m_baseRole_js = new cc.baseRole_jsb();
                this.m_baseRole_js.retain();
                this.m_baseRole_js.initEx(this.getNode(), this.m_SpineNode.getNode());
            }
        };
        baseRole.prototype.createBloodBar = function (pos, bloodScale) {
        };
        baseRole.prototype.shutdown = function () {
            if (this.m_baseRole_js) {
                this.m_baseRole_js.release();
                this.m_baseRole_js = null;
            }
            // if (this.m_spineLineControl) {
            //     this.m_spineLineControl.shutdown();
            //     this.m_spineLineControl = null;
            // }
            if (this.m_bloodBar) {
                this.m_hpper = null;
                this.removeChild(this.m_bloodBar);
                this.m_bloodBar = null;
            }
            this.m_controlerState.shutdown();
            this.m_stateControl.shutdown();
            if (this.m_SpineNode) {
                this.removeChild(this.m_SpineNode.getNode());
                this.m_SpineNode = null;
            }
        };
        // 设置骨骼动画速率
        baseRole.prototype.setTimeScale = function (per) {
            try {
                this.m_SpineNode.setTimeScale(per);
            }
            catch (e) {
                console.log(e.stack);
            }
        };
        baseRole.prototype.getCurPower = function () {
            return 0;
        };
        baseRole.prototype.setCurPower = function (power) {
        };
        baseRole.prototype.getMaxPower = function () {
            return 0;
        };
        baseRole.prototype.getTimeScale = function () {
            return this.m_SpineNode.getTimeScale();
        };
        // setScale(s: number) {
        //     super.setScale(s);
        // }
        //
        // getScale() {
        //     return super.getScale();
        // }
        baseRole.prototype.getBoneRelationPosition = function (bonename) {
            var pspBone = this.m_SpineNode.getBoneWorldPos_Root(bonename);
            if (pspBone) {
                return cc.p(pspBone.x * this.getScale() * this.m_SpineNode.getScaleX(), pspBone.y * this.getScale());
            }
            else {
                // uiMgr.getMe().show_ui_MessageBox(true, "error SkeletonAnimation_Ex::getBoneWorldPos   " + this.m_name + "没有这个骨骼 ：" + bonename);
                return null;
            }
        };
        baseRole.prototype.getBoneWroldPosition = function (bonename) {
            var pspBone = this.m_SpineNode.getBoneWorldPos_Root(bonename);
            if (pspBone) {
                var buff = cc.p(pspBone.x * this.getScale() * this.m_SpineNode.getScaleX(), pspBone.y * this.getScale());
                var buff1 = this.getPosition();
                return cc.pAdd(buff, buff1);
            }
            else {
                // uiMgr.getMe().show_ui_MessageBox(true, "error SkeletonAnimation_Ex::getBoneWorldPos   " + this.m_name + "没有这个骨骼 ：" + bonename);
                return null;
            }
        };
        baseRole.prototype.zanting = function (flag) {
            if (flag) {
                if (this.m_SpineNode) {
                    this.m_SpineNode.pause();
                }
            }
            else {
                if (this.m_SpineNode) {
                    this.m_SpineNode.resume();
                }
            }
            // if (this.m_spineLineControl) {
            //     this.m_spineLineControl.zanting(flag);
            // }
        };
        baseRole.prototype.loadres = function (res) {
            this.m_SpineNode = game.spineMgr.getMe().loadSpine(res, this.getNode(), 4);
            this.playAnimation("daiji");
            this.m_SpineNode.setStartListener(function () {
                this.onFrameEvent("Start");
            }.bind(this));
            this.m_SpineNode.setEndListener(function () {
                this.onFrameEvent("End");
            }.bind(this));
            this.m_SpineNode.setCompleteListener(function () {
                this.onFrameEvent("Complete");
            }.bind(this));
            this.m_SpineNode.setEventListener(function (traceIndex, event) {
                this.onFrameEvent("event", event);
            }.bind(this));
            if (game.rootScene.getMe().iszanting() == true) {
                this.zanting(true);
            }
            // this.chipmunk_body = ChipmunkMgr.getMe().createBody(this,100);
            // this.m_SpineNode.setDebugSlotsEnabled(true);
            return true;
        };
        baseRole.prototype.onFrameEvent = function (type, event) {
            if (type == "event") {
                if (event.data.name.indexOf(".mp3") >= 0) {
                    game.musicMgr.getMe().playeffect(event.data.name);
                }
            }
            this.m_stateControl.onFrameEvent(type, event);
        };
        baseRole.prototype.getState = function (type) {
            return this.m_stateControl.getState(type);
        };
        baseRole.prototype.getCurStateType = function () {
            return this.m_stateControl.getCurStateType(); //  this.m_cur_RoleAiState.m_stateType;
        };
        //强制切换状态
        baseRole.prototype.changeState_Ex = function (key, data) {
            if (this.getCurStateType() == game.g_AiType.g_AiType_dead) {
                return;
            }
            return this.m_stateControl.changeState_Ex(key, data);
        };
        baseRole.prototype.changeState = function (key, data) {
            return this.m_stateControl.changeState(key, data);
        };
        baseRole.prototype.update = function (dt) {
            if (this.m_stateControl) {
                this.m_stateControl.loop(dt);
            }
            if (this.m_controlerState) {
                this.m_controlerState.loop(dt);
            }
            this.moveGForce(dt);
            if (this.m_once_rect) {
                if (this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang").width > 0) {
                    this.m_once_rect = false;
                    this.m_rect = this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang");
                    this.m_rect.width *= this.m_scale;
                    this.m_rect.height *= this.m_scale;
                }
            }
        };
        // drawRect(){
        //     if(this.m_rect){
        //         this.m_drawNode = new cc.DrawNode();
        //         this.addChild(this.m_drawNode, 10);
        //         let pos = this.getBoneRelationPosition("shoujizudang");
        //         pos.x = pos.x - this.m_rect.width /2;
        //         this.m_drawNode.drawRect(cc.p(this.m_rect.width, this.m_rect.height),pos, null, 2, cc.color(255, 0, 255, 255));
        //     }
        // }
        baseRole.prototype.moveGForce = function (dt) {
            // this.m_pos = this.getPosition();
            // this.m_pos.y -= 5;
            // if(sceneMgr.getMe().getCurScene().m_tileMap.canMove(this.m_pos)){
            //     this.startForce();
            // }else{
            //     this.endForce();
            // }
            // if(this.m_beForce){
            this.m_timer += dt;
            this.m_pos = this.getPosition();
            this.m_curGForce = this.m_timer * game.g_other_config.speed_up;
            if (this.m_curGForce > this.m_maxGForce) {
                this.m_curGForce = this.m_maxGForce;
            }
            this.m_pos.y -= this.m_curGForce;
            if (game.sceneMgr.getMe().getCurScene().m_tileMap.canMove(this.m_pos)) {
                this.setPosition(this.m_pos);
            }
            else {
                this.m_timer = 0;
            }
            // }
        };
        baseRole.prototype.playAnimation = function (name, loop, mix, mintime, b_setToSetupPose) {
            if (loop === void 0) { loop = null; }
            if (mix === void 0) { mix = null; }
            if (mintime === void 0) { mintime = null; }
            if (b_setToSetupPose === void 0) { b_setToSetupPose = null; }
            if (name == null) {
                console.log("playAnimation 不能为空！" + name);
                return;
            }
            if (loop == null) {
                loop = true;
            }
            if (mix == null) {
                mix = false;
                mintime = 0;
            }
            if (b_setToSetupPose == null) {
                b_setToSetupPose = true;
            }
            var data = game.g_AnimationMix[name];
            if (data != null) {
                var curAnimationMixName = data[this.m_curAnimation];
                if (curAnimationMixName != null) {
                    this.m_SpineNode.setMix(this.m_curAnimation, name, curAnimationMixName["mixtime"]);
                    this.m_SpineNode.setMix(name, this.m_curAnimation, curAnimationMixName["mixtime"]);
                }
                if (data["isReset"] != null) {
                    b_setToSetupPose = data["isReset"];
                }
            }
            // if (mix) {
            //     this.m_SpineNode.setMix(this.m_curAnimation, name, mintime);
            //     this.m_SpineNode.setMix(name, this.m_curAnimation, mintime);
            // }
            this.m_curAnimation = name;
            if (b_setToSetupPose) {
                this.m_SpineNode.setToSetupPose();
            }
            this.m_SpineNode.setAnimation(0, name, loop);
        };
        // setPosition( in_xjPoint: any ) {
        //     // if(this.chipmunk_body){
        //     //     this.chipmunk_body.setPos(in_xjPoint);
        //     // }
        //     if(this.m_pos && sceneMgr.getMe().getCurScene().m_tileMap.canMove(this.m_pos)){
        //         super.setPosition(in_xjPoint);
        //     }
        // }
        baseRole.prototype.setPositionEx = function (position) {
            // let walkRect = cc.rectIntersection(cameraMgr.getMe().getRect(), cc.rect(game.g_walkRect.x + 100, g_walkRect.y, g_walkRect.width - 100, g_walkRect.height));
            // if (!cc.rectContainsPoint(walkRect, position)) {
            //     //console.log("坐标不在摄像机可移动范围内..")
            //     return false
            // }
            this.setPosition(position);
            return true;
        };
        //控制骨骼移动
        // 设置是否停止移动跟root 骨骼  0 停止移动 1 : 移动
        baseRole.prototype.startResetPosition = function () {
            if (this.m_SpineNode == null) {
                return;
            }
            // if (cc.sys.isNative) {
            //     this.m_baseRole_js.startResetPosition();
            // }
            this.m_SpineNode.startPlayAnimation();
            this.m_SpineNode.m_StartPos_anmimation = this.getPosition();
            this.m_firstresetPosition = true;
        };
        baseRole.prototype.stopMoveRootBone = function (flag) {
            if (cc.sys.isNative) {
                if (!this.m_SpineNode) {
                    return;
                }
                this.m_SpineNode.SetBoneData("root", flag);
            }
            else {
                if (!this.m_SpineNode) {
                    return;
                }
                var pspBone = this.m_SpineNode.findBone("root");
                if (!pspBone) {
                    return;
                }
                pspBone.isMoveX = flag;
            }
        };
        //朝向 dir:1 左边  dir:0 右边
        baseRole.prototype.setRoleDir = function (dir) {
            this.m_roledir = dir;
            var nowScale = this.m_SpineNode.getScale();
            if (nowScale < 0) {
                nowScale = -nowScale;
            }
            this.m_SpineNode.setScaleX(-nowScale * dir);
        };
        //控制角色方向
        baseRole.prototype.setDir = function (dir) {
            if (dir > 0) {
                this.setRoleDir(1);
            }
            else if (dir < 0) {
                this.setRoleDir(-1);
            }
        };
        baseRole.prototype.getDir = function () {
            return this.m_roledir;
        };
        baseRole.prototype.isDead = function () {
            return this.m_curHp == 0;
        };
        baseRole.prototype.getHp = function () {
            return this.m_curHp;
        };
        baseRole.prototype.setHp = function (hp) {
            this.m_curHp = hp;
            if (this.m_hpper) {
                this.m_hpper.setPercent(this.m_curHp / this.getMaxHp() * 100);
            }
        };
        baseRole.prototype.addHp = function (hp) {
            var curHp = this.getHp();
            curHp += hp;
            if (curHp > this.getMaxHp()) {
                curHp = this.getMaxHp();
            }
            if (this.isPvp) {
                if (game.proto_fightPVP.getMe().m_isP1) {
                    game.sync_addHp.getMe().send(this.m_index, hp, curHp);
                    this.setHp(curHp);
                    game.uieffectMgr.getMe().createLayout_playaddhp(game.roleMgr.getMe().getNode(), hp, this.getHeadHpNumberPos());
                }
                return;
            }
            this.setHp(curHp);
            game.uieffectMgr.getMe().createLayout_playaddhp(game.roleMgr.getMe().getNode(), hp, this.getHeadHpNumberPos());
        };
        baseRole.prototype.addHpEx = function (addHp, curHp) {
            this.setHp(curHp);
            game.uieffectMgr.getMe().createLayout_playaddhp(game.roleMgr.getMe().getNode(), addHp, this.getHeadHpNumberPos());
        };
        baseRole.prototype.getMaxHp = function () {
            return this.m_maxHp;
        };
        baseRole.prototype.getName = function () {
            return this.m_name;
        };
        baseRole.prototype.getAtt = function () {
            return this.m_att;
        };
        baseRole.prototype.getSpeed = function () {
            return this.m_speed;
        };
        baseRole.prototype.getCritRate = function () {
            return 0.05;
        };
        baseRole.getTargetRect = function (role) {
            var rect = role.m_SpineNode.getBoundingBoxBySlotName("shoujizudang");
            var root = role.getPosition();
            rect.x = root.x + (rect.x - root.x) * role.m_scale;
            rect.y = root.y + (rect.y - root.y) * role.m_scale;
            rect.width *= role.m_scale;
            rect.height *= role.m_scale;
            return rect;
        };
        baseRole.prototype.dealPhy = function (pos) {
            var rect = this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang");
            var root = this.getPosition();
            rect.x = root.x + (rect.x - root.x) * this.m_scale;
            rect.y = root.y + (rect.y - root.y) * this.m_scale;
            rect.width *= this.m_scale;
            rect.height *= this.m_scale;
            // rect.x *= this.getPositionX();
            // rect.y *= this.getPositionY() + rect.height / 2;
            // cc.log("rect width",this.m_rect.width);
            // cc.log("rect height",this.m_rect.height);
            // cc.log("rect x",this.m_rect.x);
            // cc.log("rect y",this.m_rect.y);
            //
            // cc.log("pos x",pos.x);
            // cc.log("pos y",pos.y);
            return cc.rectContainsPoint(rect, pos);
        };
        baseRole.prototype.getshoujizudang = function () {
            var rect = this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang");
            var root = this.getPosition();
            rect.x = root.x + (rect.x - root.x) * this.m_scale;
            rect.y = root.y + (rect.y - root.y) * this.m_scale;
            rect.width *= this.m_scale;
            rect.height *= this.m_scale;
            return rect;
        };
        baseRole.prototype.getHeadHpNumberPos = function () {
            return cc.pAdd(this.getPosition(), this.m_headHpNumberPos);
        };
        baseRole.prototype.onDamage = function (shoujires, shoujianima, shoujiscale, roleId, isBoom) {
            var ret = game.spineMgr.getMe().createSpineOncePlay(shoujires, shoujianima, this.getNode(), this.getBoneRelationPosition("shoujizudang"), 9999999);
            ret.setScale(shoujiscale);
        };
        baseRole.prototype.onDamage_ex = function (shoujires, shoujianima, shoujiscale, att) {
            this.onDamage(shoujires, shoujianima, shoujiscale);
            var hp = this.getHp();
            hp -= att;
            if (hp < 0) {
                hp = 0;
                if (this.m_stateControl.getCurStateType() != game.g_AiType.g_AiType_dead)
                    this.changeState_Ex(game.g_AiType.g_AiType_dead);
            }
            else {
                if (this.m_stateControl.getCurStateType() != game.g_AiType.g_AiType_hit)
                    this.changeState_Ex(game.g_AiType.g_AiType_hit);
            }
            this.setHp(hp);
            game.uieffectMgr.getMe().createLayout_playdrophp(game.roleMgr.getMe().getNode(), att, this.getHeadHpNumberPos());
        };
        baseRole.prototype.nextRound = function (isMonster) {
            var _this = this;
            this.canExit = false;
            cc.log("进入下一回合 1111111111111111111");
            var time = 3000;
            if (isMonster) {
                time = game.g_other_config.nextTime.monster;
            }
            else {
                time = game.g_other_config.nextTime.player;
            }
            var a = setInterval(function () {
                cc.log("进入下一回合 222222222222222222");
                if (game.roleMgr.getMe()) {
                    if (game.roleMgr.getMe().m_hasDead) {
                        game.roleMgr.getMe().m_hasDead = false;
                        _this.round2(game.g_other_config.nextTime.dead);
                    }
                    else {
                        _this.round1();
                    }
                }
                clearInterval(a);
            }, time);
        };
        baseRole.prototype.round1 = function () {
            this.canExit = true;
            if (game.roleMgr.getMe()) {
                if (game.RoundManager.getMe().m_curRoleIndex == this.m_index) {
                    cc.log("进入下一回合 3333333333333333333");
                    game.RoundManager.getMe().nextStep();
                }
            }
        };
        baseRole.prototype.round2 = function (time) {
            var _this = this;
            var a = setInterval(function () {
                _this.round1();
                clearInterval(a);
            }, time);
        };
        return baseRole;
    }(game.xjNode));
    game.baseRole = baseRole;
})(game || (game = {}));
//# sourceMappingURL=baseRole.js.map 
//# sourceMappingURL=baseRole.js.map