module game {

    export class baseRole extends xjNode {
        m_SpineNode: SkeletonAnimation_Ex;
        // m_spineLineControl: spineLine;
        m_baseRole_js: cc.baseRole_jsb;
        m_firstresetPosition: boolean;
        m_stateControl: baseStateControl;
        m_controlerState: ControlerState;

        m_index:number;
        m_curAnimation: string;
        m_roledir: number;
        m_curHp: number;
        m_maxHp: number;
        m_name: string;
        m_speed: number;
        m_att: number;
        m_height: number;
        m_headHpNumberPos;
        m_arrawPos;
        m_scale:number;

        m_canDelete: boolean = false;
        m_bloodBar:cc.Node;
        m_hpper;

        m_jumpData;
        m_weaon;
        m_item;
        m_once_rect:boolean = true;
        m_rect:cc.Rect;
        // m_drawNode;
        m_animaEnd:boolean;
        // m_debuffCount:number;
        // m_buffName:string;

        isPvp:boolean;

        initProperty(config) {
            this.isPvp = sceneMgr.getMe().getCurScene() instanceof PVP_fight;

            this.m_speed = config.runSpeed;
            this.m_height = config.height;
            this.m_jumpData = config.jump;
            this.setHp(this.getMaxHp());
            // this.m_debuffCount = 0;
            // this.m_buffName = "";
            this.create_baseRole_js();
        }

        // chipmunk_body;
        create_baseRole_js() {
            if (cc.sys.isNative) {
                if (this.m_baseRole_js)
                    return;
                this.m_baseRole_js = new cc.baseRole_jsb();
                this.m_baseRole_js.retain();
                this.m_baseRole_js.initEx(this.getNode(), this.m_SpineNode.getNode());
            }
        }

        createBloodBar(pos, bloodScale): void {

        }

        shutdown() {
            if (this.m_baseRole_js) {
                this.m_baseRole_js.release();
                this.m_baseRole_js = null;
            }
            // if (this.m_spineLineControl) {
            //     this.m_spineLineControl.shutdown();
            //     this.m_spineLineControl = null;
            // }
            if(this.m_bloodBar){
                this.m_hpper = null;
                this.removeChild(this.m_bloodBar);
                this.m_bloodBar = null;
            }
            this.m_controlerState.shutdown();
            this.m_stateControl.shutdown();
            if (this.m_SpineNode) {
                this.removeChild(this.m_SpineNode.getNode());
                this.m_SpineNode = null;
            }
        }

        // 设置骨骼动画速率
        setTimeScale(per) {
            try {
                this.m_SpineNode.setTimeScale(per);
            }
            catch (e) {
                console.log(e.stack);
            }
        }

        getCurPower() {
            return 0;
        }

        setCurPower(power: number) {

        }

        getMaxPower() {
            return 0;
        }

        getTimeScale() {
            return this.m_SpineNode.getTimeScale();
        }

        // setScale(s: number) {
        //     super.setScale(s);
        // }
        //
        // getScale() {
        //     return super.getScale();
        // }

        getBoneRelationPosition(bonename) {
            let pspBone = this.m_SpineNode.getBoneWorldPos_Root(bonename);
            if (pspBone) {
                return cc.p(pspBone.x * this.getScale() * this.m_SpineNode.getScaleX(), pspBone.y * this.getScale());
            }
            else {
                // uiMgr.getMe().show_ui_MessageBox(true, "error SkeletonAnimation_Ex::getBoneWorldPos   " + this.m_name + "没有这个骨骼 ：" + bonename);
                return null;
            }
        }

        getBoneWroldPosition(bonename) {
            let pspBone = this.m_SpineNode.getBoneWorldPos_Root(bonename);
            if (pspBone) {
                let buff = cc.p(pspBone.x * this.getScale() * this.m_SpineNode.getScaleX(), pspBone.y * this.getScale());
                let buff1 = this.getPosition();
                return cc.pAdd(buff, buff1);
            }
            else {
                // uiMgr.getMe().show_ui_MessageBox(true, "error SkeletonAnimation_Ex::getBoneWorldPos   " + this.m_name + "没有这个骨骼 ：" + bonename);
                return null;
            }
        }

        zanting(flag) {
            if (flag) {
                if (this.m_SpineNode) {
                    this.m_SpineNode.pause();
                }
            }
            else {
                if (this.m_SpineNode) {
                    this.m_SpineNode.resume();
                }
            }
            // if (this.m_spineLineControl) {
            //     this.m_spineLineControl.zanting(flag);
            // }
        }

        loadres(res): any {
            this.m_SpineNode = spineMgr.getMe().loadSpine(res, this.getNode(), 4);
            this.playAnimation("daiji");
            this.m_SpineNode.setStartListener(function () {
                this.onFrameEvent("Start");
            }.bind(this));
            this.m_SpineNode.setEndListener(function () {
                this.onFrameEvent("End");
            }.bind(this));
            this.m_SpineNode.setCompleteListener(function () {
                this.onFrameEvent("Complete");
            }.bind(this));
            this.m_SpineNode.setEventListener(function (traceIndex, event) {
                this.onFrameEvent("event", event);
            }.bind(this));
            if (rootScene.getMe().iszanting() == true) {
                this.zanting(true);
            }

            // this.chipmunk_body = ChipmunkMgr.getMe().createBody(this,100);
            // this.m_SpineNode.setDebugSlotsEnabled(true);
            return true;
        }

        onFrameEvent(type, event) {
            if (type == "event") {
                if (event.data.name.indexOf(".mp3") >= 0) {
                    musicMgr.getMe().playeffect(event.data.name);
                }
            }
            this.m_stateControl.onFrameEvent(type, event);
        }

        getState(type) {
            return this.m_stateControl.getState(type);
        }

        getCurStateType() {
            return this.m_stateControl.getCurStateType(); //  this.m_cur_RoleAiState.m_stateType;
        }

        //强制切换状态
        changeState_Ex(key, data?)
        {
            if( this.getCurStateType() == g_AiType.g_AiType_dead )
            {
                return;
            }
            return this.m_stateControl.changeState_Ex(key, data);
        }

        changeState(key, data?) {
            return this.m_stateControl.changeState(key, data);
        }

        m_timer: number = 0;
        m_pos: cc.Vec2;
        m_curGForce: number;
        m_maxGForce: number = g_other_config.max_gravity_speed;

        update(dt) {
            if (this.m_stateControl) {
                this.m_stateControl.loop(dt);
            }
            if (this.m_controlerState) {
                this.m_controlerState.loop(dt);
            }
            this.moveGForce(dt);

            if(this.m_once_rect){
                if(this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang").width > 0){
                    this.m_once_rect = false;
                    this.m_rect = this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang");
                    this.m_rect.width *= this.m_scale;
                    this.m_rect.height *= this.m_scale;
                    // cc.log(this.getName() + ": rect width",this.m_rect.width);
                    // cc.log(this.getName() + ": rect height",this.m_rect.height);
                    // cc.log(this.getName() + ": rect x",this.m_rect.x);
                    // cc.log(this.getName() + ": rect y",this.m_rect.y);
                    //
                    // let pos = this.getPosition();
                    // cc.log(this.getName() + ": pos x",pos.x);
                    // cc.log(this.getName() + ": pos y",pos.y);
                    // this.drawRect();
                }
            }
        }

        // drawRect(){
        //     if(this.m_rect){
        //         this.m_drawNode = new cc.DrawNode();
        //         this.addChild(this.m_drawNode, 10);
        //         let pos = this.getBoneRelationPosition("shoujizudang");
        //         pos.x = pos.x - this.m_rect.width /2;
        //         this.m_drawNode.drawRect(cc.p(this.m_rect.width, this.m_rect.height),pos, null, 2, cc.color(255, 0, 255, 255));
        //     }
        // }

        moveGForce(dt) {
            // this.m_pos = this.getPosition();
            // this.m_pos.y -= 5;
            // if(sceneMgr.getMe().getCurScene().m_tileMap.canMove(this.m_pos)){
            //     this.startForce();
            // }else{
            //     this.endForce();
            // }
            // if(this.m_beForce){
            this.m_timer += dt;
            this.m_pos = this.getPosition();
            this.m_curGForce = this.m_timer * g_other_config.speed_up;
            if (this.m_curGForce > this.m_maxGForce) {
                this.m_curGForce = this.m_maxGForce;
            }
            this.m_pos.y -= this.m_curGForce;
            if (sceneMgr.getMe().getCurScene().m_tileMap.canMove(this.m_pos)) {
                this.setPosition(this.m_pos);
            } else {
                this.m_timer = 0;
            }
            // }
        }

        playAnimation(name, loop: any = null, mix: any = null, mintime: any = null, b_setToSetupPose: any = null) {
            if (name == null) {
                console.log("playAnimation 不能为空！" + name);
                return;
            }
            if (loop == null) {
                loop = true;
            }
            if (mix == null) {
                mix = false;
                mintime = 0;
            }
            if (b_setToSetupPose == null) {
                b_setToSetupPose = true;
            }
            let data = g_AnimationMix[name];
            if (data != null) {
                let curAnimationMixName = data[this.m_curAnimation];
                if (curAnimationMixName != null) {
                    this.m_SpineNode.setMix(this.m_curAnimation, name, curAnimationMixName["mixtime"]);
                    this.m_SpineNode.setMix(name, this.m_curAnimation, curAnimationMixName["mixtime"]);
                }
                if (data["isReset"] != null) {
                    b_setToSetupPose = data["isReset"];
                }
            }
            // if (mix) {
            //     this.m_SpineNode.setMix(this.m_curAnimation, name, mintime);
            //     this.m_SpineNode.setMix(name, this.m_curAnimation, mintime);
            // }
            this.m_curAnimation = name;
            if (b_setToSetupPose) {
                this.m_SpineNode.setToSetupPose();
            }
            this.m_SpineNode.setAnimation(0, name, loop);
        }

        // setPosition( in_xjPoint: any ) {
        //     // if(this.chipmunk_body){
        //     //     this.chipmunk_body.setPos(in_xjPoint);
        //     // }
        //     if(this.m_pos && sceneMgr.getMe().getCurScene().m_tileMap.canMove(this.m_pos)){
        //         super.setPosition(in_xjPoint);
        //     }
        // }

        setPositionEx(position) {
            // let walkRect = cc.rectIntersection(cameraMgr.getMe().getRect(), cc.rect(game.g_walkRect.x + 100, g_walkRect.y, g_walkRect.width - 100, g_walkRect.height));
            // if (!cc.rectContainsPoint(walkRect, position)) {
            //     //console.log("坐标不在摄像机可移动范围内..")
            //     return false
            // }
            this.setPosition(position);
            return true;
        }

        //控制骨骼移动
        // 设置是否停止移动跟root 骨骼  0 停止移动 1 : 移动
        startResetPosition() {
            if (this.m_SpineNode == null) {
                return;
            }
            // if (cc.sys.isNative) {
            //     this.m_baseRole_js.startResetPosition();
            // }
            this.m_SpineNode.startPlayAnimation();
            this.m_SpineNode.m_StartPos_anmimation = this.getPosition();
            this.m_firstresetPosition = true;
        }

        stopMoveRootBone(flag) {
            if (cc.sys.isNative) {
                if (!this.m_SpineNode) {
                    return;
                }
                this.m_SpineNode.SetBoneData("root", flag);
            }
            else {
                if (!this.m_SpineNode) {
                    return;
                }
                let pspBone = this.m_SpineNode.findBone("root");
                if (!pspBone) {
                    return;
                }
                pspBone.isMoveX = flag;
            }
        }

        //朝向 dir:1 左边  dir:0 右边
        setRoleDir(dir) {
            this.m_roledir = dir;
            let nowScale = this.m_SpineNode.getScale();
            if (nowScale < 0) {
                nowScale = -nowScale;
            }
            this.m_SpineNode.setScaleX(-nowScale * dir);
        }

        //控制角色方向
        setDir(dir) {
            if (dir > 0) {
                this.setRoleDir(1);
            } else if (dir < 0) {
                this.setRoleDir(-1);
            }
        }

        getDir() {
            return this.m_roledir;
        }

        isDead(){
            return this.m_curHp == 0;
        }

        getHp(){
            return this.m_curHp;
        }

        setHp(hp: number) {
            this.m_curHp = hp;
            if (this.m_hpper) {
                this.m_hpper.setPercent(this.m_curHp / this.getMaxHp() * 100);
            }
        }

        addHp(hp:number){
            let curHp = this.getHp();
            curHp += hp;
            if(curHp > this.getMaxHp()){
                curHp = this.getMaxHp();
            }

            if(this.isPvp){
                if(proto_fightPVP.getMe().m_isP1){
                    sync_addHp.getMe().send(this.m_index, hp, curHp);
                    this.setHp(curHp);
                    uieffectMgr.getMe().createLayout_playaddhp(roleMgr.getMe().getNode(), hp, this.getHeadHpNumberPos());
                }
                return;
            }

            this.setHp(curHp);
            uieffectMgr.getMe().createLayout_playaddhp(roleMgr.getMe().getNode(), hp, this.getHeadHpNumberPos());
        }

        addHpEx(addHp:number,curHp:number){
            this.setHp(curHp);
            uieffectMgr.getMe().createLayout_playaddhp(roleMgr.getMe().getNode(), addHp, this.getHeadHpNumberPos());
        }

        getMaxHp() {
            return this.m_maxHp;
        }

        getName() {
            return this.m_name;
        }

        getAtt(): number {
            return this.m_att;
        }

        getSpeed(): number {
            return this.m_speed;
        }

        getCritRate() {
            return 0.05;
        }

        static getTargetRect(role){
            let rect = role.m_SpineNode.getBoundingBoxBySlotName("shoujizudang");
            let root = role.getPosition();
            rect.x = root.x + (rect.x - root.x) * role.m_scale;
            rect.y = root.y + (rect.y - root.y) * role.m_scale;
            rect.width *= role.m_scale;
            rect.height *= role.m_scale;
            return rect;
        }

        dealPhy(pos:cc.Vec2){
            let rect = this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang");
            let root = this.getPosition();
            rect.x = root.x + (rect.x - root.x) * this.m_scale;
            rect.y = root.y + (rect.y - root.y) * this.m_scale;
            rect.width *= this.m_scale;
            rect.height *= this.m_scale;
            // rect.x *= this.getPositionX();
            // rect.y *= this.getPositionY() + rect.height / 2;

            // cc.log("rect width",this.m_rect.width);
            // cc.log("rect height",this.m_rect.height);
            // cc.log("rect x",this.m_rect.x);
            // cc.log("rect y",this.m_rect.y);
            //
            // cc.log("pos x",pos.x);
            // cc.log("pos y",pos.y);
            return cc.rectContainsPoint(rect, pos);
        }

        getshoujizudang(){
            let rect = this.m_SpineNode.getBoundingBoxBySlotName("shoujizudang");
            let root = this.getPosition();
            rect.x = root.x + (rect.x - root.x) * this.m_scale;
            rect.y = root.y + (rect.y - root.y) * this.m_scale;
            rect.width *= this.m_scale;
            rect.height *= this.m_scale;
            return rect;
        }

        getHeadHpNumberPos() {
            return cc.pAdd(this.getPosition(), this.m_headHpNumberPos);
        }

        onDamage(shoujires:string,shoujianima:string,shoujiscale:number,roleId?:number, isBoom?:boolean){
            let ret = spineMgr.getMe().createSpineOncePlay(shoujires,shoujianima,this.getNode(),this.getBoneRelationPosition("shoujizudang"),9999999);
            ret.setScale(shoujiscale);
        }

        onDamage_ex(shoujires: string, shoujianima: string, shoujiscale: number,att:number) {
            this.onDamage(shoujires, shoujianima, shoujiscale);
            let hp = this.getHp();
            hp -= att;
            if (hp < 0) {
                hp = 0;
                if(this.m_stateControl.getCurStateType() != g_AiType.g_AiType_dead)
                    this.changeState_Ex(g_AiType.g_AiType_dead);
            } else {
                if(this.m_stateControl.getCurStateType() != g_AiType.g_AiType_hit)
                    this.changeState_Ex(g_AiType.g_AiType_hit);
            }
            this.setHp(hp);
            uieffectMgr.getMe().createLayout_playdrophp(roleMgr.getMe().getNode(), att, this.getHeadHpNumberPos());
        }

        canExit:boolean = true;

        nextRound(isMonster){
            this.canExit = false;
            cc.log("进入下一回合 1111111111111111111");
            let time = 3000;
            if(isMonster){
                time = g_other_config.nextTime.monster;
            }else{
                time = g_other_config.nextTime.player;
            }
            let a = setInterval(() => {
                cc.log("进入下一回合 222222222222222222");
                if(roleMgr.getMe()) {
                    if (roleMgr.getMe().m_hasDead) {
                        roleMgr.getMe().m_hasDead = false;
                        this.round2(g_other_config.nextTime.dead);
                    }else{
                        this.round1();
                    }
                }
                clearInterval(a);
            }, time);
        }

        round1(){
            this.canExit = true;
            if (roleMgr.getMe()) {
                if(RoundManager.getMe().m_curRoleIndex == this.m_index){
                    cc.log("进入下一回合 3333333333333333333");
                    RoundManager.getMe().nextStep();
                }
            }
        }

        round2(time){
            let a = setInterval(() => {
                this.round1();
                clearInterval(a);
            }, time);
        }
    }
}
//# sourceMappingURL=baseRole.js.map