var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/**
 * 角色状态
 * Created by cy1234 on 2016/7/30.
 */
var game;
(function (game) {
    var PlayControlerState = (function (_super) {
        __extends(PlayControlerState, _super);
        function PlayControlerState() {
            _super.apply(this, arguments);
            this.m_isStayForce = false;
            this.m_forcePer = 0; // 发射力大小百分比
            this.m_isswitch = false; //是否切换加减蓄力条
        }
        PlayControlerState.prototype.lockTarget = function () {
            var temp = 10000;
            var targetPos;
            var rolePos;
            var roleMap;
            if (game.sceneMgr.getMe().getCurScene() instanceof game.fightAiscene) {
                var rolemgr = game.roleMgr.getMe();
                roleMap = rolemgr.m_matcher_map;
            }
            else if (game.sceneMgr.getMe().getCurScene() instanceof game.PVP_fight) {
                var rolemgr = game.roleMgr.getMe();
                roleMap = rolemgr.m_matcher_map;
            }
            else {
                roleMap = game.roleMgr.getMe().m_monster_map;
            }
            for (var i = 0; i < roleMap.size; ++i) {
                var role = roleMap.getByIndex(i);
                if (role.isDead())
                    continue;
                targetPos = role.getPosition();
                rolePos = this.m_object_role.getPosition();
                if (this.m_object_role.getDir() > 0) {
                    if (targetPos.x < rolePos.x) {
                        continue;
                    }
                }
                else {
                    if (targetPos.x > rolePos.x) {
                        continue;
                    }
                }
                var dis = cc.pDistance(targetPos, rolePos);
                if (dis < temp) {
                    temp = dis;
                    this.m_target = role;
                }
            }
            return this.m_target == null;
        };
        PlayControlerState.prototype.up = function () {
            this.m_object_role.changeState(game.g_AiType.g_AiType_aim, 0.5);
        };
        PlayControlerState.prototype.down = function () {
            this.m_object_role.changeState(game.g_AiType.g_AiType_aim, -0.5);
        };
        PlayControlerState.prototype.attack = function () {
            if (this.m_object_role.isFire)
                return;
            this.m_object_role.isFire = true;
            this.m_isStayForce = false;
            this.m_object_role.changeState(game.g_AiType.g_AiType_att);
            if (game.ui_zhandoujiemian.getMe()) {
                game.ui_zhandoujiemian.getMe().setTishiTiao(this.m_forcePer);
                game.ui_zhandoujiemian.getMe().setXuliTiao(0);
            }
        };
        PlayControlerState.prototype.stayForce = function () {
            if (this.m_object_role.isFire)
                return;
            this.m_isStayForce = true;
            this.m_forcePer = 0;
        };
        PlayControlerState.prototype.drawLine = function () {
            // cc.log("如果是VIP则画线");
            if (this.m_object_role.m_weaon.isNotDraw())
                return;
            if (game.dataMgr.getMe().getViplevel() < 3)
                return;
            if (this.lockTarget()) {
                this.m_object_role.hideDots();
                cc.log("没有目标");
                return;
            }
            var dir = cc.pForAngle(cc.degreesToRadians(this.m_object_role.m_angle));
            if (dir.x == -1) {
                dir.x = 1;
                dir.y = 0;
            }
            if (this.m_object_role.getDir() < 0) {
                if (dir.x > 0)
                    dir.x = -dir.x;
            }
            else {
                if (dir.x < 0)
                    dir.x = -dir.x;
            }
            var disControl = this.updateFireAngle(dir, 0, new game.DistanceControl());
            var count = disControl.getMinAngel();
            disControl.clearDis();
            var weaponData = this.m_object_role.m_weaon.getCurWeaponConfig();
            var speed = weaponData.speedMin + (weaponData.speedMax - weaponData.speedMin) / 100 * count;
            // cc.log(count+"",(weaponData.speedMin + (weaponData.speedMax - weaponData.speedMin) / 100 * count)+"");
            game.ui_zhandoujiemian.getMe().setTishiTiao(count);
            this.m_object_role.showDots();
            this.draw(dir, speed, new DrawPointControl());
            // this.m_target = null;
        };
        PlayControlerState.prototype.draw = function (dir, speed, points) {
            if (!this.m_target)
                return;
            var rolePos = this.m_object_role.getBoneWroldPosition("paokou1");
            var pos = this.m_target.getBoneWroldPosition("shoujizudang");
            var dis = rolePos.x - pos.x;
            var Vx = dir.x * speed;
            var t = Math.abs(dis / Vx);
            var dt = 0.02;
            var weaponData = this.m_object_role.m_weaon.getCurWeaponConfig();
            var g = weaponData.g;
            var count = 0;
            var time = 0;
            for (var i = 0; i < Math.round(t / dt); ++i) {
                rolePos.y -= time * g;
                rolePos = cc.pAdd(rolePos, cc.pMult(dir, speed * dt));
                time += dt;
                count++;
                if (count > 2) {
                    count = 0;
                    points.addPoint(rolePos);
                }
            }
            this.m_object_role.drawDots(points);
        };
        PlayControlerState.prototype.updateFireAngle = function (dir, count, disCtr) {
            var rolePos = this.m_object_role.getBoneWroldPosition("paokou1");
            var weaponData = this.m_object_role.m_weaon.getCurWeaponConfig();
            var speed = weaponData.speedMin + (weaponData.speedMax - weaponData.speedMin) / 100 * count++;
            if (count > 100) {
                return disCtr;
            }
            var pos = this.m_target.getBoneWroldPosition("shoujizudang");
            // let dir = cc.pForAngle(cc.degreesToRadians(this.m_object_role.m_angle));
            var dis = rolePos.x - pos.x;
            var Vx = dir.x * speed;
            var t = Math.abs(dis / Vx);
            var g = weaponData.g;
            var newDis = Math.abs(pos.y - game.monsterAi_ptgongji1.getPos(rolePos, t, g, dir, speed).y);
            disCtr.setDis(count, newDis);
            return this.updateFireAngle(dir, count, disCtr);
        };
        PlayControlerState.prototype.loop = function (t) {
            if (this.m_isStayForce) {
                if (this.m_isswitch) {
                    this.m_forcePer -= game.g_other_config.stay_power_per;
                }
                else {
                    this.m_forcePer += game.g_other_config.stay_power_per;
                }
                if (this.m_forcePer >= 100) {
                    this.m_isswitch = true;
                }
                if (this.m_forcePer <= 0) {
                    this.m_isswitch = false;
                }
                if (game.ui_zhandoujiemian.getMe()) {
                    game.ui_zhandoujiemian.getMe().setXuliTiao(this.m_forcePer);
                }
                this.updateDrawLine();
            }
            // if( this.m_object_role.m_candraw){
            //     this.m_object_role.drawLine(t);
            // }
        };
        PlayControlerState.prototype.updateDrawLine = function () {
            if (this.m_object_role.m_weaon.isNotDraw())
                return;
            if (game.dataMgr.getMe().getViplevel() < 3)
                return;
            var dir = cc.pForAngle(cc.degreesToRadians(this.m_object_role.m_angle));
            if (dir.x == -1) {
                dir.x = 1;
                dir.y = 0;
            }
            if (this.m_object_role.getDir() < 0) {
                if (dir.x > 0)
                    dir.x = -dir.x;
            }
            else {
                if (dir.x < 0)
                    dir.x = -dir.x;
            }
            var weaponData = this.m_object_role.m_weaon.getCurWeaponConfig();
            var speed = weaponData.speedMin + (weaponData.speedMax - weaponData.speedMin) / 100 * this.m_forcePer;
            this.draw(dir, speed, new DrawPointControl());
        };
        return PlayControlerState;
    }(game.ControlerState));
    game.PlayControlerState = PlayControlerState;
    var DrawPointControl = (function () {
        function DrawPointControl() {
            this.pointArr = new Array();
        }
        DrawPointControl.prototype.addPoint = function (p) {
            this.pointArr.push(p);
        };
        return DrawPointControl;
    }());
    game.DrawPointControl = DrawPointControl;
})(game || (game = {}));
//# sourceMappingURL=PlayControlerState.js.map