/**
 * 角色状态
 * Created by cy1234 on 2016/7/30.
 */
module game {
    export class PlayControlerState extends ControlerState {
        m_object_role: player;
        m_isStayForce: boolean = false;
        m_forcePer: number = 0;       // 发射力大小百分比
        m_target: monster;

        lockTarget() {
            let temp: number = 10000;
            let targetPos;
            let rolePos;
            let roleMap;
            if(sceneMgr.getMe().getCurScene() instanceof fightAiscene){
                let rolemgr = <roleMgr_ai>roleMgr.getMe();
                roleMap = rolemgr.m_matcher_map;
            }
            else if(sceneMgr.getMe().getCurScene() instanceof PVP_fight){
                let rolemgr = <roleMgr_pvp>roleMgr.getMe();
                roleMap = rolemgr.m_matcher_map;
            }
            else{
                roleMap = roleMgr.getMe().m_monster_map;
            }
            for (let i = 0; i < roleMap.size; ++i) {
                let role = roleMap.getByIndex(i);
                if (role.isDead()) continue;
                targetPos = role.getPosition();
                rolePos = this.m_object_role.getPosition();
                if (this.m_object_role.getDir() > 0) {
                    if (targetPos.x < rolePos.x) {
                        continue;
                    }
                } else {
                    if (targetPos.x > rolePos.x) {
                        continue;
                    }
                }
                let dis = cc.pDistance(targetPos, rolePos);
                if (dis < temp) {
                    temp = dis;
                    this.m_target = role;
                }
            }
            return this.m_target == null;
        }

        up() {
            this.m_object_role.changeState(g_AiType.g_AiType_aim, 0.5);
        }

        down() {
            this.m_object_role.changeState(g_AiType.g_AiType_aim, -0.5);
        }

        attack() {
            if(this.m_object_role.isFire) return;
            this.m_object_role.isFire = true;
            this.m_isStayForce = false;
            this.m_object_role.changeState(g_AiType.g_AiType_att);
            if (ui_zhandoujiemian.getMe()) {
                ui_zhandoujiemian.getMe().setTishiTiao(this.m_forcePer);
                ui_zhandoujiemian.getMe().setXuliTiao(0);
            }
        }

        stayForce() {
            if(this.m_object_role.isFire) return;
            this.m_isStayForce = true;
            this.m_forcePer = 0;
        }

        drawLine() {
            // cc.log("如果是VIP则画线");
            if(this.m_object_role.m_weaon.isNotDraw()) return;
            if(dataMgr.getMe().getViplevel() < 3) return;
            if (this.lockTarget()) {
                this.m_object_role.hideDots();
                cc.log("没有目标");
                return;
            }
            let dir = cc.pForAngle(cc.degreesToRadians(this.m_object_role.m_angle));
            if (dir.x == -1) {
                dir.x = 1;
                dir.y = 0;
            }
            if (this.m_object_role.getDir() < 0) {
                if (dir.x > 0)
                    dir.x = -dir.x;
            } else {
                if (dir.x < 0)
                    dir.x = -dir.x;
            }

            let disControl = this.updateFireAngle(dir, 0, new DistanceControl());
            let count = disControl.getMinAngel();
            disControl.clearDis();
            let weaponData = this.m_object_role.m_weaon.getCurWeaponConfig();
            let speed = weaponData.speedMin + (weaponData.speedMax - weaponData.speedMin) / 100 * count;
            // cc.log(count+"",(weaponData.speedMin + (weaponData.speedMax - weaponData.speedMin) / 100 * count)+"");

            ui_zhandoujiemian.getMe().setTishiTiao(count);
            this.m_object_role.showDots();
            this.draw(dir, speed, new DrawPointControl());
            // this.m_target = null;
        }

        draw(dir, speed, points) {
            if(!this.m_target) return;
            let rolePos: cc.Vec2 = this.m_object_role.getBoneWroldPosition("paokou1");
            let pos = this.m_target.getBoneWroldPosition("shoujizudang");
            let dis = rolePos.x - pos.x;
            let Vx = dir.x * speed;
            let t = Math.abs(dis / Vx);
            let dt = 0.02;
            let weaponData = this.m_object_role.m_weaon.getCurWeaponConfig();
            let g = weaponData.g;
            let count = 0;
            let time = 0;
            for (let i = 0; i < Math.round(t / dt); ++i) {
                rolePos.y -= time * g;
                rolePos = cc.pAdd(rolePos, cc.pMult(dir, speed * dt));
                time += dt;
                count ++;
                if(count > 2){
                    count = 0;
                    points.addPoint(rolePos);
                }
            }
            this.m_object_role.drawDots(points);
        }

        updateFireAngle(dir, count, disCtr) {
            let rolePos: cc.Vec2 = this.m_object_role.getBoneWroldPosition("paokou1");
            let weaponData = this.m_object_role.m_weaon.getCurWeaponConfig();
            let speed = weaponData.speedMin + (weaponData.speedMax - weaponData.speedMin) / 100 * count++;
            if (count > 100) {
                return disCtr;
            }
            let pos = this.m_target.getBoneWroldPosition("shoujizudang");
            // let dir = cc.pForAngle(cc.degreesToRadians(this.m_object_role.m_angle));
            let dis = rolePos.x - pos.x;
            let Vx = dir.x * speed;
            let t = Math.abs(dis / Vx);
            let g = weaponData.g;
            let newDis = Math.abs(pos.y - monsterAi_ptgongji1.getPos(rolePos, t, g, dir, speed).y);
            disCtr.setDis(count, newDis);
            return this.updateFireAngle(dir, count, disCtr);
        }

        m_isswitch = false;//是否切换加减蓄力条
        loop(t) {
            if (this.m_isStayForce) {
                if(this.m_isswitch){
                    this.m_forcePer -= g_other_config.stay_power_per;
                }else {
                    this.m_forcePer += g_other_config.stay_power_per;
                }
                if (this.m_forcePer >= 100) {
                    this.m_isswitch = true;
                }
                if(this.m_forcePer <= 0){
                    this.m_isswitch = false;
                }
                if (ui_zhandoujiemian.getMe()) {
                    ui_zhandoujiemian.getMe().setXuliTiao(this.m_forcePer);
                }
                this.updateDrawLine();

            }
            // if( this.m_object_role.m_candraw){
            //     this.m_object_role.drawLine(t);
            // }

        }

        updateDrawLine(){
            if(this.m_object_role.m_weaon.isNotDraw()) return;
            if(dataMgr.getMe().getViplevel() < 3) return;
            let dir = cc.pForAngle(cc.degreesToRadians(this.m_object_role.m_angle));
            if (dir.x == -1) {
                dir.x = 1;
                dir.y = 0;
            }
            if (this.m_object_role.getDir() < 0) {
                if (dir.x > 0)
                    dir.x = -dir.x;
            } else {
                if (dir.x < 0)
                    dir.x = -dir.x;
            }
            let weaponData = this.m_object_role.m_weaon.getCurWeaponConfig();
            let speed = weaponData.speedMin + (weaponData.speedMax - weaponData.speedMin) / 100 * this.m_forcePer;
            this.draw(dir, speed, new DrawPointControl());
        }
    }

    export class DrawPointControl {
        pointArr: Array<cc.Vec2> = new Array<cc.Vec2>();

        addPoint(p: cc.Vec2) {
            this.pointArr.push(p);
        }

    }
}