var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var monster = (function (_super) {
        __extends(monster, _super);
        function monster() {
            _super.apply(this, arguments);
        }
        monster.prototype.init = function (heroName) {
            this.m_name = heroName;
            var config = game.g_monster_config[heroName];
            this.loadres(config.spine_res);
            this.setScale(config.scale);
            this.m_scale = config.scale;
            this.createBloodBar(config.headHpBarPos, config.bloodScale);
            this.initProperty(config);
            this.m_stateControl = new game.monsterStateControl(this);
            this.m_controlerState = new game.MonsterControlerState(this);
            this.m_stateControl.initState();
            this.setRoleDir(-1);
            // this.setPosition(cc.p(500,900));
            this.m_headHpNumberPos = config.headHpNumberPos;
            this.m_attRange = config.attPos;
            this.m_bulletSpeed = config.bulletSpeed;
        };
        monster.prototype.initProperty = function (config) {
            this.m_att = config.attackPoint;
            this.m_maxHp = config.hp;
            this.m_power = config.power;
            this.m_maxPower = config.power;
            _super.prototype.initProperty.call(this, config);
            this.m_arrawPos = config.arrowPos;
        };
        monster.prototype.createBloodBar = function (pos, scale) {
            this.m_bloodBar = game.UiBase.parseUiFile_static("xuetiao_guaiwu.json");
            this.addChild(this.m_bloodBar);
            this.m_bloodBar.setPosition(pos);
            this.m_bloodBar.setScale(scale);
            this.m_hpper = ccui.helper.seekWidgetByName(this.m_bloodBar, "xuetiao");
        };
        monster.prototype.update = function (dt) {
            _super.prototype.update.call(this, dt);
        };
        monster.prototype.getCurPower = function () {
            return this.m_power;
        };
        monster.prototype.setCurPower = function (power) {
            if (power < 0) {
                power = 0;
            }
            this.m_power = power;
        };
        monster.prototype.getMaxPower = function () {
            return this.m_maxPower;
        };
        monster.prototype.getSpeed = function () {
            return _super.prototype.getSpeed.call(this);
        };
        monster.prototype.getAtt = function () {
            try {
                return this.m_att * game.sceneMgr.getMe().getCurSceneInfo().attper * game.g_debug_monster_att_per;
            }
            catch (e) {
                console.log(e.stack);
            }
        };
        monster.prototype.getMaxHp = function () {
            try {
                return _super.prototype.getMaxHp.call(this) * game.sceneMgr.getMe().getCurSceneInfo().hpper;
            }
            catch (e) {
                console.log(e.stack);
            }
        };
        monster.prototype.onDamage = function (shoujires, shoujianima, shoujiscale, roleId) {
            _super.prototype.onDamage.call(this, shoujires, shoujianima, shoujiscale);
            var role = game.roleMgr.getMe().m_AllRole_map.get(roleId);
            if (!role)
                return;
            var att = role.getAtt();
            var iscrit = 0;
            if (Math.floor(Math.random() * 100) < role.getCritRate() * 100) {
                att *= 2;
                iscrit = 1;
            }
            if (role instanceof monster) {
                att /= 2;
            }
            var hp = this.getHp();
            if (role instanceof game.player) {
                if (role.m_skin.getSkillName() == "nianya") {
                    if (hp <= this.getMaxHp() * role.m_skin.getShuzhi1()) {
                        att *= (1 + role.m_skin.getShuzhi2());
                    }
                }
                if (role.m_skin.getSkillName() == "kuangbao") {
                    att *= (1 + role.m_skin.getShuzhi1_bear());
                }
                if (role.m_skin.getSkillName() == "xixue") {
                    role.addHp(att * role.m_skin.getShuzhi1());
                }
                if (hp < (this.getMaxHp() * 0.5)) {
                    if (role.m_weaon.getWeaponSkill() == "kill") {
                        if (Math.floor(Math.random() * 100) < 20) {
                            att = hp;
                        }
                    }
                }
            }
            hp -= att;
            if (hp <= 0) {
                hp = 0;
                if (this.m_stateControl.getCurStateType() != game.g_AiType.g_AiType_dead)
                    this.changeState_Ex(game.g_AiType.g_AiType_dead);
            }
            else {
                if (this.m_stateControl.getCurStateType() != game.g_AiType.g_AiType_hit)
                    this.changeState_Ex(game.g_AiType.g_AiType_hit);
            }
            this.setHp(hp);
            if (game.ui_zhandoujiemian.getMe()) {
                game.ui_zhandoujiemian.getMe().updateBoss(this.m_name, hp, this.getMaxHp());
            }
            if (iscrit == 1)
                game.uieffectMgr.getMe().createLayout_monsterdropCrithp(game.roleMgr.getMe().getNode(), att, this.getHeadHpNumberPos());
            else
                game.uieffectMgr.getMe().createLayout_playdrophp(game.roleMgr.getMe().getNode(), att, this.getHeadHpNumberPos());
        };
        return monster;
    }(game.baseRole));
    game.monster = monster;
})(game || (game = {}));
//# sourceMappingURL=monster.js.map