module game {
    export class monster extends baseRole {
        m_stateControl: monsterStateControl;
        m_controlerState: MonsterControlerState;

        m_power: number;
        m_maxPower: number;
        m_attRange;
        m_bulletSpeed:number;

        init(heroName) {
            this.m_name = heroName;
            let config = g_monster_config[heroName];
            this.loadres(config.spine_res);
            this.setScale(config.scale);
            this.m_scale = config.scale;
            this.createBloodBar(config.headHpBarPos, config.bloodScale);
            this.initProperty(config);

            this.m_stateControl = new monsterStateControl(this);
            this.m_controlerState = new MonsterControlerState(this);
            this.m_stateControl.initState();

            this.setRoleDir(-1);
            // this.setPosition(cc.p(500,900));
            this.m_headHpNumberPos = config.headHpNumberPos;
            this.m_attRange = config.attPos;
            this.m_bulletSpeed = config.bulletSpeed;

        }

        initProperty(config) {
            this.m_att = config.attackPoint;
            this.m_maxHp = config.hp;
            this.m_power = config.power;
            this.m_maxPower = config.power;
            super.initProperty(config);
            this.m_arrawPos = config.arrowPos;
        }

        createBloodBar(pos: cc.Vec2, scale: number) {
            this.m_bloodBar = UiBase.parseUiFile_static("xuetiao_guaiwu.json");
            this.addChild(this.m_bloodBar);
            this.m_bloodBar.setPosition(pos);
            this.m_bloodBar.setScale(scale);
            this.m_hpper = ccui.helper.seekWidgetByName(this.m_bloodBar, "xuetiao");
        }

        update(dt: number) {
            super.update(dt);
        }

        getCurPower() {
            return this.m_power;
        }

        setCurPower(power: number) {
            if (power < 0) {
                power = 0;
            }
            this.m_power = power;
        }

        getMaxPower() {
            return this.m_maxPower;
        }

        getSpeed(): number {
            return super.getSpeed();
        }

        getAtt() {
            try {
                return this.m_att * sceneMgr.getMe().getCurSceneInfo().attper * g_debug_monster_att_per;
            }
            catch (e) {
                console.log(e.stack);
            }
        }

        getMaxHp()
            {
                try {
                    return super.getMaxHp() * sceneMgr.getMe().getCurSceneInfo().hpper;
                }
                catch (e) {
                    console.log(e.stack);
                }

            }

        onDamage(shoujires: string, shoujianima: string, shoujiscale: number, roleId: number) {
            super.onDamage(shoujires, shoujianima, shoujiscale);
            let role = roleMgr.getMe().m_AllRole_map.get(roleId);
            if(!role) return;
            let att = role.getAtt();
            let iscrit = 0;
            if (Math.floor(Math.random() * 100) < role.getCritRate() * 100) {
                att *= 2;
                iscrit = 1;
            }
            if(role instanceof monster){
                att /= 2;
            }
            let hp = this.getHp();

            if(role instanceof player){
                if(role.m_skin.getSkillName() == "nianya"){
                    if(hp <= this.getMaxHp() * role.m_skin.getShuzhi1()){
                        att *= (1 + role.m_skin.getShuzhi2());
                    }
                }
                if(role.m_skin.getSkillName() == "kuangbao"){
                    att *= (1 + role.m_skin.getShuzhi1_bear());
                }
                if(role.m_skin.getSkillName() == "xixue"){
                    role.addHp(att * role.m_skin.getShuzhi1());
                }
                if(hp < (this.getMaxHp() * 0.5)){
                    if(role.m_weaon.getWeaponSkill() == "kill"){
                        if(Math.floor(Math.random() * 100) < 20){
                            att = hp;
                        }
                    }
                }
            }

            hp -= att;
            if (hp <= 0) {
                hp = 0;
                if(this.m_stateControl.getCurStateType() != g_AiType.g_AiType_dead)
                    this.changeState_Ex(g_AiType.g_AiType_dead);
            } else {
                if(this.m_stateControl.getCurStateType() != g_AiType.g_AiType_hit)
                    this.changeState_Ex(g_AiType.g_AiType_hit);
            }
            this.setHp(hp);
            if(ui_zhandoujiemian.getMe()){
                ui_zhandoujiemian.getMe().updateBoss(this.m_name,hp,this.getMaxHp());
            }

            if (iscrit == 1)
                uieffectMgr.getMe().createLayout_monsterdropCrithp(roleMgr.getMe().getNode(), att, this.getHeadHpNumberPos());
            else
                uieffectMgr.getMe().createLayout_playdrophp(roleMgr.getMe().getNode(), att, this.getHeadHpNumberPos());
        }
    }

}