/**
 * 武器
 */
var game;
(function (game) {
    var WeaponData = (function () {
        function WeaponData() {
        }
        WeaponData.prototype.toString = function () {
            return "name :" + this.name + "\n"
                + "level :" + this.level + "\n"
                + "num :" + this.num + "\n";
        };
        return WeaponData;
    }());
    game.WeaponData = WeaponData;
    var playWeapon = (function () {
        function playWeapon(role, type) {
            this.m_des = "playWeapon";
            this.init(role.getName(), type);
            this.m_object_role = role;
        }
        playWeapon.prototype.init = function (heroName, type) {
            var _this = this;
            var weaponsData = game.dataMgr.getMe().getPlayDoc()[heroName + "_weapon"];
            if (!weaponsData) {
                cc.error("weaponsData", heroName + "_weapon");
            }
            this.m_weaponsPlayData = new game.Map();
            for (var i = 0; i < weaponsData.length; ++i) {
                if (weaponsData[i]) {
                    var weaponData = new WeaponData();
                    weaponData.name = weaponsData[i].name;
                    weaponData.level = weaponsData[i].level;
                    weaponData.num = weaponsData[i].num;
                    weaponData.maxNum = weaponData.num;
                    this.m_weaponsPlayData.set(weaponData.name, weaponData);
                }
            }
            this.m_weaponsNameArr = new Array();
            this.m_weaponsPlayData.forEach(function (v, k) {
                cc.log(v.toString(), k);
                _this.m_weaponsNameArr.push(k);
            }, this);
            this.addStoneWeapon();
            this.m_weaponConfig = {};
            var name;
            for (var i = 0; i < this.m_weaponsNameArr.length; ++i) {
                name = this.m_weaponsNameArr[i];
                this.m_weaponConfig[name] = game.getWeaponConfig()[name];
            }
            this.m_curWeaponName = game.dataMgr.getMe().getCurWeaponByName(heroName);
            if (!this.hasWeaponByName(this.m_curWeaponName)) {
                this.m_curWeaponName = this.m_weaponsNameArr[0];
            }
        };
        playWeapon.prototype.addStoneWeapon = function () {
            var data = new WeaponData();
            data.name = "wuqi1";
            data.level = 0;
            data.num = 99;
            data.maxNum = 99;
            this.m_weaponsPlayData.set("wuqi1", data);
            this.m_weaponsNameArr.push("wuqi1");
        };
        playWeapon.prototype.getCurWeaponAnima = function () {
            return this.m_weaponConfig[this.m_curWeaponName].roleAnimation2;
        };
        playWeapon.prototype.isNotDraw = function () {
            var skill = this.getWeaponSkill();
            if (!skill)
                return false;
            return (skill.indexOf("launch") > -1);
        };
        playWeapon.prototype.getCurWeaponAttachmentImage = function () {
            return this.m_weaponConfig[this.m_curWeaponName].roleBujian;
        };
        playWeapon.prototype.getCurWeaponConfig = function () {
            return this.m_weaponConfig[this.m_curWeaponName][this.m_weaponsPlayData.get(this.m_curWeaponName).level];
        };
        playWeapon.prototype.getCurWeaponConfig2 = function () {
            return this.m_weaponConfig[this.m_curWeaponName];
        };
        playWeapon.prototype.setCurWeapon = function (name) {
            cc.log("setCurWeapon :", name);
            this.m_curWeaponName = name;
            // this.m_object_role  切换角色武器
            this.m_object_role.initAngle();
            this.m_object_role.updateAngle(0);
            game.playControl.getMe().init();
            if (this.m_object_role.isPvp) {
                if (this.m_object_role.m_index != null) {
                    game.sync_weapon.getMe().send(this.m_object_role.m_index, name);
                }
            }
            // this.m_object_role.updateAngle(0);
            // this.m_object_role.m_controlerState.updateDrawLine();
        };
        playWeapon.prototype.hasWeaponByName = function (name) {
            for (var i = 0; i < this.m_weaponsNameArr.length; ++i) {
                if (this.m_weaponsNameArr[i] == name) {
                    return true;
                }
            }
            return false;
        };
        playWeapon.prototype.getWeaponDataByName = function (name) {
            return this.m_weaponsPlayData.get(name);
        };
        playWeapon.prototype.reduceCurWeaponBulletNum = function () {
            if (this.getWeaponSkill() == "noLimit")
                return;
            var num = this.m_weaponsPlayData.get(this.m_curWeaponName).num--;
            if (num < 0) {
                this.m_weaponsPlayData.get(this.m_curWeaponName).num = 0;
            }
            game.ui_zhandoujiemian.getMe().initPlayerDataUI();
        };
        playWeapon.prototype.getWeaponBulletNumByName = function (name) {
            return this.m_weaponsPlayData.get(name).num;
        };
        playWeapon.prototype.resetWeaponBulletNumByName = function (name) {
            this.m_weaponsPlayData.get(name).num = this.m_weaponsPlayData.get(name).maxNum;
        };
        playWeapon.prototype.shutdown = function () {
            // 数据和存档同步  当前武器
            game.dataMgr.getMe().setCurWeaponByName(this.m_object_role.getName(), this.m_curWeaponName);
            this.m_object_role = null;
            this.m_weaponsPlayData.clear();
            this.m_weaponsPlayData = null;
            this.m_weaponsNameArr = null;
            this.m_weaponConfig = null;
        };
        playWeapon.prototype.getWeaponSkill = function () {
            return this.m_weaponConfig[this.m_curWeaponName].teshu;
        };
        return playWeapon;
    }());
    game.playWeapon = playWeapon;
})(game || (game = {}));
//# sourceMappingURL=playWeapon.js.map