/**
 * 武器
 */
module game {
    export class WeaponData {
        name: string;
        level: number;
        num: number;
        maxNum:number;

        toString() {
            return "name :" + this.name + "\n"
                + "level :" + this.level + "\n"
                + "num :" + this.num + "\n";
        }
    }

    export class playWeapon {
        m_des: string;
        m_weaponsPlayData: Map<string,WeaponData>;
        m_curWeaponName: string;
        m_weaponsNameArr: Array<string>;
        m_weaponConfig;
        m_object_role: player;

        constructor(role: player,type) {
            this.m_des = "playWeapon";
            this.init(role.getName(),type);
            this.m_object_role = role;
        }

        init(heroName: string,type) {
            let weaponsData = dataMgr.getMe().getPlayDoc()[heroName + "_weapon"];
            if (!weaponsData) {
                cc.error("weaponsData", heroName + "_weapon");
            }

            this.m_weaponsPlayData = new Map<string,WeaponData>();
            for (let i = 0; i < weaponsData.length; ++i) {
                if(weaponsData[i]){
                    let weaponData = new WeaponData();
                    weaponData.name = weaponsData[i].name;
                    weaponData.level = weaponsData[i].level;
                    weaponData.num = weaponsData[i].num;
                    weaponData.maxNum = weaponData.num;
                    this.m_weaponsPlayData.set(weaponData.name, weaponData);
                }
            }

            this.m_weaponsNameArr = new Array<string>();
            this.m_weaponsPlayData.forEach((v, k) => {
                cc.log(v.toString(), k);
                this.m_weaponsNameArr.push(k);
            }, this);

            this.addStoneWeapon();

            this.m_weaponConfig = {};
            let name;
            for (let i = 0; i < this.m_weaponsNameArr.length; ++i) {
                name = this.m_weaponsNameArr[i];
                this.m_weaponConfig[name] = getWeaponConfig()[name];
            }

            this.m_curWeaponName = dataMgr.getMe().getCurWeaponByName(heroName);
            if(!this.hasWeaponByName(this.m_curWeaponName)){
                this.m_curWeaponName = this.m_weaponsNameArr[0];
            }
        }

        addStoneWeapon(){
            let data = new WeaponData();
            data.name = "wuqi1";
            data.level = 0;
            data.num = 99;
            data.maxNum = 99;
            this.m_weaponsPlayData.set("wuqi1", data);
            this.m_weaponsNameArr.push("wuqi1");
        }

        getCurWeaponAnima(){
            return this.m_weaponConfig[this.m_curWeaponName].roleAnimation2;
        }

        isNotDraw(){
            let skill = this.getWeaponSkill();
            if(!skill) return false;
            return (skill.indexOf("launch") > -1);
        }

        getCurWeaponAttachmentImage(){
            return this.m_weaponConfig[this.m_curWeaponName].roleBujian;
        }

        getCurWeaponConfig() {
            return this.m_weaponConfig[this.m_curWeaponName][this.m_weaponsPlayData.get(this.m_curWeaponName).level];
        }

        getCurWeaponConfig2() {
            return this.m_weaponConfig[this.m_curWeaponName];
        }

        setCurWeapon(name: string) {
            cc.log("setCurWeapon :", name);
            this.m_curWeaponName = name;
            // this.m_object_role  切换角色武器
            this.m_object_role.initAngle();
            this.m_object_role.updateAngle(0);
            playControl.getMe().init();

            if(this.m_object_role.isPvp){
                if(this.m_object_role.m_index != null){
                    sync_weapon.getMe().send(this.m_object_role.m_index,name);
                }
            }

            // this.m_object_role.updateAngle(0);
            // this.m_object_role.m_controlerState.updateDrawLine();
        }

        hasWeaponByName(name: string) {
            for (let i = 0; i < this.m_weaponsNameArr.length; ++i) {
                if (this.m_weaponsNameArr[i] == name) {
                    return true;
                }
            }
            return false;
        }

        getWeaponDataByName(name: string): WeaponData {
            return this.m_weaponsPlayData.get(name);
        }

        reduceCurWeaponBulletNum() {
            if(this.getWeaponSkill() == "noLimit") return;
            let num = this.m_weaponsPlayData.get(this.m_curWeaponName).num--;
            if (num < 0) {
                this.m_weaponsPlayData.get(this.m_curWeaponName).num = 0;
            }
            ui_zhandoujiemian.getMe().initPlayerDataUI();
        }

        getWeaponBulletNumByName(name) {
            return this.m_weaponsPlayData.get(name).num;
        }

        resetWeaponBulletNumByName(name){
            this.m_weaponsPlayData.get(name).num = this.m_weaponsPlayData.get(name).maxNum;
        }

        shutdown(){
            // 数据和存档同步  当前武器
            dataMgr.getMe().setCurWeaponByName(this.m_object_role.getName(), this.m_curWeaponName);

            this.m_object_role = null;
            this.m_weaponsPlayData.clear();
            this.m_weaponsPlayData = null;
            this.m_weaponsNameArr = null;
            this.m_weaponConfig = null;
        }

        getWeaponSkill(){
            return this.m_weaponConfig[this.m_curWeaponName].teshu;
        }
    }
}