var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    // 装备 符文 皮肤 金币
    var pSub = cc.pSub;
    var pMult = cc.pMult;
    var player = (function (_super) {
        __extends(player, _super);
        function player() {
            _super.apply(this, arguments);
            this.m_DrawNode = null; //辅助线
        }
        player.prototype.init = function (heroName, type) {
            var config = game.g_playhero_config[heroName];
            this.loadres(config.spine_res);
            this.m_name = heroName;
            this.setScale(config.scale);
            this.m_scale = config.scale;
            this.createBloodBar(config.headHpBarPos, config.bloodScale);
            this.m_stateControl = new game.playStateControl(this);
            this.m_controlerState = new game.PlayControlerState(this);
            this.m_weaon = new game.playWeapon(this, 1);
            this.m_skin = new game.playSkin(this, 1);
            this.m_item = new game.playItem(this);
            this.m_title = new game.playTitle(this, 1);
            this.m_stateControl.initState();
            if (game.dataMgr.getMe().getViplevel() > game.g_vip_unlock) {
                this.m_DrawNode = new cc.DrawNode();
                this.addChild(this.m_DrawNode);
            }
            this.setRoleDir(1);
            this.initProperty(config);
            this.setCurPower(this.getMaxPower());
            this.m_headHpNumberPos = config.headHpNumberPos;
            this.isPvp = game.sceneMgr.getMe().getCurScene() instanceof game.PVP_fight;
        };
        player.prototype.initProperty = function (config) {
            var herolevel = game.dataMgr.getMe().getlevel();
            var levelconfig = game.g_player_levelUp_config[herolevel];
            this.m_att = levelconfig.atk + game.dataMgr.getMe().getPlayDoc().coreData.extraAtt;
            this.m_maxHp = levelconfig.hp + game.dataMgr.getMe().getPlayDoc().coreData.extraHP;
            this.m_def = levelconfig.def + game.dataMgr.getMe().getPlayDoc().coreData.extraDef;
            this.m_power = levelconfig.power + game.dataMgr.getMe().getPlayDoc().coreData.extraPower;
            _super.prototype.initProperty.call(this, config);
            this.initAngleNode();
            this.m_arrawPos = config.arrowPos;
        };
        player.prototype.showBody = function () {
            this.m_SpineNode.getNode().opacity = 255;
        };
        player.prototype.hideBody = function () {
            this.m_SpineNode.getNode().opacity = 100;
        };
        player.prototype.changeState_Ex = function (key, data) {
            // cc.log("changeState "+this.getName(),key);
            if (this.isPvp) {
                if (this.m_index != null) {
                    game.sync_state.getMe().send(this.m_index, key, data, this.getPosition());
                }
            }
            return this.m_stateControl.changeState_Ex(key, data);
        };
        player.prototype.changeState = function (key, data) {
            // cc.log("changeState "+this.getName(),key);
            if (this.isPvp) {
                if (this.m_index != null) {
                    game.sync_state.getMe().send(this.m_index, key, data, this.getPosition());
                }
            }
            return this.m_stateControl.changeState(key, data);
        };
        player.prototype.fuhuo = function () {
            game.roleMgr.getMe().m_deadNum_player--;
            this.setHp(this.getMaxHp());
            this.changeState_Ex(game.g_AiType.g_AiType_idle);
            // 复活特效
            var ret = game.spineMgr.getMe().createSpineOncePlay("fuhuotxiao", "animation", this.getNode(), this.getPosition(), 9999999);
            ret.setPosition(game.g_other_config.fuhuo.pos);
            ret.setScale(game.g_other_config.fuhuo.scale);
        };
        player.prototype.createBloodBar = function (pos, scale) {
            this.m_bloodBar = game.UiBase.parseUiFile_static("xuetiao_bule.json");
            this.addChild(this.m_bloodBar);
            this.m_bloodBar.setPosition(pos);
            this.m_bloodBar.setScale(scale);
            this.m_hpper = ccui.helper.seekWidgetByName(this.m_bloodBar, "xuetiao");
            var name = ccui.helper.seekWidgetByName(this.m_bloodBar, "name");
            var _level = ccui.helper.seekWidgetByName(this.m_bloodBar, "dengji");
            var _tittle = ccui.helper.seekWidgetByName(this.m_bloodBar, "chenghao");
            var vipimg = ccui.helper.seekWidgetByName(this.m_bloodBar, "vip_biaoshi");
            name.setString(game.dataMgr.getMe().getNickName());
            _level.setString(game.dataMgr.getMe().getlevel());
            // let tittleconfig = dataMgr.getMe().getTittleConfigBytag(tittle);
            var nantittle = game.dataMgr.getMe().getTittle(this.m_name);
            if (nantittle == -1) {
                _tittle.setVisible(false);
            }
            else {
                _tittle.setVisible(true);
                var level_nan = game.dataMgr.getMe().getTittlelevel(nantittle);
                var nantittleconfig = game.dataMgr.getMe().getTittleConfigBytag(nantittle, level_nan);
                _tittle.loadTexture(nantittleconfig.icon);
            }
            if (game.dataMgr.getMe().getViplevel() <= 0) {
                vipimg.setVisible(false);
            }
            else {
                vipimg.setVisible(true);
                vipimg.loadTexture(game.g_vip_config[game.dataMgr.getMe().getViplevel()].icon);
            }
        };
        player.prototype.update = function (dt) {
            _super.prototype.update.call(this, dt);
            // 换武器
            if (this.m_weaon) {
                this.m_SpineNode.replaceAttachmentImage("wuqi", this.m_weaon.getCurWeaponAttachmentImage());
            }
        };
        player.prototype.getExpPer = function () {
            return this.m_title.getExpPer();
        };
        player.prototype.getGoldPer = function () {
            return this.m_title.getGoldPer();
        };
        player.prototype.setCurPower = function (power) {
            if (power < 0) {
                power = 0;
            }
            this.m_curPower = power;
            if (game.ui_zhandoujiemian.getMe()) {
                game.ui_zhandoujiemian.getMe().setPower(this.m_curPower, this.getMaxPower());
            }
        };
        player.prototype.getCurPower = function () {
            return this.m_curPower;
            // return 1;
        };
        player.prototype.getMaxPower = function () {
            return (this.m_power + this.m_skin.getPower() + this.m_title.getPower()) * (1 + this.m_title.getPowerPer());
        };
        player.prototype.getDef_boom = function () {
            var def = (1 - (this.m_def + this.m_skin.getDef() + this.m_title.getDef())) * (1 - this.m_title.getDefPer()) * (1 - this.m_title.getBoomDefPer());
            cc.log("def_boom:", def);
            return def;
        };
        player.prototype.getDef = function () {
            var def = (1 - (this.m_def + this.m_skin.getDef() + this.m_title.getDef())) * (1 - this.m_title.getDefPer());
            cc.log("def:", def);
            return def;
        };
        player.prototype.shutdown = function () {
            this.m_weaon.shutdown();
            this.m_skin.shutdown();
            this.m_item.shutdown();
            this.m_title.shutdown();
            this.m_weaon = null;
            this.m_skin = null;
            this.m_item = null;
            this.m_title = null;
            _super.prototype.shutdown.call(this);
            if (this.m_angleNode) {
                this.removeChild(this.m_angleNode, true);
                this.m_angleNode = null;
            }
            if (this.m_angleImage) {
                this.m_angleImage.shutdown();
                this.m_angleImage = null;
            }
            if (this.m_angleImage2) {
                this.removeChild(this.m_angleImage2, true);
                this.m_angleImage2 = null;
            }
            if (this.m_DrawNode) {
                this.removeChild(this.m_DrawNode, true);
                this.m_DrawNode = null;
            }
        };
        player.prototype.getAtt = function () {
            var att = (_super.prototype.getAtt.call(this) + this.m_skin.getAtt() + this.m_title.getAtt() + this.m_weaon.getCurWeaponConfig().damage) * (1 + this.m_title.getAttPer()) * this.m_item.getAttPer();
            cc.log("att:", att);
            return att * game.g_debug_play_att_per;
        };
        player.prototype.getSpeed = function () {
            return _super.prototype.getSpeed.call(this);
        };
        player.prototype.getMaxHp = function () {
            return _super.prototype.getMaxHp.call(this) + this.m_skin.getHp() + this.m_title.getHp();
        };
        player.prototype.getCritRate = function () {
            var crit = _super.prototype.getCritRate.call(this) + this.m_skin.getCritRate();
            cc.log("暴击率：", crit);
            return crit;
        };
        player.prototype.setHp = function (hp) {
            _super.prototype.setHp.call(this, hp);
        };
        player.prototype.onDamage = function (shoujires, shoujianima, shoujiscale, roleId, isBoom) {
            _super.prototype.onDamage.call(this, shoujires, shoujianima, shoujiscale);
            var role = game.roleMgr.getMe().m_AllRole_map.get(roleId);
            if (!role)
                return;
            var att = role.getAtt();
            var hp = this.getHp();
            var iscrit = 0;
            if (Math.floor(Math.random() * 100) < role.getCritRate() * 100) {
                att *= 2;
                iscrit = 1;
            }
            if (role instanceof player) {
                att /= 2;
            }
            if (this.m_skin.getSkillName() == "kuangbao") {
                att *= (1 + this.m_skin.getShuzhi2_bear());
            }
            if (this.m_skin.getSkillName() == "minjie") {
                if (Math.floor(Math.random() * 100) < this.m_skin.getShuzhi1() * 100) {
                    game.uieffectMgr.getMe().createLayout_playdrophp_crit(game.roleMgr.getMe().getNode(), att, this.getHeadHpNumberPos());
                    return;
                }
            }
            if (role instanceof game.player_pvp) {
                if (role.m_skin.getSkillName() == "nianya") {
                    if (hp <= this.getMaxHp() * role.m_skin.getShuzhi1()) {
                        att *= (1 + role.m_skin.getShuzhi2());
                    }
                }
                if (role.m_skin.getSkillName() == "kuangbao") {
                    att *= (1 + role.m_skin.getShuzhi1_bear());
                }
                if (role.m_skin.getSkillName() == "xixue") {
                    role.addHp(att * role.m_skin.getShuzhi1());
                }
                if (hp < (this.getMaxHp() * 0.5)) {
                    if (role.m_weaon.getWeaponSkill() == "kill") {
                        if (Math.floor(Math.random() * 100) < 20) {
                            att = hp;
                        }
                    }
                }
            }
            if (isBoom) {
                att *= this.getDef_boom();
            }
            else {
                att *= this.getDef();
            }
            hp -= att;
            if (hp < 0) {
                hp = 0;
                if (this.m_stateControl.getCurStateType() != game.g_AiType.g_AiType_dead)
                    this.changeState_Ex(game.g_AiType.g_AiType_dead);
            }
            else {
                if (this.m_stateControl.getCurStateType() != game.g_AiType.g_AiType_hit)
                    this.changeState_Ex(game.g_AiType.g_AiType_hit);
            }
            this.setHp(hp);
            if (iscrit == 1)
                game.uieffectMgr.getMe().createLayout_monsterdropCrithp(game.roleMgr.getMe().getNode(), att, this.getHeadHpNumberPos());
            else
                game.uieffectMgr.getMe().createLayout_playdrophp(game.roleMgr.getMe().getNode(), att, this.getHeadHpNumberPos());
            if (this.isPvp) {
                if (this.m_index != null) {
                    game.sync_hit.getMe().send(this.m_index, shoujires, shoujianima, shoujiscale, roleId, isBoom, att, iscrit);
                }
            }
        };
        player.prototype.initAngle = function () {
            if (!this.m_angle) {
                var data = this.m_weaon.getCurWeaponConfig();
                this.m_angle = (data.minAngle + data.maxAngle) / 2;
                this.updateAngleNode(this.m_angle);
            }
            // cc.log("initAngle :", this.m_angle);
        };
        player.prototype.initAngleNode = function () {
            this.m_angleNode = game.UiBase.parseUiFile_static("jiaodu.json");
            // ccui.helper.seekWidgetByName(this.m_angleNode, "1").setVisible(false);
            this.addChild(this.m_angleNode);
            var angletext = ccui.helper.seekWidgetByName(this.m_angleNode, "jiaodu");
            angletext.setString(Math.ceil(this.m_angle ? this.m_angle : 0) + "°");
            var pos = game.g_playhero_config[this.getName()].shootAngelPos;
            // pos.x = pos.x * this.getScale();
            // pos.y = pos.y * this.getScale();
            this.m_angelPos = pos;
            this.m_angelPos2 = cc.p(game.g_other_config.anglePos);
            this.m_angleImage = new game.ProgressTimerEx("xingjietantantang/big/ui/image/ddt_ui158.png", pos, this.getNode(), game.g_other_config.angleSize.range);
            this.m_angleImage2 = new ccui.ImageView();
            this.m_angleImage2.loadTexture("xingjietantantang/big/ui/image/ddt_ui255.png");
            this.addChild(this.m_angleImage2, 100);
            this.m_angleImage2.setPosition(pos);
            this.m_angleNode.setPosition(this.m_angelPos2);
            this.m_angleNode.setVisible(false);
            this.m_angleImage2.setVisible(false);
            this.m_angleImage2.setScale(game.g_other_config.angleSize.aimline);
            this.m_angleNode.setScale(game.g_other_config.angleSize.angle);
        };
        player.prototype.showAngleImage = function () {
            this.isFire = false;
            if (this.m_weaon.isNotDraw())
                return;
            this.m_angleNode.setVisible(true);
            this.m_angleImage2.setVisible(true);
            this.updateAngleImage();
            if (this.m_DrawNode) {
                // this.m_DrawNode.setVisible(true);
                this.m_controlerState.drawLine();
            }
        };
        player.prototype.updateAngleImage = function () {
            var data = this.m_weaon.getCurWeaponConfig();
            if (this.getDir() < 0) {
                this.m_angleImage.setRotation(180 + (180 - (90 - data.minAngle)));
                if (this.m_angelPos.x > 0) {
                    this.m_angelPos2.x = -this.m_angelPos2.x;
                    this.m_angelPos.x = -this.m_angelPos.x;
                }
                this.m_angleImage.setPosition(this.m_angelPos);
                // this.m_angle = 180 + this.m_angle;
                // cc.log("aaaaaaaaaaa ", this.m_angle);
                if (this.m_angle < 90) {
                    this.m_angleImage2.setRotation(180 + this.m_angle);
                }
                else {
                    this.m_angleImage2.setRotation(-this.m_angle);
                }
                // this.m_angleImage2.setRotation(180 + this.m_angle);
                this.m_angleImage2.setPosition(this.m_angelPos);
            }
            else {
                this.m_angleImage.setRotation(90 - data.maxAngle);
                if (this.m_angelPos.x < 0) {
                    this.m_angelPos2.x = -this.m_angelPos2.x;
                    this.m_angelPos.x = -this.m_angelPos.x;
                }
                this.m_angleImage.setPosition(this.m_angelPos);
                // this.m_angle = 180 - this.m_angle;
                // if (this.m_angle < 90)
                //     this.m_angle = -this.m_angle;
                // cc.log("bbbbbbbbbb ", this.m_angle);
                if (this.m_angle > 90) {
                    this.m_angleImage2.setRotation(180 + this.m_angle);
                }
                else {
                    this.m_angleImage2.setRotation(-this.m_angle);
                }
                this.m_angleImage2.setPosition(this.m_angelPos);
            }
            var range = Math.abs(data.maxAngle - data.minAngle) / 360 * 100;
            this.m_angleImage.setPercentage(range);
            cc.log(this.m_angle);
            this.m_angleNode.setPosition(this.m_angelPos2);
        };
        player.prototype.hideAngleImage = function () {
            this.m_angleImage.setPercentage(0);
            if (this.m_angleNode) {
                this.m_angleNode.setVisible(false);
            }
            if (this.m_angleImage2) {
                this.m_angleImage2.setVisible(false);
            }
            this.hideDots();
        };
        player.prototype.updateAngle = function (offset) {
            var data = this.m_weaon.getCurWeaponConfig();
            var newAngle = this.m_angle + offset;
            // cc.log("before : ", this.m_angle);
            if (this.getDir() < 0) {
                newAngle = this.m_angle - offset;
                if (newAngle < 90) {
                    newAngle = 180 - newAngle;
                }
                // cc.log("updateAngle before :",this.m_angle);
                // cc.log("aaaaa :"+data.maxAngle,"bbbbb :"+data.minAngle);
                if (newAngle < 180 - data.maxAngle)
                    newAngle = 180 - data.maxAngle;
                else if (newAngle > 180 - data.minAngle)
                    newAngle = 180 - data.minAngle;
            }
            else {
                if (newAngle > 90) {
                    newAngle = 180 - newAngle;
                }
                // cc.log("updateAngle before :",this.m_angle);
                // cc.log("aaaaa :"+data.maxAngle,"bbbbb :"+data.minAngle);
                if (newAngle > data.maxAngle)
                    newAngle = data.maxAngle;
                else if (newAngle < data.minAngle)
                    newAngle = data.minAngle;
            }
            this.m_angle = newAngle;
            this.updateAngleNode(newAngle);
            // cc.log("after : ", newAngle);
        };
        player.prototype.updateAngleNode = function (angle) {
            var angle2 = angle;
            if (this.m_angleNode) {
                if (angle > 90)
                    angle = 90 - angle;
                if (this.m_roledir < 0) {
                    angle = angle + 90;
                }
                var angletext = ccui.helper.seekWidgetByName(this.m_angleNode, "jiaodu");
                angletext.setString(Math.ceil(angle) + "°");
            }
            if (this.m_angleImage2) {
                this.m_angleImage2.setRotation(-angle2);
            }
        };
        player.prototype.hideDots = function () {
            if (this.m_DrawNode) {
                this.m_DrawNode.clear();
                this.m_DrawNode.setVisible(false);
            }
        };
        player.prototype.showDots = function () {
            if (this.m_DrawNode) {
                this.m_DrawNode.setVisible(true);
            }
        };
        player.prototype.drawDots = function (points) {
            if (game.dataMgr.getMe().getViplevel() > game.g_vip_unlock) {
                if (this.m_DrawNode == null) {
                    this.m_DrawNode = new cc.DrawNode();
                    this.addChild(this.m_DrawNode);
                }
            }
            this.m_DrawNode.clear();
            for (var i = 0; i < points.pointArr.length; ++i) {
                this.m_DrawNode.drawDot(pMult(pSub(points.pointArr[i], this.getPosition()), 1 / this.m_scale), 10, cc.color(255, 255, 255));
            }
        };
        return player;
    }(game.baseRole));
    game.player = player;
})(game || (game = {}));
//# sourceMappingURL=player.js.map