module game {
    export class RoundManager_ai extends RoundManager {
        public static g_instance: RoundManager_ai;
        m_timer: number; // 回合倒计时

        nextStep() {
            if(this.m_isOver) return;
            ui_selectWeapon.ShowOrHide(false);
            RoundManager_ai.gameEnd();
            if (ui_pvpwin.getMe() || ui_pvplose.getMe()) return;
            this.m_curRoleIndex++;
            if (this.m_curRoleIndex >= this.m_maxRoleIndex) {
                this.nextRound();
            }
            this.updateControlRole();
        }

        static gameEnd() {
            if(RoundManager.getMe().m_isOver) return;
            if (roleMgr.getMe().isMonsterAllDead()) {
                cc.log("胜利");
                RoundManager.getMe().m_isOver = true;
                ui_pvpwin.ShowOrHide(true);
            } else if (roleMgr.getMe().isPlayerAllDead()) {
                cc.log("失败");
                RoundManager.getMe().m_isOver = true;
                ui_pvplose.ShowOrHide(true);
            }
        }

        updateControlRole() {
            if(this.m_isOver) return;
            this.m_timer = 30;
            this.m_canHideTimer = false;
            playControl.getMe().setDefault();
            let role = roleMgr.getMe().m_AllRole_map.get(this.m_curRoleIndex);
            if (ui_zhandoujiemian.getMe()) {
                ui_zhandoujiemian.getMe().setuitexiao(role.m_name,role);
                ui_zhandoujiemian.getMe().setHP(role.getHp(),role.getMaxHp());
            }
            // if (role.m_debuffCount > 0) {
            //     role.m_debuffCount--;
            //     if (role.m_buffName) {
            //         let data = g_buff_config[role.m_buffName];
            //         role.onDamage_ex(data.shoujiSpine, data.shoujiAnimation, data.shoujiScale, data.damage);
            //     }
            // }
            if (role.isDead()) {
                this.nextStep();
                return;
            }
            role.setCurPower(role.getMaxPower());
            if (role instanceof player) {
                roleMgr.getMe().m_curRole = role;
                role.changeState_Ex(g_AiType.g_AiType_idle);
                uiMgr.getMe().show_OnceAnimation("round.json", function () {
                    ui_selectWeapon.ShowOrHide(true);
                }.bind(this));

                // if (ui_arraw.getMe()) {
                //     ui_arraw.getMe().setArrawPos(cc.pAdd(role.getPosition(), role.m_arrawPos));
                // }
            }
            cameraMgr.getMe().reset(role.getPosition(), role);
            if (role instanceof player_ai) {
                // bulletMgr.getMe().initDeleteBulletNum(g_weapon_play[role.getName()]["0"].shootNum);
                // role.m_controlerState.begin();
                role.begin();
            }
            if (ui_arraw.getMe()) {
                ui_arraw.getMe().setRole(role);
            }
        }

        loop(t){
            if(this.m_isOver) return;
            this.m_timer -= t;
            if(!this.m_canHideTimer){
                if(ui_zhandoujiemian.getMe()){
                    ui_zhandoujiemian.getMe().roundCountdown(this.m_timer);
                }
            }

            if( this.m_timer > 0){
                if (ui_zhandoujiemian.getMe()) {
                    if(roleMgr.getMe() == null){
                        return ;
                    }
                    if(roleMgr.getMe().getControlPlayer() == null){
                        return ;
                    }
                    let role = roleMgr.getMe().m_AllRole_map.get(this.m_curRoleIndex);
                    if(role.m_name != roleMgr.getMe().getControlPlayer().m_name){
                        return ;
                    }
                    ui_zhandoujiemian.getMe().setHP(role.getHp(), role.getMaxHp());
                }
            }
            if(this.m_timer <= 0){
                roleMgr.getMe().m_curRole.m_controlerState.m_isStayForce = false;
                this.nextStep();
            }
            if (ui_arraw.getMe())
                ui_arraw.getMe().setArrawPos();
        }
    }
}