module  game {

    export class playerAi_idle_ai extends playerAi_idle {
        m_object_role: player_ai;
    }

    export class playerAi_run_ai extends aiBase_run {
        m_object_role: player_ai;
        m_timer: number;
        m_once: boolean;
        m_range;

        randomRange() {
            let range = Math.floor(Math.random() * (this.m_object_role.m_attRange.x2 - this.m_object_role.m_attRange.x1)) + this.m_object_role.m_attRange.x1;
            this.m_range = {};
            this.m_range.x1 = range - 10;
            this.m_range.x2 = range + 10;
            // cc.log("this.m_range.x1",this.m_range.x1);
            // cc.log("this.m_range.x2",this.m_range.x2);
        }

        InternalEvent(key, data) {
            this.m_object_role.playAnimation("yidong", true);
            let p1 = this.m_object_role.getPosition();
            let dis = p1.x - this.m_object_role.m_target.getPosition().x;
            let x;
            if (dis < 0) {
                dis = -dis;
                x = -1;
            } else {
                x = 1;
            }
            if (dis > this.m_object_role.m_attRange.x2) {
                this.m_dir.x = -x;
            } else if (dis < this.m_object_role.m_attRange.x1) {
                this.m_dir.x = x;
            }
            this.m_object_role.setDir(this.m_dir.x);
            this.m_timer = 0;
            this.m_once = true;
            this.randomRange();
            return true;
        }

        move(newpos: cc.Vec2) {
            super.move(newpos);
            let dis = Math.abs(this.m_object_role.getPosition().x - this.m_object_role.m_target.getPosition().x);
            if (dis > this.m_range.x1 && dis < this.m_range.x2) {
                if (this.m_once) {
                    this.m_once = false;
                    this.m_object_role.changeState(g_AiType.g_AiType_att);
                }
            }
        }

        update(dt) {
            let x = this.m_object_role.getPosition().x;
            super.update(dt);
            if (this.m_timer > 10) {
                if (this.m_once) {
                    this.m_once = false;
                    this.m_object_role.changeState(g_AiType.g_AiType_att);
                }
                return true;
            }
            if (x == this.m_object_role.getPosition().x) {
                this.m_timer++;
            }

            // if(ui_arraw.getMe()){
            //     ui_arraw.getMe().setArrawPos(cc.pAdd(this.m_object_role.getPosition(),this.m_object_role.m_arrawPos));
            // }
            return true;
        }
    }

    export class playerAi_dead_ai extends playerAi_dead {
        m_object_role: player_ai;

        InternalEvent(key, data) {
            this.m_object_role.stopMoveRootBone(0);
            this.m_object_role.m_SpineNode.setToSetupPose();
            if (this.m_object_role.m_animaEnd) {
                this.m_object_role.playAnimation("siwang", false);
            }
            // roleMgr.getMe().deleteTarget(this.m_object_role.getId());
            this.m_once = true;

            if (this.m_object_role.m_skin.getSkillName() == "yinshen") {
                // this.m_object_role.m_SpineNode.getNode().opacity = 255;
                this.m_object_role.showBody();
            }
            // this.m_object_role.m_SpineNode.setTimeScale(2);
            roleMgr.getMe().m_hasDead = true;
            roleMgr.getMe().m_deadNum_monster++;
            return true;
        }

        Complete() {
            this.m_object_role.startResetPosition();
            this.m_object_role.m_canDelete = true;
            if (this.m_once) {
                this.m_once = false;
                // this.m_object_role.m_debuffCount = 0;
                // this.m_object_role.m_buffName = "";
                // this.m_object_role.m_SpineNode.setTimeScale(1);
                if (this.m_object_role.m_skin.getPanda()) {
                    this.m_object_role.setHp(this.m_object_role.getMaxHp() * this.m_object_role.m_skin.getShuzhi1());
                    this.m_object_role.changeState_Ex(g_AiType.g_AiType_idle);
                    let ret = spineMgr.getMe().createSpineOncePlay("fuhuotxiao","animation",this.m_object_role.getNode(),this.m_object_role.getPosition(),9999999);
                    ret.setPosition(g_other_config.fuhuo.pos);
                    ret.setScale(g_other_config.fuhuo.scale);
                    return true;
                }
                this.m_object_role.playAnimation("mudi", true);
            }
            return true;
        }
    }

    export class playerAi_ptgongji1_ai extends playerAi_ptgongji1 {
        m_angle: number;
        m_object_role: player_ai;

        InternalEvent(key, data) {
            this.m_once = true;
            this.m_object_role.playAnimation(this.m_object_role.m_weaon.getCurWeaponAnima(), false);
            this.m_object_role.m_animaEnd = false;

            if (this.m_object_role.m_skin.getSkillName() == "yinshen") {
                // this.m_object_role.m_SpineNode.getNode().opacity = 255;
                this.m_object_role.showBody();
            }
            this.initFireAngle();
            if (this.m_object_role.m_item.isYaoji2() && !this.m_object_role.m_item.m_used) {
                return true;
            }
            this.m_object_role.nextRound(false);
            return true;
        }

        initFireAngle() {
            let pos = this.m_object_role.m_target.getPosition();
            let rolePos: cc.Vec2 = this.m_object_role.getPosition();
            if (pos.x > rolePos.x) {
                this.m_object_role.setDir(1);
            } else {
                this.m_object_role.setDir(-1);
            }
            let disControl = this.updateFireAngle(this.m_object_role.m_weaon.getCurWeaponConfig().maxAngle, -1,new DistanceControl());
            this.m_angle = disControl.getMinAngel();
            disControl.clearDis();
            cc.log("目标：", this.m_object_role.m_target.getName());
            cc.log("angle", this.m_angle);
            let rank = dataMgr.getMe().getRank();
            if(rank > 1000){
                this.m_angle += Math.random() < 0.5 ? 3 : -3;
            }
            else if(rank > 100){
                this.m_angle += Math.random() < 0.5 ? 1 : -1;
            }
            cc.log("angle", this.m_angle);
            if(this.m_object_role.m_target.m_skin.getSkillName() == "yinshen"){
                let shuzhi = this.m_object_role.m_target.m_skin.getShuzhi1();
                this.m_angle += Math.random() < 0.5 ? shuzhi : -shuzhi;
                cc.log("yinshen shuzhi:", shuzhi);
                cc.log("yinshen angle:", this.m_angle);
            }
            // this.m_object_role.m_target = null;
        }

        updateFireAngle(angle, count, disCtr) {
            let rolePos: cc.Vec2 = this.m_object_role.getBoneWroldPosition("paokou1");
            let weaponData = this.m_object_role.m_weaon.getCurWeaponConfig();
            let pos = this.m_object_role.m_target.getBoneWroldPosition("shoujizudang");
            let dir = cc.pForAngle(cc.degreesToRadians(angle));
            let dis = rolePos.x - pos.x;
            let Vx = dir.x * (weaponData.speedMax + weaponData.speedMin) / 2;
            let t = Math.abs(dis / Vx);
            let g = weaponData.g;
            let newDis = Math.abs(pos.y - monsterAi_ptgongji1.getPos(rolePos, t, g, dir, (weaponData.speedMax + weaponData.speedMin) / 2).y);
            disCtr.setDis(angle,newDis);
            angle += count;
            if (angle < weaponData.minAngle) {
                return disCtr;
            }
            return this.updateFireAngle(angle, count, disCtr);
        }

        getBulletData() {
            let pos: cc.Vec2 = this.m_object_role.getBoneWroldPosition("paokou1");
            let weaponData = this.m_object_role.m_weaon.getCurWeaponConfig();
            let weaponData2 = this.m_object_role.m_weaon.getCurWeaponConfig2();
            let data: BulletData = new BulletData();
            data.scale = weaponData.scale;
            data.speedMin = weaponData.speedMin;
            data.speedMax = weaponData.speedMax;
            data.earthDamage = weaponData.earthDamage;
            data.g = weaponData.g;
            data.hard = weaponData.hard;
            data.boomRange = weaponData.boomRange;

            data.res = weaponData2.res;
            data.resAnimation = weaponData2.resAnimation;
            data.boomSpine = weaponData2.boomSpine;
            data.boomAnimation = weaponData2.boomAnimation;
            data.boomScale = weaponData2.boomScale;
            data.shoujiSpine = weaponData2.shoujiSpine;
            data.shoujiAnimation = weaponData2.shoujiAnimation;
            data.shoujiScale = weaponData2.shoujiScale;
            data.damageType = weaponData2.damageType;
            data.filpX = weaponData2.filpX;
            //shootNum 减少子弹数

            data.m_pos = pos;
            data.m_speed = (weaponData.speedMax + weaponData.speedMin) / 2;
            data.m_angle = this.m_angle;
            data.m_roledir = this.m_object_role.getDir();
            data.m_dir = this.fixDir(cc.pForAngle(cc.degreesToRadians(data.m_angle)));
            data.m_roleId = this.m_object_role.m_index;
            data.m_isplayer = this.m_object_role instanceof player;

            return data;
        }

        OnFireBullet() {
            let data = this.getBulletData();
            if (this.m_object_role.m_weaon.getWeaponSkill() == "launch") {
                data.m_pos = cc.p(g_other_config.paokou1);
                if (this.m_object_role.getDir() < 0) {
                    data.m_pos.x += 2 * g_other_config.paokou2.x;
                }
                data.m_angle = this.getCloseRoleAngle(data.m_pos);
                data.m_dir = this.fixDir(cc.pForAngle(cc.degreesToRadians(data.m_angle)));
            }
            else if (this.m_object_role.m_weaon.getWeaponSkill() == "launch2") {
                data.m_pos = cc.p(g_other_config.paokou2);
                data.m_angle = -90;
                data.m_dir = this.fixDir(cc.pForAngle(cc.degreesToRadians(data.m_angle)));
            }
            this.createBullet(data);
            if (this.m_object_role.m_item.isYaoji3()) {
                let data2 = cc.copy(data);
                data2.m_angle = data.m_angle + 5;
                data2.m_dir = this.fixDir(cc.pForAngle(cc.degreesToRadians(data2.m_angle)));
                this.createBullet(data2);

                let data3 = cc.copy(data);
                data3.m_angle = data.m_angle - 5;
                data3.m_dir = this.fixDir(cc.pForAngle(cc.degreesToRadians(data3.m_angle)));
                this.createBullet(data3);
            }
            if (this.m_object_role.m_item.isYaoji2() && this.m_object_role.m_item.m_used) return;
            this.m_object_role.m_weaon.reduceCurWeaponBulletNum();
        }

        createBullet(data){
            if (this.m_object_role.m_weaon.getWeaponSkill() == "blink") {
                bulletMgr.getMe().creatBlinkBullet(data);
            }
            else if (this.m_object_role.m_weaon.getWeaponSkill() == "heal") {
                bulletMgr.getMe().creatHealBullet(data);
            }
            else if (this.m_object_role.m_weaon.getWeaponSkill() == "posion") {
                bulletMgr.getMe().creatPosionBullet(data);
            }
            else if (this.m_object_role.m_weaon.getWeaponSkill() == "cross") {
                bulletMgr.getMe().creatCrossBullet(data);
            }
            else if (this.m_object_role.m_weaon.getWeaponSkill() == "launch") {
                bulletMgr.getMe().creatLaunchBullet(data);
            }
            else if (this.m_object_role.m_weaon.getWeaponSkill() == "launch2") {
                bulletMgr.getMe().creatLaunchBullet2(data);
            }
            else {
                bulletMgr.getMe().createBullet(data);
            }
        }

        getCloseRoleAngle(bulletPos:cc.Vec2){
            let temp: number = 10000;
            let pos:cc.Vec2;
            let rolePos:cc.Vec2;
            let role:monster;
            let roleMap;
            roleMap = roleMgr.getMe().m_player_map;
            for (let i = 0; i < roleMap.size; ++i) {
                role = roleMap.getByIndex(i);
                if (role.isDead()) continue;
                rolePos = role.getPosition();
                let dis = cc.pDistance(rolePos, this.m_object_role.getPosition());
                if (dis < temp) {
                    temp = dis;
                    pos = rolePos;
                }
            }
            if(rolePos){
                return cc.radiansToDegrees(cc.pToAngle(cc.pSub(rolePos,bulletPos)));
            }
            return -90;
        }
    }

    export class playerAi_beiji_ai extends playerAi_beiji {
        m_object_role: player_ai;
    }

}