/**
 * 武器
 */
var game;
(function (game) {
    var playWeapon_ai = (function () {
        function playWeapon_ai(role, type) {
            this.m_des = "playWeapon_ai";
            this.init(role.getName(), type);
            this.m_object_role = role;
        }
        playWeapon_ai.prototype.init = function (heroName, type) {
            var _this = this;
            var weaponsData;
            if (type == 1) {
                weaponsData = game.proto_pvpLogin.getMe().m_data.weapon1;
            }
            else {
                weaponsData = game.proto_pvpLogin.getMe().m_data.weapon2;
            }
            this.m_weaponsPlayData = new game.Map();
            for (var i = 0; i < weaponsData.length; ++i) {
                var weaponData = new game.WeaponData();
                weaponData.name = weaponsData[i];
                if (heroName == "nv") {
                    weaponData.level = game.dataMgr.getMe().getweaponlevel(weaponsData[i] + "_1");
                }
                else {
                    weaponData.level = game.dataMgr.getMe().getweaponlevel(weaponsData[i]);
                }
                weaponData.num = game.dataMgr.getMe().getWeaponconfig(weaponData.name)[weaponData.level].bulletNum;
                this.m_weaponsPlayData.set(weaponData.name, weaponData);
            }
            this.m_weaponsNameArr = new Array();
            this.m_weaponsPlayData.forEach(function (v, k) {
                cc.log(v.toString(), k);
                _this.m_weaponsNameArr.push(k);
            }, this);
            this.addStoneWeapon();
            this.m_weaponConfig = {};
            var name;
            for (var i = 0; i < this.m_weaponsNameArr.length; ++i) {
                name = this.m_weaponsNameArr[i];
                this.m_weaponConfig[name] = game.getWeaponConfig()[name];
            }
            if (!this.hasWeaponByName(this.m_curWeaponName)) {
                this.m_curWeaponName = this.m_weaponsNameArr[0];
            }
        };
        playWeapon_ai.prototype.addStoneWeapon = function () {
            var data = new game.WeaponData();
            data.name = "wuqi1";
            data.level = 0;
            data.num = 99;
            this.m_weaponsPlayData.set("wuqi1", data);
            this.m_weaponsNameArr.push("wuqi1");
        };
        playWeapon_ai.prototype.isNotDraw = function () {
            return false;
        };
        playWeapon_ai.prototype.getCurWeaponAnima = function () {
            return this.m_weaponConfig[this.m_curWeaponName].roleAnimation2;
        };
        playWeapon_ai.prototype.getCurWeaponAttachmentImage = function () {
            return this.m_weaponConfig[this.m_curWeaponName].roleBujian;
        };
        playWeapon_ai.prototype.getCurWeaponConfig = function () {
            var data = this.m_weaponsPlayData.get(this.m_curWeaponName);
            if (!data) {
                cc.error("getCurWeaponConfig error", this.m_curWeaponName);
                return this.m_weaponConfig[this.m_curWeaponName]["0"];
            }
            return this.m_weaponConfig[this.m_curWeaponName][data.level];
        };
        playWeapon_ai.prototype.getCurWeaponConfig2 = function () {
            return this.m_weaponConfig[this.m_curWeaponName];
        };
        playWeapon_ai.prototype.setCurWeapon = function () {
            this.m_object_role.initAngle();
            var r = Math.floor(Math.random() * (this.m_weaponsNameArr.length - 1));
            var name = this.m_weaponsNameArr[r];
            if (this.getWeaponBulletNumByName(name) <= 0) {
                name = "wuqi1";
            }
            this.m_curWeaponName = name;
        };
        playWeapon_ai.prototype.hasWeaponByName = function (name) {
            for (var i = 0; i < this.m_weaponsNameArr.length; ++i) {
                if (this.m_weaponsNameArr[i] == name) {
                    return true;
                }
            }
            return false;
        };
        playWeapon_ai.prototype.getWeaponDataByName = function (name) {
            return this.m_weaponsPlayData.get(name);
        };
        playWeapon_ai.prototype.resetWeaponBulletNumByName = function (name) {
            this.m_weaponsPlayData.get(name).num = this.m_weaponsPlayData.get(name).maxNum;
        };
        playWeapon_ai.prototype.reduceCurWeaponBulletNum = function () {
            if (this.getWeaponSkill() == "noLimit")
                return;
            var num = this.m_weaponsPlayData.get(this.m_curWeaponName).num--;
            if (num < 0) {
                this.m_weaponsPlayData.get(this.m_curWeaponName).num = 0;
            }
            game.ui_zhandoujiemian.getMe().initPlayerDataUI();
        };
        playWeapon_ai.prototype.getWeaponBulletNumByName = function (name) {
            return this.m_weaponsPlayData.get(name).num;
        };
        playWeapon_ai.prototype.shutdown = function () {
            // 数据和存档同步  当前武器
            this.m_object_role = null;
            this.m_weaponsPlayData.clear();
            this.m_weaponsPlayData = null;
            this.m_weaponsNameArr = null;
            this.m_weaponConfig = null;
        };
        playWeapon_ai.prototype.getWeaponSkill = function () {
            return this.m_weaponConfig[this.m_curWeaponName].teshu;
        };
        return playWeapon_ai;
    }());
    game.playWeapon_ai = playWeapon_ai;
})(game || (game = {}));
//# sourceMappingURL=playWeapon_ai.js.map