/**
 * 武器
 */
module game {
    export class playWeapon_ai {
        m_des: string;
        m_weaponsPlayData: Map<string,WeaponData>;
        m_curWeaponName: string;
        m_weaponsNameArr: Array<string>;
        m_weaponConfig;
        m_object_role: player_ai;

        constructor(role: player_ai,type) {
            this.m_des = "playWeapon_ai";
            this.init(role.getName(),type);
            this.m_object_role = role;
        }

        init(heroName: string,type) {
            let weaponsData;
            if(type == 1){
                weaponsData = proto_pvpLogin.getMe().m_data.weapon1;
            }else{
                weaponsData = proto_pvpLogin.getMe().m_data.weapon2;
            }
            this.m_weaponsPlayData = new Map<string,WeaponData>();
            for (let i = 0; i < weaponsData.length; ++i) {
                let weaponData = new WeaponData();
                weaponData.name = weaponsData[i];
                if(heroName == "nv"){
                    weaponData.level = dataMgr.getMe().getweaponlevel(weaponsData[i] + "_1");
                }else{
                    weaponData.level = dataMgr.getMe().getweaponlevel(weaponsData[i]);
                }
                weaponData.num = dataMgr.getMe().getWeaponconfig(weaponData.name)[weaponData.level].bulletNum;
                this.m_weaponsPlayData.set(weaponData.name, weaponData);
            }

            this.m_weaponsNameArr = new Array<string>();
            this.m_weaponsPlayData.forEach((v, k) => {
                cc.log(v.toString(), k);
                this.m_weaponsNameArr.push(k);
            }, this);

            this.addStoneWeapon();

            this.m_weaponConfig = {};
            let name;
            for (let i = 0; i < this.m_weaponsNameArr.length; ++i) {
                name = this.m_weaponsNameArr[i];
                this.m_weaponConfig[name] = getWeaponConfig()[name];
            }

            if(!this.hasWeaponByName(this.m_curWeaponName)){
                this.m_curWeaponName = this.m_weaponsNameArr[0];
            }
        }

        addStoneWeapon(){
            let data = new WeaponData();
            data.name = "wuqi1";
            data.level = 0;
            data.num = 99;
            this.m_weaponsPlayData.set("wuqi1", data);
            this.m_weaponsNameArr.push("wuqi1");
        }

        isNotDraw(){
            return false;
        }

        getCurWeaponAnima(){
            return this.m_weaponConfig[this.m_curWeaponName].roleAnimation2;
        }

        getCurWeaponAttachmentImage(){
            return this.m_weaponConfig[this.m_curWeaponName].roleBujian;
        }

        getCurWeaponConfig() {
            let data = this.m_weaponsPlayData.get(this.m_curWeaponName);
            if(!data){
                cc.error("getCurWeaponConfig error",this.m_curWeaponName);
                return this.m_weaponConfig[this.m_curWeaponName]["0"];
            }
            return this.m_weaponConfig[this.m_curWeaponName][data.level];
        }

        getCurWeaponConfig2() {
            return this.m_weaponConfig[this.m_curWeaponName];
        }

        setCurWeapon() {
            this.m_object_role.initAngle();
            let r = Math.floor(Math.random() * (this.m_weaponsNameArr.length - 1));
            let name = this.m_weaponsNameArr[r];
            if(this.getWeaponBulletNumByName(name) <= 0){
                name = "wuqi1";
            }
            this.m_curWeaponName = name;
        }

        hasWeaponByName(name: string) {
            for (let i = 0; i < this.m_weaponsNameArr.length; ++i) {
                if (this.m_weaponsNameArr[i] == name) {
                    return true;
                }
            }
            return false;
        }

        getWeaponDataByName(name: string): WeaponData {
            return this.m_weaponsPlayData.get(name);
        }

        resetWeaponBulletNumByName(name){
            this.m_weaponsPlayData.get(name).num = this.m_weaponsPlayData.get(name).maxNum;
        }

        reduceCurWeaponBulletNum() {
            if(this.getWeaponSkill() == "noLimit") return;
            let num = this.m_weaponsPlayData.get(this.m_curWeaponName).num--;
            if (num < 0) {
                this.m_weaponsPlayData.get(this.m_curWeaponName).num = 0;
            }
            ui_zhandoujiemian.getMe().initPlayerDataUI();
        }

        getWeaponBulletNumByName(name) {
            return this.m_weaponsPlayData.get(name).num;
        }

        shutdown(){
            // 数据和存档同步  当前武器
            this.m_object_role = null;
            this.m_weaponsPlayData.clear();
            this.m_weaponsPlayData = null;
            this.m_weaponsNameArr = null;
            this.m_weaponConfig = null;
        }

        getWeaponSkill(){
            return this.m_weaponConfig[this.m_curWeaponName].teshu;
        }
    }
}