var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
// 角色管理类
var game;
(function (game) {
    var roleMgr_ai = (function (_super) {
        __extends(roleMgr_ai, _super);
        function roleMgr_ai() {
            _super.apply(this, arguments);
        }
        roleMgr_ai.prototype.initMap = function () {
            this.m_player_map = new game.Map();
            this.m_matcher_map = new game.Map();
            this.m_AllRole_map = new game.Map();
        };
        roleMgr_ai.prototype.isMonsterAllDead = function () {
            return this.m_deadNum_monster == this.m_matcher_map.size;
        };
        roleMgr_ai.prototype.getBirthPos = function (player_birth, oldPos, name) {
            var count = 0;
            for (var p in player_birth) {
                count++;
            }
            count /= 2;
            var r = Math.floor(Math.random() * count) + 1;
            var pos = player_birth[name + "_" + r];
            if (pos == oldPos) {
                return this.getBirthPos(player_birth, oldPos, name);
            }
            return pos;
        };
        // 出生位置 初始角色
        roleMgr_ai.prototype.initroleMgr = function (sceneinfo) {
            this.initMap();
            var player_birth = cc.copy(game.g_birth_config[sceneinfo.hero_birth]);
            var pos = this.getBirthPos(player_birth, cc.p(0, 0), "hero");
            this.m_curRole = this.createPlayer(game.dataMgr.getMe().getPlayDoc().coreData.curHero, pos);
            var roleName = game.proto_pvpLogin.getMe().m_data.roleName1;
            var pos2 = this.getBirthPos(player_birth, cc.p(0, 0), "enemy");
            this.createMatcher(roleName, pos2, 1);
            if (game.dataMgr.getMe().getPlayDoc().coreData.curFollower) {
                pos = this.getBirthPos(player_birth, pos, "hero");
                this.createPlayer(game.dataMgr.getMe().getPlayDoc().coreData.curFollower, pos);
                // roleName = roleName == "nan" ? "nv" : "nan";
                roleName = game.proto_pvpLogin.getMe().m_data.roleName2;
                pos2 = this.getBirthPos(player_birth, pos2, "enemy");
                this.createMatcher(roleName, pos2, 2);
            }
            game.cameraMgr.getMe().reset(this.m_curRole.getPosition(), this.m_curRole);
            if (game.ui_zhandoujiemian.getMe()) {
                game.ui_zhandoujiemian.getMe().initAiDataUI();
                game.ui_zhandoujiemian.getMe().initPlayerDataUI();
            }
            this.m_deadNum_monster = 0;
            this.m_deadNum_player = 0;
            this.m_hasDead = false;
            game.ui_arraw.ShowOrHide(true);
            game.RoundManager.getMe().start();
        };
        roleMgr_ai.prototype.createMatcher = function (heroname, pos, type) {
            var l_player = new game.player_ai();
            l_player.init(heroname, type);
            l_player.setPosition(pos);
            this.addChild(l_player.getNode(), 2000);
            this.m_matcher_map.set(l_player.__instanceId, l_player);
            this.m_AllRole_map.set(game.RoundManager.getMe().m_maxRoleIndex, l_player);
            l_player.m_index = game.RoundManager.getMe().m_maxRoleIndex++;
            return l_player;
        };
        roleMgr_ai.prototype.shutdown = function () {
            if (game.ui_arraw.getMe()) {
                game.ui_arraw.ShowOrHide(false);
            }
            if (game.playControl.getMe()) {
                game.playControl.getMe().shutdown();
            }
            this.m_AllRole_map.forEach(function (v, k) {
                v.shutdown();
            }, this);
            this.m_AllRole_map.clear();
            this.m_matcher_map.clear();
            this.m_player_map.clear();
        };
        //暂停动画
        roleMgr_ai.prototype.zanting = function (falg) {
            this.m_AllRole_map.forEach(function (v, k) {
                v.zanting(falg);
            }, this);
        };
        roleMgr_ai.prototype.update = function (t) {
            this.m_AllRole_map.forEach(function (v, k) {
                v.update(t);
            }, this);
        };
        return roleMgr_ai;
    }(game.roleMgr));
    game.roleMgr_ai = roleMgr_ai;
})(game || (game = {}));
//# sourceMappingURL=roleMgr_ai.js.map 
//# sourceMappingURL=roleMgr_ai.js.map