// 角色管理类
module game {

    export class roleMgr_ai extends roleMgr {
        m_matcher_map: Map<number, player_ai>;

        initMap() {
            this.m_player_map = new Map<number, player>();
            this.m_matcher_map = new Map<number, player_ai>();
            this.m_AllRole_map = new Map<number, baseRole>();
        }

        isMonsterAllDead() {
            return this.m_deadNum_monster == this.m_matcher_map.size;
        }

        getBirthPos(player_birth, oldPos, name) {
            let count: number = 0;
            for (let p in player_birth) {
                count++;
            }
            count /= 2;
            let r = Math.floor(Math.random() * count) + 1;
            let pos = player_birth[name + "_" + r];
            if (pos == oldPos) {
                return this.getBirthPos(player_birth, oldPos, name);
            }
            return pos;
        }

        // 出生位置 初始角色
        initroleMgr(sceneinfo: scene_config_data_s) {
            this.initMap();
            let player_birth = cc.copy(g_birth_config[sceneinfo.hero_birth]);
            let pos = this.getBirthPos(player_birth, cc.p(0, 0), "hero");
            this.m_curRole = this.createPlayer(dataMgr.getMe().getPlayDoc().coreData.curHero, pos);

            let roleName = proto_pvpLogin.getMe().m_data.roleName1;
            let pos2 = this.getBirthPos(player_birth, cc.p(0, 0), "enemy");
            this.createMatcher(roleName, pos2,1);

            if (dataMgr.getMe().getPlayDoc().coreData.curFollower) {
                pos = this.getBirthPos(player_birth, pos, "hero");
                this.createPlayer(dataMgr.getMe().getPlayDoc().coreData.curFollower, pos);

                // roleName = roleName == "nan" ? "nv" : "nan";
                roleName = proto_pvpLogin.getMe().m_data.roleName2;
                pos2 = this.getBirthPos(player_birth, pos2, "enemy");
                this.createMatcher(roleName, pos2,2);
            }
            cameraMgr.getMe().reset(this.m_curRole.getPosition(), this.m_curRole);

            if (ui_zhandoujiemian.getMe()){
                ui_zhandoujiemian.getMe().initAiDataUI();
                ui_zhandoujiemian.getMe().initPlayerDataUI();
            }
            this.m_deadNum_monster = 0;
            this.m_deadNum_player = 0;
            this.m_hasDead = false;
            ui_arraw.ShowOrHide(true);

            RoundManager.getMe().start();
        }

        createMatcher(heroname: string, pos: cc.Vec2,type): player_ai {
            let l_player = new player_ai();
            l_player.init(heroname,type);
            l_player.setPosition(pos);
            this.addChild(l_player.getNode(), 2000);
            this.m_matcher_map.set(l_player.__instanceId, l_player);
            this.m_AllRole_map.set(RoundManager.getMe().m_maxRoleIndex, l_player);
            l_player.m_index = RoundManager.getMe().m_maxRoleIndex++;
            return l_player;
        }

        shutdown() {
            if (ui_arraw.getMe()) {
                ui_arraw.ShowOrHide(false);
            }
            if (playControl.getMe()) {
                playControl.getMe().shutdown();
            }
            this.m_AllRole_map.forEach(function (v, k) {
                v.shutdown();
            }, this);
            this.m_AllRole_map.clear();
            this.m_matcher_map.clear();
            this.m_player_map.clear();
        }

        //暂停动画
        zanting(falg) {
            this.m_AllRole_map.forEach(function (v, k) {
                v.zanting(falg);
            }, this);
        }

        update(t) {
            this.m_AllRole_map.forEach(function (v: baseRole, k) {
                v.update(t);
            }, this);
        }

    }
}
//# sourceMappingURL=roleMgr_ai.js.map