module game {
    export class RoundManager_pvp extends RoundManager {
        public static g_instance: RoundManager_pvp;
        m_timer: number = 30; // 回合倒计时
        m_isP1: boolean;

        init() {
            super.init();
            this.m_isP1 = false;
        }

        start() {
            if(this.m_isOver) return;
            this.m_timer = 30;
            this.m_isP1 = true;
            this.updateControlRole();
        }

        nextStep() {
            if(this.m_isOver) return;
            if (this.m_isP1) {
                RoundManager_pvp.gameEnd();
                if (ui_pvpwin.getMe() || ui_pvplose.getMe()) return false;
                this.m_curRoleIndex++;
                this.nextStepEx();
                sync_round.getMe().send(this.m_curRoleIndex);
            }
        }

        nextStepEx() {
            if(this.m_isOver) return;
            ui_selectWeapon.ShowOrHide(false);
            if (this.m_curRoleIndex >= this.m_maxRoleIndex) {
                this.nextRound();
            }
            this.updateControlRole();
        }


        static gameEnd() {
            if(RoundManager.getMe().m_isOver) return;
            if (roleMgr.getMe().isMonsterAllDead()) {
                cc.log("胜利");
                RoundManager.getMe().m_isOver = true;
                sync_result.getMe().send(0);
                ui_pvpwin.ShowOrHide(true);
            } else if (roleMgr.getMe().isPlayerAllDead()) {
                cc.log("失败");
                RoundManager.getMe().m_isOver = true;
                sync_result.getMe().send(1);
                ui_pvplose.ShowOrHide(true);
            }
        }

        updateControlRole() {
            if(this.m_isOver) return;
            this.m_timer = 30;
            this.m_canHideTimer = false;
            playControl.getMe().setDefault();
            let role = roleMgr.getMe().m_AllRole_map.get(this.m_curRoleIndex);
            if (ui_zhandoujiemian.getMe()) {
                ui_zhandoujiemian.getMe().setuitexiao(role.m_name,role);
                ui_zhandoujiemian.getMe().setHP(role.getHp(),role.getMaxHp());
            }
            // if (role.m_debuffCount > 0) {
            //     role.m_debuffCount--;
            //     if (role.m_buffName) {
            //         let data = g_buff_config[role.m_buffName];
            //         role.onDamage_ex(data.shoujiSpine, data.shoujiAnimation, data.shoujiScale, data.damage);
            //     }
            // }
            if (role.isDead()) {
                this.nextStep();
                return;
            }
            role.setCurPower(role.getMaxPower());
            if (role instanceof player) {
                roleMgr.getMe().m_curRole = role;
                role.changeState_Ex(g_AiType.g_AiType_idle);
                uiMgr.getMe().show_OnceAnimation("round.json", function () {
                    ui_selectWeapon.ShowOrHide(true);
                }.bind(this));

            }
            cameraMgr.getMe().reset(role.getPosition(), role);
            if (role instanceof player_pvp) {
                // bulletMgr.getMe().initDeleteBulletNum(g_weapon_play[role.getName()]["0"].shootNum);
                // role.m_controlerState.begin();
                // role.begin();
                role.m_item.useCurItem();
            }
            cc.log("当前的角色是：",role.m_index);
            // if (ui_arraw.getMe()) {
            //     ui_arraw.getMe().setRole(role);
            // }
        }

        loop(t) {
            if(this.m_isOver) return;
            this.m_timer -= t;
            if(!this.m_canHideTimer){
                if(ui_zhandoujiemian.getMe()){
                    ui_zhandoujiemian.getMe().roundCountdown(this.m_timer);
                }
            }
            if (!this.m_isP1) return;
            if( this.m_timer > 0){
                if (ui_zhandoujiemian.getMe()) {
                    if(roleMgr.getMe() == null){
                        return ;
                    }
                    if(roleMgr.getMe().getControlPlayer() == null){
                        return ;
                    }
                    let role = roleMgr.getMe().m_AllRole_map.get(this.m_curRoleIndex);
                    if(role.m_name != roleMgr.getMe().getControlPlayer().m_name){
                        return ;
                    }
                    ui_zhandoujiemian.getMe().setHP(role.getHp(), role.getMaxHp());
                }
            }

            if (this.m_timer <= 0) {
                roleMgr.getMe().getControlPlayer().m_controlerState.m_isStayForce = false;
                this.nextStep();
            }
            // if (ui_arraw.getMe())
            //     ui_arraw.getMe().setArrawPos();
        }
    }
}