/**
 * 装逼时装
 */
module game {
    export class playSkin_pvp {
        m_des: string;
        m_object_role: player_pvp;
        m_skinData;
        m_onceFuhuo: boolean;

        constructor(player: player_pvp, type) {
            this.m_des = "playSkin_pvp";
            this.m_object_role = player;
            this.init(type);
        }

        shutdown() {
            this.m_object_role = null;
            this.m_skinData = null;
        }

        init(type) {
            let heroName = this.m_object_role.getName();
            let pifu;
            let data = proto_fightPVP.getMe().m_data;
            if (this.m_object_role.getName() == data.curHero.name) {
                pifu = data.curHero.skin;
            } else {
                pifu = data.curFollower.skin;
            }
            this.m_skinData = dataMgr.getMe().getSkinConfig(pifu, heroName);
            this.setSkin(this.m_skinData.skin);
            this.m_onceFuhuo = false;
        }

        setSkin(name: string) {
            this.m_object_role.m_SpineNode.setSkin(name);
        }

        getAtt() {
            return this.m_skinData.damage;
        }

        getHp() {
            return this.m_skinData.hp;
        }

        getDef() {
            return this.m_skinData.damageRes;
        }

        getPower() {
            return this.m_skinData.power;
        }

        getCritRate() {
            return this.m_skinData.critRate;
        }

        getSkillName() {
            return this.m_skinData.skill;
        }

        getShuzhi1() {
            return this.m_skinData.shuzhi1;
        }

        getShuzhi2() {
            return this.m_skinData.shuzhi2;
        }

        getShuzhi1_bear() {
            return this.m_skinData.shuzhi1 * (RoundManager.getMe().m_round + 1);
        }

        getShuzhi2_bear() {
            return this.m_skinData.shuzhi2 * (RoundManager.getMe().m_round + 1);
        }

        getPanda() {
            if (this.m_skinData.skill == "guobao") {
                if (!this.m_onceFuhuo) {
                    this.m_onceFuhuo = true;
                    return true;
                }
            }
            return false;
        }
    }
}