/**
 * 装逼头衔
 */
module game {
    export class playTitle_pvp {
        m_des: string;
        m_object_role: player_pvp;
        m_titleData;

        constructor(player: player_pvp, type) {
            this.m_des = "playTitle_pvp";
            this.m_object_role = player;
            this.init(type);
        }

        shutdown() {
            this.m_object_role = null;
            this.m_titleData = null;
        }

        init(type) {
            let title;
            let level;
            let data = proto_fightPVP.getMe().m_data;
            if (this.m_object_role.getName() == data.curHero.name) {
                title = data.curHero.title;
                level = data.curHero.titleLevel;
            } else {
                title = data.curFollower.title;
                level = data.curFollower.titleLevel;
            }
            if (title == -1 || level < 1) {
                this.defaultData();
                return;
            }
            this.m_titleData = g_chenghao_config[title][level];
        }

        defaultData() {
            this.m_titleData = {};
            this.m_titleData.damage = 0;
            this.m_titleData.hp = 0;
            this.m_titleData.def = 0;
            this.m_titleData.power = 0;
            this.m_titleData.damageUp = 0;
            this.m_titleData.boomRes = 0;
            this.m_titleData.expUp = 0;
            this.m_titleData.damageRes = 0;
            this.m_titleData.powerUp = 0;
            this.m_titleData.goldUp = 0;
        }

        getAtt() {
            return this.m_titleData.damage;
        }

        getHp() {
            return this.m_titleData.hp;
        }

        getDef() {
            return this.m_titleData.def;
        }

        getPower() {
            return this.m_titleData.power;
        }

        getAttPer() {
            return this.m_titleData.damageUp;
        }

        getBoomDefPer() {
            return this.m_titleData.boomRes;
        }

        getExpPer() {
            return this.m_titleData.expUp;
        }

        getDefPer() {
            return this.m_titleData.damageRes;
        }

        getPowerPer() {
            return this.m_titleData.powerUp;
        }

        getGoldPer() {
            return this.m_titleData.goldUp;
        }
    }
}