/**
 * 武器
 */
var game;
(function (game) {
    var playWeapon_pvp = (function () {
        function playWeapon_pvp(role) {
            this.m_des = "playWeapon_pvp";
            this.init(role.getName());
            this.m_object_role = role;
        }
        playWeapon_pvp.prototype.init = function (heroName) {
            var _this = this;
            var weaponsData;
            var data = game.proto_fightPVP.getMe().m_data;
            if (heroName == data.curHero.name) {
                weaponsData = data.curHero.weapon;
            }
            else {
                weaponsData = data.curFollower.weapon;
            }
            if (!weaponsData) {
                cc.error("weaponsData", heroName + "_weapon");
            }
            this.m_weaponsPlayData = new game.Map();
            for (var i = 0; i < weaponsData.length; ++i) {
                var weaponData = new game.WeaponData();
                weaponData.name = weaponsData[i].name;
                weaponData.level = weaponsData[i].level;
                weaponData.num = weaponsData[i].num;
                this.m_weaponsPlayData.set(weaponData.name, weaponData);
            }
            this.m_weaponsNameArr = new Array();
            this.m_weaponsPlayData.forEach(function (v, k) {
                cc.log(v.toString(), k);
                _this.m_weaponsNameArr.push(k);
            }, this);
            this.addStoneWeapon();
            this.m_weaponConfig = {};
            var name;
            for (var i = 0; i < this.m_weaponsNameArr.length; ++i) {
                name = this.m_weaponsNameArr[i];
                this.m_weaponConfig[name] = game.getWeaponConfig()[name];
            }
            this.m_curWeaponName = game.dataMgr.getMe().getCurWeaponByName(heroName);
            if (!this.hasWeaponByName(this.m_curWeaponName)) {
                this.m_curWeaponName = this.m_weaponsNameArr[0];
            }
        };
        playWeapon_pvp.prototype.addStoneWeapon = function () {
            var data = new game.WeaponData();
            data.name = "wuqi1";
            data.level = 0;
            data.num = 99;
            this.m_weaponsPlayData.set("wuqi1", data);
            this.m_weaponsNameArr.push("wuqi1");
        };
        playWeapon_pvp.prototype.isNotDraw = function () {
            return false;
        };
        playWeapon_pvp.prototype.getCurWeaponAnima = function () {
            return this.m_weaponConfig[this.m_curWeaponName].roleAnimation2;
        };
        playWeapon_pvp.prototype.getCurWeaponAttachmentImage = function () {
            return this.m_weaponConfig[this.m_curWeaponName].roleBujian;
        };
        playWeapon_pvp.prototype.getCurWeaponConfig = function () {
            var data = this.m_weaponsPlayData.get(this.m_curWeaponName);
            if (!data) {
                cc.error("getCurWeaponConfig error", this.m_curWeaponName);
                return this.m_weaponConfig[this.m_curWeaponName]["0"];
            }
            cc.log("curweapon name :", this.m_curWeaponName);
            cc.log("curweapon level :", data.level);
            return this.m_weaponConfig[this.m_curWeaponName][data.level];
        };
        playWeapon_pvp.prototype.getCurWeaponConfig2 = function () {
            return this.m_weaponConfig[this.m_curWeaponName];
        };
        playWeapon_pvp.prototype.setCurWeapon = function (name) {
            cc.log("setCurWeapon :", name);
            this.m_curWeaponName = name;
            // this.m_object_role  切换角色武器
            // this.m_object_role.initAngle();
            // playControl.getMe().init();
            // bulletMgr.getMe().initDeleteBulletNum(this.getCurWeaponConfig().shootNum);
        };
        playWeapon_pvp.prototype.hasWeaponByName = function (name) {
            for (var i = 0; i < this.m_weaponsNameArr.length; ++i) {
                if (this.m_weaponsNameArr[i] == name) {
                    return true;
                }
            }
            return false;
        };
        playWeapon_pvp.prototype.getWeaponDataByName = function (name) {
            return this.m_weaponsPlayData.get(name);
        };
        playWeapon_pvp.prototype.reduceCurWeaponBulletNum = function () {
            if (this.getWeaponSkill() == "noLimit")
                return;
            var num = this.m_weaponsPlayData.get(this.m_curWeaponName).num--;
            if (num < 0) {
                this.m_weaponsPlayData.get(this.m_curWeaponName).num = 0;
            }
            game.ui_zhandoujiemian.getMe().initPlayerDataUI();
        };
        playWeapon_pvp.prototype.getWeaponBulletNumByName = function (name) {
            return this.m_weaponsPlayData.get(name).num;
        };
        playWeapon_pvp.prototype.resetWeaponBulletNumByName = function (name) {
            this.m_weaponsPlayData.get(name).num = this.m_weaponsPlayData.get(name).maxNum;
        };
        playWeapon_pvp.prototype.shutdown = function () {
            this.m_object_role = null;
            this.m_weaponsPlayData.clear();
            this.m_weaponsPlayData = null;
            this.m_weaponsNameArr = null;
            this.m_weaponConfig = null;
        };
        playWeapon_pvp.prototype.getWeaponSkill = function () {
            return this.m_weaponConfig[this.m_curWeaponName].teshu;
        };
        return playWeapon_pvp;
    }());
    game.playWeapon_pvp = playWeapon_pvp;
})(game || (game = {}));
//# sourceMappingURL=playWeapon_pvp.js.map