/**
 * 武器
 */
module game {
    export class playWeapon_pvp {
        m_des: string;
        m_weaponsPlayData: Map<string,WeaponData>;
        m_curWeaponName: string;
        m_weaponsNameArr: Array<string>;
        m_weaponConfig;
        m_object_role: player_pvp;

        constructor(role: player_pvp) {
            this.m_des = "playWeapon_pvp";
            this.init(role.getName());
            this.m_object_role = role;
        }

        init(heroName: string) {
            let weaponsData;
            let data = proto_fightPVP.getMe().m_data;
            if (heroName == data.curHero.name) {
                weaponsData = data.curHero.weapon;
            } else {
                weaponsData = data.curFollower.weapon;
            }
            if (!weaponsData) {
                cc.error("weaponsData", heroName + "_weapon");
            }
            this.m_weaponsPlayData = new Map<string,WeaponData>();
            for (let i = 0; i < weaponsData.length; ++i) {
                let weaponData = new WeaponData();
                weaponData.name = weaponsData[i].name;
                weaponData.level = weaponsData[i].level;
                weaponData.num = weaponsData[i].num;
                this.m_weaponsPlayData.set(weaponData.name, weaponData);
            }
            this.m_weaponsNameArr = new Array<string>();
            this.m_weaponsPlayData.forEach((v, k) => {
                cc.log(v.toString(), k);
                this.m_weaponsNameArr.push(k);
            }, this);

            this.addStoneWeapon();

            this.m_weaponConfig = {};
            let name;
            for (let i = 0; i < this.m_weaponsNameArr.length; ++i) {
                name = this.m_weaponsNameArr[i];
                this.m_weaponConfig[name] = getWeaponConfig()[name];
            }

            this.m_curWeaponName = dataMgr.getMe().getCurWeaponByName(heroName);
            if (!this.hasWeaponByName(this.m_curWeaponName)) {
                this.m_curWeaponName = this.m_weaponsNameArr[0];
            }
        }

        addStoneWeapon() {
            let data = new WeaponData();
            data.name = "wuqi1";
            data.level = 0;
            data.num = 99;
            this.m_weaponsPlayData.set("wuqi1", data);
            this.m_weaponsNameArr.push("wuqi1");
        }

        isNotDraw(){
            return false;
        }

        getCurWeaponAnima() {
            return this.m_weaponConfig[this.m_curWeaponName].roleAnimation2;
        }

        getCurWeaponAttachmentImage() {
            return this.m_weaponConfig[this.m_curWeaponName].roleBujian;
        }

        getCurWeaponConfig() {
            let data = this.m_weaponsPlayData.get(this.m_curWeaponName);
            if (!data) {
                cc.error("getCurWeaponConfig error", this.m_curWeaponName);
                return this.m_weaponConfig[this.m_curWeaponName]["0"];
            }
            cc.log("curweapon name :",this.m_curWeaponName);
            cc.log("curweapon level :",data.level);
            return this.m_weaponConfig[this.m_curWeaponName][data.level];
        }

        getCurWeaponConfig2() {
            return this.m_weaponConfig[this.m_curWeaponName];
        }

        setCurWeapon(name: string) {
            cc.log("setCurWeapon :", name);
            this.m_curWeaponName = name;
            // this.m_object_role  切换角色武器
            // this.m_object_role.initAngle();
            // playControl.getMe().init();

            // bulletMgr.getMe().initDeleteBulletNum(this.getCurWeaponConfig().shootNum);
        }

        hasWeaponByName(name: string) {
            for (let i = 0; i < this.m_weaponsNameArr.length; ++i) {
                if (this.m_weaponsNameArr[i] == name) {
                    return true;
                }
            }
            return false;
        }

        getWeaponDataByName(name: string): WeaponData {
            return this.m_weaponsPlayData.get(name);
        }

        reduceCurWeaponBulletNum() {
            if (this.getWeaponSkill() == "noLimit") return;
            let num = this.m_weaponsPlayData.get(this.m_curWeaponName).num--;
            if (num < 0) {
                this.m_weaponsPlayData.get(this.m_curWeaponName).num = 0;
            }
            ui_zhandoujiemian.getMe().initPlayerDataUI();
        }

        getWeaponBulletNumByName(name) {
            return this.m_weaponsPlayData.get(name).num;
        }

        resetWeaponBulletNumByName(name){
            this.m_weaponsPlayData.get(name).num = this.m_weaponsPlayData.get(name).maxNum;
        }
        
        shutdown() {
            this.m_object_role = null;
            this.m_weaponsPlayData.clear();
            this.m_weaponsPlayData = null;
            this.m_weaponsNameArr = null;
            this.m_weaponConfig = null;
        }

        getWeaponSkill() {
            return this.m_weaponConfig[this.m_curWeaponName].teshu;
        }
    }
}