// 这是加入者
module game {
    // 装备 符文 皮肤 金币
    import pSub = cc.pSub;
    import pMult = cc.pMult;
    export class player_pvp extends baseRole {
        m_stateControl: playStateControl_pvp;
        m_controlerState: PlayControlerState_pvp;

        m_weaon: playWeapon_pvp;
        m_skin: playSkin_pvp;
        m_item: playItem;
        m_title: playTitle_pvp;

        m_def: number;
        m_power: number;
        m_curPower: number;

        m_angle: number;
        m_angelPos: cc.Vec2;
        m_angelPos2: cc.Vec2;

        m_angleNode: cc.Node;
        m_angleImage: ProgressTimerEx;
        m_angleImage2: ccui.ImageView;
        m_DrawNode: cc.DrawNode = null;//辅助线

        isFire: boolean;
        m_attRange;
        isPvp: boolean;

        init(heroName: string, type) {
            let config = g_playhero_config[heroName];
            this.loadres(config.spine_res);
            this.m_name = heroName;
            this.setScale(config.scale);
            this.m_scale = config.scale;
            this.createBloodBar(config.headHpBarPos, config.bloodScale);

            this.m_stateControl = new playStateControl_pvp(this);
            this.m_controlerState = new PlayControlerState_pvp(this);
            this.m_weaon = new playWeapon_pvp(this);
            this.m_skin = new playSkin_pvp(this, type);
            this.m_item = new playItem(this);
            this.m_title = new playTitle_pvp(this, type);
            this.m_stateControl.initState();
            // if (dataMgr.getMe().getViplevel() > 2) {
            //     this.m_DrawNode = new cc.DrawNode();
            //     this.addChild(this.m_DrawNode);
            // }
            this.setRoleDir(1);
            this.initProperty(config);
            this.setCurPower(this.getMaxPower());

            this.m_headHpNumberPos = config.headHpNumberPos;

            this.setDir(-1);
        }

        fuhuo() {
        }

        initProperty(config) {
            let data = proto_fightPVP.getMe().m_data;
            let herolevel = data.level;
            let levelconfig: levelup_s = g_player_levelUp_config[herolevel];
            this.m_att = levelconfig.atk + data.extraAtt;
            this.m_maxHp = levelconfig.hp + data.extraHP;
            this.m_def = levelconfig.def + data.extraDef;
            this.m_power = levelconfig.power + data.extraPower;
            super.initProperty(config);
            this.initAngleNode();
            this.m_arrawPos = config.arrowPos;
            this.m_attRange = config.attPos;
        }

        showBody(){
            this.m_bloodBar.setVisible(true);
            this.m_SpineNode.getNode().opacity = 255;
        }

        hideBody(){
            this.m_bloodBar.setVisible(false);
            this.m_SpineNode.getNode().opacity = 0;
        }

        createBloodBar(pos: cc.Vec2, scale: number) {
            this.m_bloodBar = UiBase.parseUiFile_static("xuetiao_bule.json");
            this.addChild(this.m_bloodBar);
            this.m_bloodBar.setPosition(pos);
            this.m_bloodBar.setScale(scale);
            this.m_hpper = ccui.helper.seekWidgetByName(this.m_bloodBar, "xuetiao");
            let name: ccui.Text = ccui.helper.seekWidgetByName(this.m_bloodBar, "name");
            let _level: ccui.Text = ccui.helper.seekWidgetByName(this.m_bloodBar, "dengji");
            let _tittle: ccui.ImageView = ccui.helper.seekWidgetByName(this.m_bloodBar, "chenghao");
            let vipimg: ccui.ImageView = ccui.helper.seekWidgetByName(this.m_bloodBar, "vip_biaoshi");

            let data = proto_fightPVP.getMe().m_data;
            let nantittle;
            let level_nan;
            name.setString(data.name);
            _level.setString(data.level);
            if (data.curHero.name == this.getName()) {
                nantittle = data.curHero.title;
                level_nan = data.curHero.titleLevel;
            } else {
                nantittle = data.curFollower.title;
                level_nan = data.curFollower.titleLevel;
            }
            if (nantittle == -1) {
                _tittle.setVisible(false)
            } else {
                _tittle.setVisible(true);
                let nantittleconfig = dataMgr.getMe().getTittleConfigBytag(nantittle, level_nan);
                if(nantittleconfig){
                    _tittle.loadTexture(nantittleconfig.icon);
                }
            }
            if (data.viplevel <= 0) {
                vipimg.setVisible(false)
            } else {
                vipimg.setVisible(true);
                vipimg.loadTexture(g_vip_config[data.viplevel].icon)
            }
        }

        update(dt: number) {
            super.update(dt);
            // 换武器
            if (this.m_weaon) {
                this.m_SpineNode.replaceAttachmentImage("wuqi", this.m_weaon.getCurWeaponAttachmentImage());
            }
        }

        getExpPer() {
            return this.m_title.getExpPer();
        }

        getGoldPer() {
            return this.m_title.getGoldPer();
        }

        setCurPower(power: number) {
            if (power < 0) {
                power = 0;
            }
            this.m_curPower = power;
            if (ui_zhandoujiemian.getMe()) {
                ui_zhandoujiemian.getMe().setPower(this.m_curPower, this.getMaxPower());
            }
        }

        getCurPower() {
            return this.m_curPower;
        }

        getMaxPower() {
            return (this.m_power + this.m_skin.getPower() + this.m_title.getPower()) * (1 + this.m_title.getPowerPer());
        }

        getDef_boom() {
            return (1 - (this.m_def + this.m_skin.getDef() + this.m_title.getDef())) * (1 - this.m_title.getDefPer()) * (1 - this.m_title.getBoomDefPer());
        }

        getDef() {
            return (1 - (this.m_def + this.m_skin.getDef() + this.m_title.getDef())) * (1 - this.m_title.getDefPer());
        }

        shutdown() {
            this.m_weaon.shutdown();
            this.m_skin.shutdown();
            this.m_item.shutdown();
            this.m_title.shutdown();
            this.m_weaon = null;
            this.m_skin = null;
            this.m_item = null;
            this.m_title = null;

            super.shutdown();
            // if (this.m_angleNode) {
            //     this.removeChild(this.m_angleNode, true);
            //     this.m_angleNode = null;
            // }
            // if (this.m_angleImage) {
            //     this.m_angleImage.shutdown();
            //     this.m_angleImage = null;
            // }
            // if (this.m_angleImage2) {
            //     this.removeChild(this.m_angleImage2, true);
            //     this.m_angleImage2 = null;
            // }
            // if (this.m_DrawNode) {
            //     this.removeChild(this.m_DrawNode, true);
            //     this.m_DrawNode = null;
            // }
        }

        getAtt(): number {
            let att = (super.getAtt() + this.m_skin.getAtt() + this.m_title.getAtt() + this.m_weaon.getCurWeaponConfig().damage) * (1 + this.m_title.getAttPer()) * this.m_item.getAttPer();
            cc.log("att:", att);
            return att * g_debug_play_att_per;
        }

        getSpeed(): number {
            return super.getSpeed();
        }

        getMaxHp(): number {
            return super.getMaxHp() + this.m_skin.getHp() + this.m_title.getHp();
        }

        getCritRate() {
            let crit = super.getCritRate() + this.m_skin.getCritRate();
            cc.log("暴击率：", crit);
            return crit;
        }

        setHp(hp: number) {
            super.setHp(hp);
            // if (ui_zhandoujiemian.getMe()) {
            //     ui_zhandoujiemian.getMe().setHP(hp, this.getMaxHp());
            // }
        }

        // onDamage(shoujires: string, shoujianima: string, shoujiscale: number, roleId: number, isBoom?: boolean) {
        // }

        onDamageEx(data) {
            super.onDamage(data.shoujires, data.shoujianima, data.shoujiscale);
            let role = roleMgr.getMe().m_AllRole_map.get(data.roleId);
            if (!role) return;
            // let att = role.getAtt();
            let hp = this.getHp();
            // let iscrit = 0;
            // if (Math.floor(Math.random() * 100) < role.getCritRate() * 100) {
            //     att *= 2;
            //     iscrit = 1;
            // }
            // if (role instanceof player_pvp) {
            //     att /= 2;
            // }
            // if (this.m_skin.getSkillName() == "kuangbao") {
            //     att *= (1 + this.m_skin.getShuzhi2_bear());
            // }
            if (this.m_skin.getSkillName() == "minjie") {
                if (Math.floor(Math.random() * 100) < this.m_skin.getShuzhi1() * 100) {
                    uieffectMgr.getMe().createLayout_playdrophp_crit(roleMgr.getMe().getNode(), 0, this.getHeadHpNumberPos());
                    return;
                }
            }
            if (role instanceof player) {
                // if (role.m_skin.getSkillName() == "nianya") {
                //     if (hp <= this.getMaxHp() * role.m_skin.getShuzhi1()) {
                //         att *= (1 + role.m_skin.getShuzhi2());
                //     }
                // }
                // if (role.m_skin.getSkillName() == "kuangbao") {
                //     att *= (1 + role.m_skin.getShuzhi1_bear());
                // }
                // if (role.m_skin.getSkillName() == "xixue") {
                //     role.addHp(att * role.m_skin.getShuzhi1());
                // }
                // if (hp < (this.getMaxHp() * 0.5)) {
                //     if (role.m_weaon.getWeaponSkill() == "kill") {
                //         if (Math.floor(Math.random() * 100) < 20) {
                //             att = hp;
                //         }
                //     }
                // }
            }
            // if (data.isBoom) {
            //     att *= this.getDef_boom();
            // } else {
            //     att *= this.getDef();
            // }

            hp -= data.att;
            if (hp < 0) {
                hp = 0;
                if(this.m_stateControl.getCurStateType() != g_AiType.g_AiType_dead){
                    this.changeState_Ex(g_AiType.g_AiType_dead);
                    if(data.isBoom)
                        sync_title.getMe().send("chenghao_2");
                }
            } else {
                if (this.m_stateControl.getCurStateType() != g_AiType.g_AiType_hit)
                    this.changeState_Ex(g_AiType.g_AiType_hit);
            }
            this.setHp(hp);

            if (data.iscrit == 1)
                uieffectMgr.getMe().createLayout_monsterdropCrithp(roleMgr.getMe().getNode(), data.att, this.getHeadHpNumberPos());
            else
                uieffectMgr.getMe().createLayout_playdrophp(roleMgr.getMe().getNode(), data.att, this.getHeadHpNumberPos());
        }

        initAngle() {
            // if (!this.m_angle) {
            //     let data = this.m_weaon.getCurWeaponConfig();
            //     this.m_angle = (data.minAngle + data.maxAngle) / 2;
            //     this.updateAngleNode(this.m_angle);
            // }
            // cc.log("initAngle :", this.m_angle);
        }

        initAngleNode() {
            // this.m_angleNode = UiBase.parseUiFile_static("jiaodu.json");
            // // ccui.helper.seekWidgetByName(this.m_angleNode, "1").setVisible(false);
            // this.addChild(this.m_angleNode);
            //
            // let angletext: ccui.Text = ccui.helper.seekWidgetByName(this.m_angleNode, "jiaodu");
            // angletext.setString(Math.ceil(this.m_angle ? this.m_angle : 0) + "°");
            //
            // let pos = g_playhero_config[this.getName()].shootAngelPos;
            // // pos.x = pos.x * this.getScale();
            // // pos.y = pos.y * this.getScale();
            // this.m_angelPos = pos;
            // this.m_angelPos2 = cc.p(g_other_config.anglePos);
            // this.m_angleImage = new ProgressTimerEx("xingjietantantang/big/ui/image/ddt_ui158.png", pos, this.getNode(), g_other_config.angleSize.range);
            //
            // this.m_angleImage2 = new ccui.ImageView();
            // this.m_angleImage2.loadTexture("xingjietantantang/big/ui/image/ddt_ui255.png");
            // this.addChild(this.m_angleImage2, 100);
            // this.m_angleImage2.setPosition(pos);
            // this.m_angleNode.setPosition(this.m_angelPos2);
            // this.m_angleNode.setVisible(false);
            // this.m_angleImage2.setVisible(false);
            // this.m_angleImage2.setScale(g_other_config.angleSize.aimline);
            // this.m_angleNode.setScale(g_other_config.angleSize.angle);
        }

        showAngleImage() {
            // this.m_angleNode.setVisible(true);
            // this.m_angleImage2.setVisible(true);
            // this.updateAngleImage();
            // if (this.m_DrawNode) {
            //     // this.m_DrawNode.setVisible(true);
            //     this.m_controlerState.drawLine();
            // }
            // this.isFire = false;
        }

        updateAngleImage() {
            // let data = this.m_weaon.getCurWeaponConfig();
            // if (this.getDir() < 0) {
            //     this.m_angleImage.setRotation(180 + (180 - (90 - data.minAngle)));
            //     if (this.m_angelPos.x > 0) {
            //         this.m_angelPos2.x = -this.m_angelPos2.x;
            //         this.m_angelPos.x = -this.m_angelPos.x;
            //     }
            //     this.m_angleImage.setPosition(this.m_angelPos);
            //     // this.m_angle = 180 + this.m_angle;
            //     // cc.log("aaaaaaaaaaa ", this.m_angle);
            //     if (this.m_angle < 90) {
            //         this.m_angleImage2.setRotation(180 + this.m_angle);
            //     } else {
            //         this.m_angleImage2.setRotation(-this.m_angle);
            //     }
            //     // this.m_angleImage2.setRotation(180 + this.m_angle);
            //     this.m_angleImage2.setPosition(this.m_angelPos);
            // } else {
            //     this.m_angleImage.setRotation(90 - data.maxAngle);
            //     if (this.m_angelPos.x < 0) {
            //         this.m_angelPos2.x = -this.m_angelPos2.x;
            //         this.m_angelPos.x = -this.m_angelPos.x;
            //     }
            //     this.m_angleImage.setPosition(this.m_angelPos);
            //     // this.m_angle = 180 - this.m_angle;
            //     // if (this.m_angle < 90)
            //     //     this.m_angle = -this.m_angle;
            //     // cc.log("bbbbbbbbbb ", this.m_angle);
            //     if (this.m_angle > 90) {
            //         this.m_angleImage2.setRotation(180 + this.m_angle);
            //     } else {
            //         this.m_angleImage2.setRotation(-this.m_angle);
            //     }
            //     this.m_angleImage2.setPosition(this.m_angelPos);
            // }
            // let range = Math.abs(data.maxAngle - data.minAngle) / 360 * 100;
            // this.m_angleImage.setPercentage(range);
            // cc.log(this.m_angle);
            // this.m_angleNode.setPosition(this.m_angelPos2);
        }

        hideAngleImage() {
            // this.m_angleImage.setPercentage(0);
            // if (this.m_angleNode) {
            //     this.m_angleNode.setVisible(false);
            // }
            // if (this.m_angleImage2) {
            //     this.m_angleImage2.setVisible(false);
            // }
            // this.hideDots();
        }

        updateAngle(offset: number) {
            // let data = this.m_weaon.getCurWeaponConfig();
            // let newAngle = this.m_angle + offset;
            // // cc.log("before : ", this.m_angle);
            // if (this.getDir() < 0) {
            //     newAngle = this.m_angle - offset;
            //     if (newAngle < 90) {
            //         newAngle = 180 - newAngle;
            //     }
            //     // cc.log("updateAngle before :",this.m_angle);
            //     // cc.log("aaaaa :"+data.maxAngle,"bbbbb :"+data.minAngle);
            //     if (newAngle < 180 - data.maxAngle)
            //         newAngle = 180 - data.maxAngle;
            //     else if (newAngle > 180 - data.minAngle)
            //         newAngle = 180 - data.minAngle;
            //     // cc.log("updateAngle after : ",this.m_angle);
            // } else {
            //     if (newAngle > 90) {
            //         newAngle = 180 - newAngle;
            //     }
            //     // cc.log("updateAngle before :",this.m_angle);
            //     // cc.log("aaaaa :"+data.maxAngle,"bbbbb :"+data.minAngle);
            //     if (newAngle > data.maxAngle)
            //         newAngle = data.maxAngle;
            //     else if (newAngle < data.minAngle)
            //         newAngle = data.minAngle;
            //     // cc.log("updateAngle after : ",this.m_angle);
            // }
            // this.m_angle = newAngle;
            // this.updateAngleNode(newAngle);
            //
            // // cc.log("after : ", newAngle);
        }

        updateAngleNode(angle) {
            // let angle2 = angle;
            // if (this.m_angleNode) {
            //     if (angle > 90)
            //         angle = 90 - angle;
            //     if (this.m_roledir < 0) {
            //         angle = angle + 90;
            //     }
            //     let angletext: ccui.Text = ccui.helper.seekWidgetByName(this.m_angleNode, "jiaodu");
            //     angletext.setString(Math.ceil(angle) + "°");
            // }
            // if (this.m_angleImage2) {
            //     this.m_angleImage2.setRotation(-angle2);
            // }
        }

        hideDots() {
            // if (this.m_DrawNode) {
            //     this.m_DrawNode.clear();
            //     this.m_DrawNode.setVisible(false);
            // }
        }

        showDots() {
            // if (this.m_DrawNode) {
            //     this.m_DrawNode.setVisible(true);
            // }
        }

        drawDots(points: DrawPointControl) {
            // this.m_DrawNode.clear();
            // for (let i = 0; i < points.pointArr.length; ++i) {
            //     this.m_DrawNode.drawDot(pMult(pSub(points.pointArr[i], this.getPosition()), 1 / this.m_scale), 10, cc.color(255, 255, 255));
            // }
        }

        //
        // m_target: player;
        //
        // begin() {
        //     // 1 选武器 2 选药水 3 寻敌 4 调整角度
        //     let a = setInterval(() => {
        //         this.selectPlayWeapon();
        //         this.selectYaoshui();
        //         if (!this.lockTarget()) {
        //             this.changeState_Ex(g_AiType.g_AiType_run);
        //         }
        //         clearInterval(a);
        //     }, 500);
        // }
        //
        // selectPlayWeapon() {
        //     // 设置武器
        //     this.m_weaon.setCurWeapon();
        //     // 重置本回合射出子弹数
        //     bulletMgr.getMe().initDeleteBulletNum(this.m_weaon.getCurWeaponConfig().shootNum);
        // }
        //
        // selectYaoshui() {
        //     let rank = dataMgr.getMe().getRank();
        //     let r = Math.floor(Math.random() * 3) + 1;
        //     if (rank < 100) {
        //         this.m_item.setCurItem("yaoji" + r);
        //     }
        //     else if (rank < 1000) {
        //         if (Math.floor(Math.random() * 100) < 30) {
        //             this.m_item.setCurItem("yaoji" + r);
        //         }
        //     }
        // }
        //
        // lockTarget() {
        //     let temp: number = 10000;
        //     for (let i = 0; i < roleMgr.getMe().m_player_map.size; ++i) {
        //         let role = roleMgr.getMe().m_player_map.getByIndex(i);
        //         if (role.isDead()) continue;
        //         let dis = cc.pDistance(role.getPosition(), this.getPosition());
        //         if (dis < temp) {
        //             temp = dis;
        //             this.m_target = role;
        //         }
        //     }
        //     return this.m_target == null;
        // }

        OnFireBulletEx(data) {
            data.m_isplayer = false;
            if (this.m_weaon.getWeaponSkill() == "blink") {
                bulletMgr.getMe().creatBlinkBullet(data);
            }
            else if (this.m_weaon.getWeaponSkill() == "heal") {
                bulletMgr.getMe().creatHealBullet(data);
            }
            else if (this.m_weaon.getWeaponSkill() == "posion") {
                bulletMgr.getMe().creatPosionBullet(data);
            }
            else if (this.m_weaon.getWeaponSkill() == "cross") {
                bulletMgr.getMe().creatCrossBullet(data);
            }
            else if (this.m_weaon.getWeaponSkill() == "launch") {
                bulletMgr.getMe().creatLaunchBullet(data);
            }
            else if (this.m_weaon.getWeaponSkill() == "launch2") {
                bulletMgr.getMe().creatLaunchBullet2(data);
            }
            else {
                bulletMgr.getMe().createBullet(data);
            }
            if (this.m_item.isYaoji3()) {
                let data2 = cc.copy(data);
                data2.m_angle = data.m_angle + 5;
                data2.m_dir = this.fixDir(cc.pForAngle(cc.degreesToRadians(data2.m_angle)));
                bulletMgr.getMe().createBullet(data2);

                let data3 = cc.copy(data);
                data3.m_angle = data.m_angle - 5;
                data3.m_dir = this.fixDir(cc.pForAngle(cc.degreesToRadians(data3.m_angle)));
                bulletMgr.getMe().createBullet(data3);
            }
            if (this.m_item.isYaoji2() && this.m_item.m_used) return;
            this.m_weaon.reduceCurWeaponBulletNum();
        }

        fixDir(dir: cc.Vec2) {
            if (dir.x == -1) {
                dir.x = 1;
                dir.y = 0;
            }
            if (this.getDir() < 0) {
                if (dir.x > 0)
                    dir.x = -dir.x;
            } else {
                if (dir.x < 0)
                    dir.x = -dir.x;
            }
            return dir;
        }
    }

}