var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
// 角色管理类
var game;
(function (game) {
    var roleMgr_pvp = (function (_super) {
        __extends(roleMgr_pvp, _super);
        function roleMgr_pvp() {
            _super.apply(this, arguments);
        }
        roleMgr_pvp.prototype.initMap = function () {
            this.m_player_map = new game.Map();
            this.m_matcher_map = new game.Map();
            this.m_AllRole_map = new game.Map();
        };
        roleMgr_pvp.prototype.isMonsterAllDead = function () {
            return this.m_deadNum_monster == this.m_matcher_map.size;
        };
        roleMgr_pvp.prototype.getBirthPos = function (player_birth, oldPos, name) {
            var count = 0;
            for (var p in player_birth) {
                count++;
            }
            count /= 2;
            var r = Math.floor(Math.random() * count) + 1;
            var pos = player_birth[name + "_" + r];
            if (pos == oldPos) {
                return this.getBirthPos(player_birth, oldPos, name);
            }
            return pos;
        };
        // 出生位置 初始角色
        roleMgr_pvp.prototype.initroleMgr = function (sceneinfo) {
            if (game.proto_fightPVP.getMe().m_isP1) {
                this.initMap();
                var player_birth = cc.copy(game.g_birth_config[sceneinfo.hero_birth]);
                var roleName = void 0;
                var pos = void 0;
                var posArr = new Array();
                var role = void 0;
                pos = this.getBirthPos(player_birth, cc.p(0, 0), "hero");
                this.m_curRole = this.createPlayer(game.dataMgr.getMe().getPlayDoc().coreData.curHero, pos);
                this.m_curRole.setRoleDir(1);
                posArr.push(pos);
                roleName = game.proto_fightPVP.getMe().m_data.curHero.name;
                var pos2 = this.getBirthPos(player_birth, cc.p(0, 0), "enemy");
                role = this.createMatcher(roleName, pos2, 1);
                role.setRoleDir(-1);
                posArr.push(pos2);
                if (game.dataMgr.getMe().getPlayDoc().coreData.curFollower) {
                    pos = this.getBirthPos(player_birth, pos, "hero");
                    role = this.createPlayer(game.dataMgr.getMe().getPlayDoc().coreData.curFollower, pos);
                    role.setRoleDir(1);
                    posArr.push(pos);
                }
                else {
                    posArr.push(cc.p(0, 0));
                }
                if (game.proto_fightPVP.getMe().m_data.curFollower.name) {
                    roleName = roleName == "nan" ? "nv" : "nan";
                    pos2 = this.getBirthPos(player_birth, pos2, "enemy");
                    role = this.createMatcher(roleName, pos2, 2);
                    role.setRoleDir(1);
                    posArr.push(pos2);
                }
                else {
                    posArr.push(cc.p(0, 0));
                }
                game.sync_birthPos.getMe().send(posArr);
                game.cameraMgr.getMe().reset(this.m_curRole.getPosition(), this.m_curRole);
                if (game.ui_zhandoujiemian.getMe()) {
                    game.ui_zhandoujiemian.getMe().initPVPDataUI();
                    game.ui_zhandoujiemian.getMe().initPlayerDataUI();
                }
                this.m_deadNum_monster = 0;
                this.m_deadNum_player = 0;
                this.m_hasDead = false;
                // ui_arraw.ShowOrHide(true);
                game.sync_start.getMe().send();
            }
        };
        roleMgr_pvp.prototype.initroleMgrEx = function (posArr) {
            this.initMap();
            var roleName;
            var pos;
            var role;
            roleName = game.proto_fightPVP.getMe().m_data.curHero.name;
            pos = posArr[0];
            this.m_curRole = this.createMatcher(roleName, pos, 1);
            this.m_curRole.setRoleDir(1);
            pos = posArr[1];
            role = this.createPlayer(game.dataMgr.getMe().getPlayDoc().coreData.curHero, pos);
            role.setRoleDir(-1);
            if (game.proto_fightPVP.getMe().m_data.curFollower.name) {
                roleName = roleName == "nan" ? "nv" : "nan";
                pos = posArr[2];
                role = this.createMatcher(roleName, pos, 2);
                role.setRoleDir(1);
            }
            if (game.dataMgr.getMe().getPlayDoc().coreData.curFollower) {
                pos = posArr[3];
                role = this.createPlayer(game.dataMgr.getMe().getPlayDoc().coreData.curFollower, pos);
                role.setRoleDir(-1);
            }
            game.cameraMgr.getMe().reset(this.m_curRole.getPosition(), this.m_curRole);
            if (game.ui_zhandoujiemian.getMe()) {
                game.ui_zhandoujiemian.getMe().initPVPDataUI();
                game.ui_zhandoujiemian.getMe().initPlayerDataUI();
            }
            this.m_deadNum_monster = 0;
            this.m_deadNum_player = 0;
            this.m_hasDead = false;
            // ui_arraw.ShowOrHide(true);
            game.sync_start.getMe().send();
        };
        roleMgr_pvp.prototype.createMatcher = function (heroname, pos, type) {
            var l_player = new game.player_pvp();
            l_player.init(heroname, type);
            l_player.setPosition(pos);
            this.addChild(l_player.getNode(), 2000);
            this.m_matcher_map.set(l_player.__instanceId, l_player);
            this.m_AllRole_map.set(game.RoundManager.getMe().m_maxRoleIndex, l_player);
            l_player.m_index = game.RoundManager.getMe().m_maxRoleIndex++;
            return l_player;
        };
        roleMgr_pvp.prototype.shutdown = function () {
            if (game.ui_arraw.getMe()) {
                game.ui_arraw.ShowOrHide(false);
            }
            if (game.playControl.getMe()) {
                game.playControl.getMe().shutdown();
            }
            this.m_AllRole_map.forEach(function (v, k) {
                v.shutdown();
            }, this);
            this.m_AllRole_map.clear();
            this.m_matcher_map.clear();
            this.m_player_map.clear();
        };
        //暂停动画
        roleMgr_pvp.prototype.zanting = function (falg) {
            this.m_AllRole_map.forEach(function (v, k) {
                v.zanting(falg);
            }, this);
        };
        roleMgr_pvp.prototype.update = function (t) {
            this.m_AllRole_map.forEach(function (v, k) {
                v.update(t);
            }, this);
        };
        return roleMgr_pvp;
    }(game.roleMgr));
    game.roleMgr_pvp = roleMgr_pvp;
})(game || (game = {}));
//# sourceMappingURL=roleMgr_pvp.js.map 
//# sourceMappingURL=roleMgr_pvp.js.map