// 角色管理类
module game {

    export class roleMgr_pvp extends roleMgr {
        m_matcher_map: Map<number, player_pvp>;

        initMap() {
            this.m_player_map = new Map<number, player>();
            this.m_matcher_map = new Map<number, player_pvp>();
            this.m_AllRole_map = new Map<number, baseRole>();
        }

        isMonsterAllDead() {
            return this.m_deadNum_monster == this.m_matcher_map.size;
        }

        getBirthPos(player_birth, oldPos, name) {
            let count: number = 0;
            for (let p in player_birth) {
                count++;
            }
            count /= 2;
            let r = Math.floor(Math.random() * count) + 1;
            let pos = player_birth[name + "_" + r];
            if (pos == oldPos) {
                return this.getBirthPos(player_birth, oldPos, name);
            }
            return pos;
        }

        // 出生位置 初始角色
        initroleMgr(sceneinfo: scene_config_data_s) {
            if(proto_fightPVP.getMe().m_isP1){
                this.initMap();
                let player_birth = cc.copy(g_birth_config[sceneinfo.hero_birth]);
                let roleName;
                let pos;
                let posArr = new Array();
                let role;
                pos = this.getBirthPos(player_birth, cc.p(0, 0), "hero");
                this.m_curRole = this.createPlayer(dataMgr.getMe().getPlayDoc().coreData.curHero, pos);
                this.m_curRole.setRoleDir(1);

                posArr.push(pos);
                roleName = proto_fightPVP.getMe().m_data.curHero.name;
                let pos2 = this.getBirthPos(player_birth, cc.p(0, 0), "enemy");
                role = this.createMatcher(roleName, pos2,1);
                role.setRoleDir(-1);
                posArr.push(pos2);
                if (dataMgr.getMe().getPlayDoc().coreData.curFollower) {
                    pos = this.getBirthPos(player_birth, pos, "hero");
                    role = this.createPlayer(dataMgr.getMe().getPlayDoc().coreData.curFollower, pos);
                    role.setRoleDir(1);
                    posArr.push(pos);
                }else{
                    posArr.push(cc.p(0,0));
                }
                if(proto_fightPVP.getMe().m_data.curFollower.name){
                    roleName = roleName == "nan" ? "nv" : "nan";
                    pos2 = this.getBirthPos(player_birth, pos2, "enemy");
                    role = this.createMatcher(roleName, pos2,2);
                    role.setRoleDir(1);
                    posArr.push(pos2);
                }else{
                    posArr.push(cc.p(0,0));
                }

                sync_birthPos.getMe().send(posArr);
                cameraMgr.getMe().reset(this.m_curRole.getPosition(), this.m_curRole);

                if (ui_zhandoujiemian.getMe()){
                    ui_zhandoujiemian.getMe().initPVPDataUI();
                    ui_zhandoujiemian.getMe().initPlayerDataUI();
                }
                this.m_deadNum_monster = 0;
                this.m_deadNum_player = 0;
                this.m_hasDead = false;
                // ui_arraw.ShowOrHide(true);

                sync_start.getMe().send();
            }
        }

        initroleMgrEx(posArr) {
            this.initMap();
            let roleName;
            let pos;
            let role;
            roleName = proto_fightPVP.getMe().m_data.curHero.name;
            pos = posArr[0];
            this.m_curRole = this.createMatcher(roleName, pos, 1);
            this.m_curRole.setRoleDir(1);
            pos = posArr[1];
            role = this.createPlayer(dataMgr.getMe().getPlayDoc().coreData.curHero, pos);
            role.setRoleDir(-1);
            if (proto_fightPVP.getMe().m_data.curFollower.name) {
                roleName = roleName == "nan" ? "nv" : "nan";
                pos = posArr[2];
                role = this.createMatcher(roleName, pos, 2);
                role.setRoleDir(1);
            }

            if (dataMgr.getMe().getPlayDoc().coreData.curFollower) {
                pos = posArr[3];
                role = this.createPlayer(dataMgr.getMe().getPlayDoc().coreData.curFollower, pos);
                role.setRoleDir(-1);
            }

            cameraMgr.getMe().reset(this.m_curRole.getPosition(), this.m_curRole);

            if (ui_zhandoujiemian.getMe()){
                ui_zhandoujiemian.getMe().initPVPDataUI();
                ui_zhandoujiemian.getMe().initPlayerDataUI();
            }
            this.m_deadNum_monster = 0;
            this.m_deadNum_player = 0;
            this.m_hasDead = false;
            // ui_arraw.ShowOrHide(true);

            sync_start.getMe().send();
        }

        createMatcher(heroname: string, pos: cc.Vec2,type): player_pvp {
            let l_player = new player_pvp();
            l_player.init(heroname,type);
            l_player.setPosition(pos);
            this.addChild(l_player.getNode(), 2000);
            this.m_matcher_map.set(l_player.__instanceId, l_player);
            this.m_AllRole_map.set(RoundManager.getMe().m_maxRoleIndex, l_player);
            l_player.m_index = RoundManager.getMe().m_maxRoleIndex++;
            return l_player;
        }

        shutdown() {
            if (ui_arraw.getMe()) {
                ui_arraw.ShowOrHide(false);
            }
            if (playControl.getMe()) {
                playControl.getMe().shutdown();
            }
            this.m_AllRole_map.forEach(function (v, k) {
                v.shutdown();
            }, this);
            this.m_AllRole_map.clear();
            this.m_matcher_map.clear();
            this.m_player_map.clear();
        }

        //暂停动画
        zanting(falg) {
            this.m_AllRole_map.forEach(function (v, k) {
                v.zanting(falg);
            }, this);
        }

        update(t) {
            this.m_AllRole_map.forEach(function (v: baseRole, k) {
                v.update(t);
            }, this);
        }

    }
}
//# sourceMappingURL=roleMgr_pvp.js.map