// 角色管理类
module game {

    export class roleMgr extends xjNode {
        m_curRole: player;
        m_player_map: Map<number, player>;
        m_monster_map: Map<number, monster>;
        m_AllRole_map: Map<number, baseRole>;
        m_deadNum_player: number;
        m_deadNum_monster: number;

        m_hasDead: boolean;
        static getMe = function (): roleMgr {
            if (sceneMgr.getMe().m_curScene == null) {
                return null;
            }
            if (sceneMgr.getMe().m_curScene instanceof fightAiscene) {
                let scene = <fightAiscene>sceneMgr.getMe().m_curScene;
                return scene.m_roleMgr;
            }
            if (sceneMgr.getMe().m_curScene instanceof PVP_fight) {
                let scene = <PVP_fight>sceneMgr.getMe().m_curScene;
                return scene.m_roleMgr;
            }
            return sceneMgr.getMe().m_curScene.m_roleMgr;
        };
        static create = function (): roleMgr {
            if (sceneMgr.getMe().m_curScene instanceof fightAiscene) {
                return new roleMgr_ai();
            }
            if (sceneMgr.getMe().m_curScene instanceof PVP_fight) {
                return new roleMgr_pvp();
            }
            return new roleMgr();
        };

        initMap() {
            this.m_player_map = new Map<number, player>();
            this.m_monster_map = new Map<number, monster>();
            this.m_AllRole_map = new Map<number, baseRole>();
        }

        isMonsterAllDead() {
            return this.m_deadNum_monster == this.m_monster_map.size;
        }

        isPlayerAllDead() {
            return this.m_deadNum_player == this.m_player_map.size;
        }

        // // 设置当前控制角色
        // setControlPlayer(_role:player = null) {
        //     g_Vo = g_Vo_default
        //     if(_role)
        //     {
        //         this.m_curControlRole = _role
        //     }
        //     else
        //     {
        //         this.m_curControlRole.m_fireState = e_fire_state.Stand
        //         for (let i = 0; i < this.m_player_map.size; ++i) {
        //             let obj = this.m_player_map.getByIndex(i);
        //             if (obj.__instanceId != this.m_curControlRole.__instanceId) {
        //                 if(obj.isdead())
        //                     continue
        //                 this.m_curControlRole = obj;
        //                 break;
        //             }
        //         }
        //     }
        //     this.m_curControlRole.setControlRole(true);
        //     cameraMgr.getMe().resetEx(this.m_curControlRole)
        //     playControl.getMe().resetKey();
        //     this.m_curControlRole.resetEndurance()
        //     this.m_curControlRole.m_fireState = e_fire_state.Move
        //
        //     let data = this.m_curControlRole.m_weaponLevelconfig;
        //     this.m_curControlRole.showAngleImage(data.minAngle,data.maxAngle,playControl.getMe().m_angle);
        // }

        //当前被控制的角色
        getControlPlayer(): player {
            return this.m_curRole;
        }

        // m_maxMonsterNum = 0;
        // m_onsterData = null;

        initroleMgr(sceneinfo: scene_config_data_s) {
            this.initMap();
            let player_birth = cc.copy(g_birth_config[sceneinfo.hero_birth]);
            this.m_curRole = this.createPlayer(dataMgr.getMe().getPlayDoc().coreData.curHero, player_birth.hero_2);
            if (dataMgr.getMe().getPlayDoc().coreData.curFollower) {
                this.createPlayer(dataMgr.getMe().getPlayDoc().coreData.curFollower, player_birth.hero_1);
            }
            cameraMgr.getMe().reset(player_birth.hero_1, this.m_curRole);


            // this.m_curRole = this.createMonster(null);
            // this.m_curRole.setPosition(cc.p(500,1000));

            // playControl.getMe().init();

            let monsterData = g_monster_birth_config[sceneinfo.monsterBirth[0].wave];
            // this.m_onsterData = monsterData;
            // let count = 0;
            // for (let p in monsterData) {
            //     count++;
            // }
            // this.m_maxMonsterNum = count;
            // let a = setInterval(() => {
            //     count--;
            //     this.createMonster(monsterData[this.m_maxMonsterNum - count].monstername, cc.p(monsterData[this.m_maxMonsterNum - count].pos_x, monsterData[this.m_maxMonsterNum - count].pos_y));
            //     cc.log("count:", count);
            //     if (count <= 0) {
            //         clearInterval(a);
            //         RoundManager.getMe().start();
            //     }
            // }, 200);
            //
            // sceneMgr.getMe().getCurScene().m_createMonsterInterval = a;

            for (let i in monsterData) {
                this.createMonster(monsterData[i].monstername, cc.p(monsterData[i].pos_x, monsterData[i].pos_y));
            }

            if (ui_zhandoujiemian.getMe())
                ui_zhandoujiemian.getMe().initPlayerDataUI();

            this.m_deadNum_monster = 0;
            this.m_deadNum_player = 0;
            this.m_hasDead = false;
            ui_arraw.ShowOrHide(true);

            RoundManager.getMe().start();
        }

        // 当前玩家
        createPlayer(heroname: string, pos: cc.Vec2): player {
            let l_player = new player();
            l_player.init(heroname, 1);
            l_player.setPosition(pos);
            this.addChild(l_player.getNode(), 2000);
            this.m_player_map.set(l_player.__instanceId, l_player);
            this.m_AllRole_map.set(RoundManager.getMe().m_maxRoleIndex, l_player);
            l_player.m_index = RoundManager.getMe().m_maxRoleIndex++;
            return l_player;
        }

        createMonster(name: string, pos: cc.Vec2): monster {
            let l_monster = new monster();
            l_monster.init(name);
            l_monster.setPosition(pos);
            this.addChild(l_monster.getNode(), 0);
            this.m_monster_map.set(l_monster.__instanceId, l_monster);
            this.m_AllRole_map.set(RoundManager.getMe().m_maxRoleIndex, l_monster);
            l_monster.m_index = RoundManager.getMe().m_maxRoleIndex++;
            return l_monster;
        }

        // removeMonster(l_monster: monster) {
        //     this.m_monster_map.delete(l_monster.__instanceId);
        //     this.m_AllRole_map.delete(l_monster.__instanceId);
        //     l_monster.shutdown();
        //     this.removeChild(l_monster.getNode());
        // }

        shutdown() {
            if (ui_arraw.getMe()) {
                ui_arraw.ShowOrHide(false);
            }
            if (playControl.getMe()) {
                playControl.getMe().shutdown();
            }
            this.m_AllRole_map.forEach(function (v, k) {
                v.shutdown();
            }, this);
            this.m_AllRole_map.clear();
            this.m_monster_map.clear();
            this.m_player_map.clear();
            // this.getNode().removeAllChildren(true);
        }

        //暂停动画
        zanting(falg) {
            this.m_AllRole_map.forEach(function (v, k) {
                v.zanting(falg);
            }, this);
        }

        // m_first = true;
        update(t) {
            this.m_AllRole_map.forEach(function (v: baseRole, k) {
                v.update(t);
            }, this);

            // if(this.m_first){
            //     for(let i in this.m_onsterData){
            //         this.createMonster(this.m_onsterData[i].monstername,
            //             cc.p(this.m_onsterData[i].pos_x, this.m_onsterData[i].pos_y));
            //
            //     }
            //     RoundManager.getMe().start();
            //     this.m_first = false
            // }
        }
    }
}
//# sourceMappingURL=roleMgr.js.map