module game {
    export class sceneMgr extends xjNode {

        static g_instance: sceneMgr;

        static getMe(): sceneMgr {
            return sceneMgr.create();
        };

        m_curScene: baseScene = null;

        static create() {
            if (sceneMgr.g_instance == null) {
                sceneMgr.g_instance = new sceneMgr();
            }
            return sceneMgr.g_instance;
        };

        getCurSceneName() {
            if (this.getCurSceneType() == e_SceneType.SceneType_fight) {
                let sn = this.m_curScene.m_scenename.split("_");
                if (sn.length > 2) {
                    return sn[0] + "_" + sn[1];
                }
            }
            return this.m_curScene.m_scenename;
        }

        getCurSceneType(): e_SceneType {
            if (this.m_curScene == null) {
                return e_SceneType.SceneType_login;
            }
            return this.m_curScene.m_SceneType;
        }

        getCurScene(): baseScene {
            return this.m_curScene;
        }

        getCurSceneInfo() {
            try {
                return this.m_curScene.m_SceneInfo;
            }
            catch (e) {
                console.log(e.stack);
            }

        }

        getSceneInfoBySceneName(sceneName): scene_config_data_s {
            return fileMgr.g_scene_config_data_Map.get(sceneName);
        }

        readSceneInfo(sceneName) {
            return;
        }

        //删除当前场景
        shutdownCurScene() {
            // if (this.m_curScene) {
            //     this.m_curScene.shutdown()
            //     this.removeChild(this.m_curScene.getNode(), true)
            //     this.m_curScene = null
            // }
        }

        selectScene(type: e_SceneType, sceneName?, callback?, callback_data?) {
            js_GameLogicMgr.getMe().removeAllSpineMem();
            this.selectSceneEx(type, sceneName);
        }

        restart() {
            this.selectScene(this.getCurSceneType(), this.getCurSceneName());
        }

        selectSceneEx(type: e_SceneType, sceneName: any = null) {
            if (type == e_SceneType.SceneType_guide) {
                //通过新手引导界面 到第二关心及后面的所有关
                // if (dataMgr.getMe().getCurGuankaid() > 1) {
                //     type = e_SceneType.SceneType_fight;
                // }
            }
            if (this.m_curScene != null) {
                this.m_curScene.shutdown();
                this.removeChild(this.m_curScene.getNode(), true);
                this.m_curScene = null;
            }
            //登陆背景
            if (type == e_SceneType.SceneType_login) {
                this.m_curScene = loginscene.scene();
                this.addChild(this.m_curScene.getNode());
            }
            else if (type == e_SceneType.SceneType_main) {
                this.m_curScene = mainscene.scene();
                this.addChild(this.m_curScene.getNode());
            }
            //战斗背景
            else if (type == e_SceneType.SceneType_fight) {
                this.m_curScene = fightscene.scene();
                this.m_curScene.loadscene(sceneName);
                this.addChild(this.m_curScene.getNode());
            }
            else if (type == e_SceneType.SceneType_fightai) {
                this.m_curScene = fightAiscene.scene();
                this.m_curScene.loadscene(sceneName);
                this.addChild(this.m_curScene.getNode());
            }
            //测试场景
            // else if (type == e_SceneType.SceneType_test) {
            //     this.m_curScene = testScene.scene();
            //     this.m_curScene.loadscene(sceneName);
            //     this.addChild(this.m_curScene.getNode());
            // }
            //PVP场景
            else if (type == e_SceneType.SceneType_pvp) {
                this.m_curScene = PVP_fight.scene();
                this.m_curScene.loadscene(sceneName);
                this.addChild(this.m_curScene.getNode());
            }
            else if (type == e_SceneType.SceneType_guide) {
                this.m_curScene = yindaoScene.scene();
                this.m_curScene.loadscene(sceneName);
                this.addChild(this.m_curScene.getNode());
            }
            else {
                console.error("error");
            }

            if (this.m_curScene == null) {
                console.error("error");
            }

            return this.m_curScene;
        }

        update(t) {
            if (this.m_curScene) {
                this.m_curScene.update(t);
            }
        }
    }

}
