var game;
(function (game) {
    var TiledMapEX = (function () {
        function TiledMapEX(node) {
            this.m_node = null;
            this.m_TmxLayer = null;
            this.m_node = node;
            this.init();
            if (game.sceneMgr.getMe().getCurScene() instanceof game.PVP_fight) {
                this.m_isPvp = true;
            }
        }
        TiledMapEX.create = function (path, parent) {
            path = game.g_tmxPath + path;
            var _tileMap = new cc.TMXTiledMap(path);
            var _ex = new TiledMapEX(_tileMap);
            if (parent) {
                parent.addChild(_ex.getNode());
            }
            return _ex;
        };
        TiledMapEX.prototype.getNode = function () {
            return this.m_node;
        };
        TiledMapEX.prototype.init = function () {
            this.m_TmxLayer = this.m_node.getLayer("layer");
            if (this.m_TmxLayer == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "tiledMap没有Layer层");
            }
            this.m_TmxLayer.getTexture().setAliasTexParameters();
            var arr = [];
            for (var h = 0; h < this.getMapSize().height; h++) {
                for (var w = 0; w < this.getMapSize().width; w++) {
                    var tileCoord = cc.p(w, h);
                    var gid = this.getGIDbytileCoord(tileCoord);
                    if (gid != 0) {
                        var spr = this.getSpriteByCoord(tileCoord);
                        var data = game.g_fangkuai_config[(gid - 1).toString()];
                        spr.setUserData({
                            des: data.des,
                            naijiu: data.naijiu,
                            touch: data.touch,
                            dangqian: data.naijiu,
                            byBulletId: 0
                        });
                    }
                    arr.push(gid);
                }
            }
            // g_invalid_tiD.length = 0;
            // for (let p in g_fangkuai_config) {
            //     if (g_fangkuai_config[p].touch == 0) {
            //         g_invalid_tiD.push(Number(p) + 1);
            //     }
            // }
            this.m_mapCeilArr = new Array();
            for (var p in game.g_fangkuai_config) {
                if (game.g_fangkuai_config[p].touch == 0) {
                    this.m_mapCeilArr.push(parseInt(p) + 1);
                }
            }
        };
        // colide(role): boolean {
        //     let pos = role.getPosition();
        //     let weaponconfig: weaponconfig_s = role.m_info["weaponConfig"];
        //     let weaponlevelconfig: weaponlevelconfig_s = role.m_info["weaponlevelconfig"];
        //     //判断爆炸范围
        //     let isremove = !(role.m_info.hitType == "hit");
        //     if (this.reMoveSpriteByWorldPosition(pos, isremove)) {
        //         if (weaponconfig) {
        //             if (weaponconfig.teshu == "blink") {
        //                 role.m_owner.setPosition(pos);
        //                 return true;
        //             }
        //             let boomrange = weaponlevelconfig.boomRange;
        //             let q = 0;
        //             if (boomrange != 0) {
        //                 while (boomrange >= 0) {
        //                     for (let p = boomrange; p >= -boomrange; p--) {
        //                         let newP = cc.pAdd(pos, cc.p(p * this.getTileSize().width, -q * this.getTileSize().height));
        //                         if (this.reMoveSpriteByWorldPosition(newP, isremove)) {
        //                             if (weaponconfig) {
        //                                 spineMgr.getMe().createSpineOncePlay(weaponconfig.boomSpine, weaponconfig.boomAnimation, roleMgr.getMe().getNode(), newP, role.getLocalZOrder());
        //                             }
        //                         }
        //                     }
        //                     --boomrange;
        //                     --q;
        //                 }
        //             }
        //             else {
        //                 if (weaponconfig) {
        //                     spineMgr.getMe().createSpineOncePlay(weaponconfig.boomSpine, weaponconfig.boomAnimation, roleMgr.getMe().getNode(), pos, role.getLocalZOrder());
        //                 }
        //             }
        //         }
        //         try {
        //             let boomdata = role.m_info.weapondata.hit.shanghai1;
        //             if (boomdata) {
        //                 spineMgr.getMe().createSpineOncePlay(boomdata.spineName, boomdata.animationName, roleMgr.getMe().getNode(), pos, role.getLocalZOrder());
        //             }
        //         }
        //         catch (e) {
        //
        //         }
        //         return true
        //     }
        //     return false
        // }
        //
        // colide_gongjizudang1(role: baseRole) {
        //     return this.reMoveSpriteByWorldPosition(role.getBoneWroldPosition(("gongjizudang1")));
        // }
        TiledMapEX.prototype.getGIDHard = function (pos) {
            if (!this.m_TmxLayer)
                return false;
            var num = (this.m_TmxLayer.getTileGIDAt(this.tileCoordFromWorldPosition(pos)));
            if (!num) {
                return 1;
            }
            var hard = game.g_fangkuai_config[num + ""].hard;
            if (!hard)
                return 1;
            return hard;
        };
        TiledMapEX.prototype.canMove = function (pos) {
            if (!this.m_TmxLayer)
                return false;
            var tileCoord = this.tileCoordFromWorldPosition(pos);
            var tileGid = this.m_TmxLayer.getTileGIDAt(tileCoord);
            for (var i = 0; i < this.m_mapCeilArr.length; ++i) {
                if (this.m_mapCeilArr[i] == tileGid) {
                    return true;
                }
            }
            return tileGid == 0;
        };
        TiledMapEX.prototype.reMoveSpriteByWorldPosition = function (worldPosithon, remove, bulletId) {
            var tileCoord = this.tileCoordFromWorldPosition(worldPosithon);
            var Tmx_spr = this.getSpriteByCoord(tileCoord);
            if (Tmx_spr) {
                var data = Tmx_spr.getUserData();
                // Tmx_spr.opacity = --data.dangqian / data.naijiu * 255
                if (data.byBulletId == bulletId)
                    return;
                data.dangqian -= remove;
                data.byBulletId = bulletId;
                if (data.dangqian < 0) {
                    data.dangqian = 0;
                }
                if (data.dangqian == 0) {
                    if (this.m_isPvp) {
                        if (game.proto_fightPVP.getMe().m_isP1) {
                            game.sync_ceil.getMe().send(worldPosithon);
                            this.m_TmxLayer.removeChild(Tmx_spr, true);
                        }
                        return;
                    }
                    this.m_TmxLayer.removeChild(Tmx_spr, true);
                }
            }
        };
        ;
        TiledMapEX.prototype.reMoveSpriteByWorldPositionEx = function (worldPosithon) {
            var tileCoord = this.tileCoordFromWorldPosition(worldPosithon);
            var Tmx_spr = this.getSpriteByCoord(tileCoord);
            if (Tmx_spr) {
                this.m_TmxLayer.removeChild(Tmx_spr, true);
            }
        };
        ;
        TiledMapEX.prototype.removeSpriteOneByTiledCoord = function (tileCoord) {
            var Tmx_spr = this.getSpriteByCoord(tileCoord);
            if (Tmx_spr) {
                this.m_TmxLayer.removeChild(Tmx_spr, true);
            }
        };
        TiledMapEX.prototype.getSpriteByCoord = function (tileCoordinate) {
            // tileCoordinate = cc.p(Math.round(tileCoordinate.x), Math.round(tileCoordinate.y));
            return this.m_TmxLayer.getTileAt(tileCoordinate);
        };
        ;
        TiledMapEX.prototype.getSpriteByWorldPosition = function (WorldPosition) {
            var tileCoord = this.getGIDbyWorldPosition(WorldPosition);
            return this.m_TmxLayer.getTileAt(tileCoord);
        };
        ;
        //将世界坐标转换为格子坐标
        TiledMapEX.prototype.tileCoordFromWorldPosition = function (Worldposition) {
            //获得x轴瓦片坐标（单位是瓦片数），_tileMap.getTileSize().width是每个瓦片的宽度，单位是像素
            var x = Worldposition.x / this.m_node.getTileSize().width;
            //反转坐标轴，结果除以每个瓦片的高度_tileMap.getTileSize().height，就得到y轴瓦片坐标了。
            var y = ((this.m_node.getMapSize().height * this.m_node.getTileSize().height) - Worldposition.y) / this.m_node.getTileSize().height;
            if (x >= this.getMapSize().width)
                x = this.getMapSize().width;
            if (y >= this.getMapSize().height)
                y = this.getMapSize().height;
            return cc.p(Math.max(0, Math.ceil(x) - 1), Math.max(0, Math.ceil(y) - 1));
            // return cc.p(Math.round(x), Math.round(y));
        };
        ;
        //通过格子坐标获取GID值
        TiledMapEX.prototype.getGIDbytileCoord = function (tileCoord) {
            //获得瓦片的GID  对应图片的相应id值
            var tileGid = this.m_TmxLayer.getTileGIDAt(tileCoord);
            return tileGid;
        };
        ;
        //通过世界坐标获取GID值
        TiledMapEX.prototype.getGIDbyWorldPosition = function (worldpos) {
            var tileCoord = this.tileCoordFromWorldPosition(worldpos);
            var Gid = this.m_TmxLayer.getTileGIDAt(tileCoord);
            return Gid;
        };
        TiledMapEX.prototype.getTileSize = function () {
            return this.m_node.getTileSize();
        };
        TiledMapEX.prototype.getMapSize = function () {
            return this.m_node.getMapSize();
        };
        //通过世界坐标获取GID值
        TiledMapEX.prototype.getGIDbyWorldPositionMin = function (worldpos) {
            var tileCoord = this.tileCoordFromWorldPosition(worldpos);
            var gid = this.m_TmxLayer.getTileGIDAt(tileCoord);
            //直接将格子坐标转为0，才能掉落
            // for (let p in g_invalid_tiD) {
            //     if (g_invalid_tiD[p] == gid) {
            //         return 0;
            //     }
            // }
            return gid;
        };
        ;
        return TiledMapEX;
    }());
    game.TiledMapEX = TiledMapEX;
})(game || (game = {}));
//# sourceMappingURL=TiledMapEX.js.map