module game {
    import Size = cc.Size;
    //http://blog.csdn.net/qq_30150251/article/details/52143106
    //https://www.2cto.com/kf/201401/273800.html
    //黑边抖动bug http://blog.csdn.net/hj3601947/article/details/49861211
    import Vec2 = cc.Vec2;
    import number = cc.number;

    export class TiledMapEX {
        static create(path, parent: cc.Node): TiledMapEX {
            path = g_tmxPath + path;
            let _tileMap = new cc.TMXTiledMap(path);
            let _ex = new TiledMapEX(_tileMap);
            if (parent) {
                parent.addChild(_ex.getNode());
            }
            return _ex;
        }

        m_node: cc.TMXTiledMap = null;
        m_TmxLayer: cc.TMXLayer = null;
        // m_ObjectLayer: cc.TMXObjectGroup = null;
        m_mapCeilArr: Array<number>;

        m_isPvp:boolean;

        constructor(node: cc.TMXTiledMap) {
            this.m_node = node;
            this.init();

            if(sceneMgr.getMe().getCurScene() instanceof PVP_fight){
                this.m_isPvp = true;
            }
        }

        getNode() {
            return this.m_node;
        }

        init() {
            this.m_TmxLayer = this.m_node.getLayer("layer");
            if (this.m_TmxLayer == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "tiledMap没有Layer层");
            }

            this.m_TmxLayer.getTexture().setAliasTexParameters();

            let arr = [];

            for (let h = 0; h < this.getMapSize().height; h++) {
                for (let w = 0; w < this.getMapSize().width; w++) {
                    let tileCoord = cc.p(w, h);
                    let gid = this.getGIDbytileCoord(tileCoord);
                    if (gid != 0) {
                        let spr = this.getSpriteByCoord(tileCoord);
                        let data = g_fangkuai_config[(gid - 1).toString()];
                        spr.setUserData({
                            des: data.des,
                            naijiu: data.naijiu,
                            touch: data.touch,
                            dangqian: data.naijiu,
                            byBulletId: 0
                        });
                    }
                    arr.push(gid);
                }
                // console.log(JSON.stringify(arr))
            }
            // g_invalid_tiD.length = 0;
            // for (let p in g_fangkuai_config) {
            //     if (g_fangkuai_config[p].touch == 0) {
            //         g_invalid_tiD.push(Number(p) + 1);
            //     }
            // }

            this.m_mapCeilArr = new Array<number>();
            for (let p in g_fangkuai_config) {
                if (g_fangkuai_config[p].touch == 0) {
                    this.m_mapCeilArr.push(parseInt(p) + 1);
                }
            }
        }

        // colide(role): boolean {
        //     let pos = role.getPosition();
        //     let weaponconfig: weaponconfig_s = role.m_info["weaponConfig"];
        //     let weaponlevelconfig: weaponlevelconfig_s = role.m_info["weaponlevelconfig"];
        //     //判断爆炸范围
        //     let isremove = !(role.m_info.hitType == "hit");
        //     if (this.reMoveSpriteByWorldPosition(pos, isremove)) {
        //         if (weaponconfig) {
        //             if (weaponconfig.teshu == "blink") {
        //                 role.m_owner.setPosition(pos);
        //                 return true;
        //             }
        //             let boomrange = weaponlevelconfig.boomRange;
        //             let q = 0;
        //             if (boomrange != 0) {
        //                 while (boomrange >= 0) {
        //                     for (let p = boomrange; p >= -boomrange; p--) {
        //                         let newP = cc.pAdd(pos, cc.p(p * this.getTileSize().width, -q * this.getTileSize().height));
        //                         if (this.reMoveSpriteByWorldPosition(newP, isremove)) {
        //                             if (weaponconfig) {
        //                                 spineMgr.getMe().createSpineOncePlay(weaponconfig.boomSpine, weaponconfig.boomAnimation, roleMgr.getMe().getNode(), newP, role.getLocalZOrder());
        //                             }
        //                         }
        //                     }
        //                     --boomrange;
        //                     --q;
        //                 }
        //             }
        //             else {
        //                 if (weaponconfig) {
        //                     spineMgr.getMe().createSpineOncePlay(weaponconfig.boomSpine, weaponconfig.boomAnimation, roleMgr.getMe().getNode(), pos, role.getLocalZOrder());
        //                 }
        //             }
        //         }
        //         try {
        //             let boomdata = role.m_info.weapondata.hit.shanghai1;
        //             if (boomdata) {
        //                 spineMgr.getMe().createSpineOncePlay(boomdata.spineName, boomdata.animationName, roleMgr.getMe().getNode(), pos, role.getLocalZOrder());
        //             }
        //         }
        //         catch (e) {
        //
        //         }
        //         return true
        //     }
        //     return false
        // }
        //
        // colide_gongjizudang1(role: baseRole) {
        //     return this.reMoveSpriteByWorldPosition(role.getBoneWroldPosition(("gongjizudang1")));
        // }

        getGIDHard(pos: cc.Vec2) {
            if (!this.m_TmxLayer) return false;
            let num = (this.m_TmxLayer.getTileGIDAt(this.tileCoordFromWorldPosition(pos)));
            if(!num){
                return 1;
            }
            let hard = g_fangkuai_config[num + ""].hard;
            if(!hard) return 1;
            return hard;
        }

        canMove(pos: cc.Vec2): boolean {
            if (!this.m_TmxLayer) return false;
            let tileCoord = this.tileCoordFromWorldPosition(pos);
            let tileGid = this.m_TmxLayer.getTileGIDAt(tileCoord);
            for (let i = 0; i < this.m_mapCeilArr.length; ++i) {
                if (this.m_mapCeilArr[i] == tileGid) {
                    return true;
                }
            }
            return tileGid == 0;
        }

        reMoveSpriteByWorldPosition(worldPosithon: Vec2, remove: number, bulletId: number) {
            let tileCoord = this.tileCoordFromWorldPosition(worldPosithon);
            let Tmx_spr = this.getSpriteByCoord(tileCoord);
            if (Tmx_spr) {
                let data = Tmx_spr.getUserData();
                // Tmx_spr.opacity = --data.dangqian / data.naijiu * 255
                if (data.byBulletId == bulletId) return;
                data.dangqian -= remove;
                data.byBulletId = bulletId;
                if (data.dangqian < 0) {
                    data.dangqian = 0;
                }
                if (data.dangqian == 0){
                    if(this.m_isPvp){
                        if(proto_fightPVP.getMe().m_isP1){
                            sync_ceil.getMe().send(worldPosithon);
                            this.m_TmxLayer.removeChild(Tmx_spr, true);
                        }
                        return;
                    }
                    this.m_TmxLayer.removeChild(Tmx_spr, true);
                }
            }
        };

        reMoveSpriteByWorldPositionEx(worldPosithon: Vec2) {
            let tileCoord = this.tileCoordFromWorldPosition(worldPosithon);
            let Tmx_spr = this.getSpriteByCoord(tileCoord);
            if (Tmx_spr) {
                this.m_TmxLayer.removeChild(Tmx_spr, true);
            }
        };

        removeSpriteOneByTiledCoord(tileCoord) {
            let Tmx_spr = this.getSpriteByCoord(tileCoord);
            if (Tmx_spr) {
                this.m_TmxLayer.removeChild(Tmx_spr, true);
            }
        }


        getSpriteByCoord(tileCoordinate: Vec2) {
            // tileCoordinate = cc.p(Math.round(tileCoordinate.x), Math.round(tileCoordinate.y));
            return this.m_TmxLayer.getTileAt(tileCoordinate);

        };

        getSpriteByWorldPosition(WorldPosition: Vec2) {
            let tileCoord = this.getGIDbyWorldPosition(WorldPosition);
            return this.m_TmxLayer.getTileAt(tileCoord);

        };

        //将世界坐标转换为格子坐标
        tileCoordFromWorldPosition(Worldposition: Vec2) {
            //获得x轴瓦片坐标（单位是瓦片数），_tileMap.getTileSize().width是每个瓦片的宽度，单位是像素
            let x = Worldposition.x / this.m_node.getTileSize().width;
            //反转坐标轴，结果除以每个瓦片的高度_tileMap.getTileSize().height，就得到y轴瓦片坐标了。
            let y = ((this.m_node.getMapSize().height * this.m_node.getTileSize().height) - Worldposition.y) / this.m_node.getTileSize().height;
            if (x >= this.getMapSize().width)
                x = this.getMapSize().width;
            if (y >= this.getMapSize().height)
                y = this.getMapSize().height;
            return cc.p(Math.max(0, Math.ceil(x) - 1), Math.max(0, Math.ceil(y) - 1));
            // return cc.p(Math.round(x), Math.round(y));
        };

        //通过格子坐标获取GID值
        getGIDbytileCoord(tileCoord) {
            //获得瓦片的GID  对应图片的相应id值
            let tileGid = this.m_TmxLayer.getTileGIDAt(tileCoord);
            return tileGid;
        };

        //通过世界坐标获取GID值
        getGIDbyWorldPosition(worldpos) {
            let tileCoord = this.tileCoordFromWorldPosition(worldpos);
            let Gid = this.m_TmxLayer.getTileGIDAt(tileCoord);
            return Gid;
        }

        getTileSize(): Size {
            return this.m_node.getTileSize()
        }

        getMapSize(): Size {
            return this.m_node.getMapSize()
        }

        //通过世界坐标获取GID值
        getGIDbyWorldPositionMin(worldpos) {
            let tileCoord = this.tileCoordFromWorldPosition(worldpos);
            let gid = this.m_TmxLayer.getTileGIDAt(tileCoord);
            //直接将格子坐标转为0，才能掉落
            // for (let p in g_invalid_tiD) {
            //     if (g_invalid_tiD[p] == gid) {
            //         return 0;
            //     }
            // }
            return gid;
        };
    }

}