/**
 * Created by xieli on 2017/2/24.
 */

module game {
    export class ProgressTimerEx {
        m_ProgressTimer: cc.ProgressTimer;
        m_parent: cc._BaseNode;

        //精灵路径，冷却时间，坐标，父类Node对象，缩放比例
        constructor(Sprite_path: string, pos: cc.Vec2, parent: cc._BaseNode, scale: number = 1) {
            let sprite = new cc.Sprite(Sprite_path);
            this.m_ProgressTimer = new cc.ProgressTimer(sprite);
            this.m_ProgressTimer.setType(cc.ProgressTimer.TYPE_RADIAL);
            this.m_ProgressTimer.setScale(scale);
            this.m_ProgressTimer.setPosition(pos.x, pos.y);
            this.m_ProgressTimer.setPercentage(0);
            this.m_parent = parent;
            this.m_parent.addChild(this.m_ProgressTimer,100);
        }

        setPosition(p:cc.Vec2){
            this.m_ProgressTimer.setPosition(p);
        }

        setRotation(r:number){
            this.m_ProgressTimer.setRotation(r);
        }

        setPercentage(per: number) {
            this.m_ProgressTimer.setPercentage(per);
        }

        shutdown() {
            this.m_parent.removeChild(this.m_ProgressTimer);
            this.m_ProgressTimer = null;
        }
    }
}