var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var ui_pifu = (function (_super) {
        __extends(ui_pifu, _super);
        function ui_pifu() {
            _super.call(this);
            this.m_skinlist = null;
            this.m_curKey = 0;
            this.m_node = null;
            this.m_listView = null;
            this.m_spine = null;
            this.m_cursender = null; //当前按钮
            this.m_des = "ui_pifu";
            this.m_CBaseKeyState = new game.BaseKeyState();
        }
        ui_pifu.prototype.left = function () {
            this.m_CBaseKeyState.left();
            if (this.m_curKey > 0) {
                this.m_curKey--;
                this.updateSpine();
            }
            var node = this.m_CBaseKeyState.m_key.node;
            var per = Math.floor((node.getPositionX() - node.getContentSize().width / 2) / this.m_listView.getInnerContainerSize().width * 100);
            this.m_listView.jumpToPercentHorizontal(per);
        };
        ui_pifu.prototype.right = function () {
            this.m_CBaseKeyState.right();
            if (this.m_curKey < this.m_skinlist.length - 1) {
                this.m_curKey++;
                this.updateSpine();
            }
            var node = this.m_CBaseKeyState.m_key.node;
            var per = Math.floor((node.getPositionX() + node.getContentSize().width / 2) / this.m_listView.getInnerContainerSize().width * 100);
            this.m_listView.jumpToPercentHorizontal(per);
        };
        ui_pifu.prototype.oninit = function (data) {
            var root = this._parseUIFile("shangcheng_pifu.json", 0);
            this.EnterUI();
            this.shipeiCenter(root);
            this.addChild(root);
            this.m_skinlist = new Array();
            this.m_listView = ccui.helper.seekWidgetByName(this.m_root, "ListView_1");
            this.m_node = ccui.helper.seekWidgetByName(this.m_root, "Node");
            var tuichu = ccui.helper.seekWidgetByName(this.m_root, "tuichu");
            if (!game.Version_mgr.getInstance().isPhone()) {
                game.dataMgr.getMe().loadCheckBoximg(tuichu, "xingjietantantang/big/ui/image/ddt_ui138b.png");
            }
            tuichu.addTouchEventListener(this.tuichu_func, this);
            this.initUI();
            this.updateSpine();
            if (game.Version_mgr.getInstance().isPhone()) {
                var imag = ccui.helper.seekWidgetByTag(this.m_root, 1264);
                imag.setVisible(false);
            }
            else {
                this.m_CBaseKeyState.init(this);
                this.m_CBaseKeyState.setCurKey_byId(0);
            }
            this.m_listView.jumpToPercentHorizontal(0);
        };
        ui_pifu.prototype.tuichu_func = function (sender, type) {
            switch (type) {
                case ccui.Widget.TOUCH_ENDED:
                    this.onBack();
                    break;
            }
        };
        ui_pifu.prototype.initUI = function () {
            //获取配置表的数据
            for (var p in game.g_pifu_config) {
                for (var k in game.g_shangcheng_config["pifu"]) {
                    if (p == game.g_shangcheng_config["pifu"][k]) {
                        console.log(game.g_pifu_config[p].name + "  spine:" + game.g_pifu_config[p].spine + "  skin:" + game.g_pifu_config[p].skin);
                        this.m_skinlist.push(cc.clone(game.g_pifu_config[p]));
                    }
                }
            }
            var button = ccui.helper.seekWidgetByName(this.m_listView, "tx_1");
            button.addTouchEventListener(this.buySkinFun, this);
            button.setUserData(0);
            for (var i = 0; i < this.m_skinlist.length; i++) {
                if (i == 0) {
                    var flag = game.itemMgr.getMe().getSkinislock(game.itemMgr.getMe().stringToType(this.m_skinlist[i].name));
                    var suo = ccui.helper.seekWidgetByName(button, "suo");
                    var texiao = ccui.helper.seekWidgetByName(button, "uitexiao");
                    if (game.Version_mgr.getInstance().isPhone()) {
                        texiao.setVisible(false);
                    }
                    else {
                        this.m_CBaseKeyState.regNodeEx(button, i);
                    }
                    if (flag) {
                        suo.setVisible(false);
                    }
                    else {
                        suo.setVisible(true);
                    }
                    this.loadImg(button, this.m_skinlist[i].icon);
                }
                else {
                    var copy_data = button.clone();
                    copy_data.setUserData(i);
                    var flag = game.itemMgr.getMe().getSkinislock(game.itemMgr.getMe().stringToType(this.m_skinlist[i].name));
                    var suo = ccui.helper.seekWidgetByName(copy_data, "suo");
                    var texiao = ccui.helper.seekWidgetByName(copy_data, "uitexiao");
                    copy_data.addTouchEventListener(this.buySkinFun, this);
                    if (game.Version_mgr.getInstance().isPhone()) {
                        texiao.setVisible(false);
                    }
                    else {
                        this.m_CBaseKeyState.regNodeEx(copy_data, i);
                    }
                    if (flag) {
                        suo.setVisible(false);
                    }
                    else {
                        suo.setVisible(true);
                    }
                    this.loadImg(copy_data, this.m_skinlist[i].icon);
                    this.m_listView.pushBackCustomItem(copy_data);
                }
            }
        };
        ui_pifu.prototype.loadImg = function (chekbox, imgpath) {
            chekbox.loadTextureBackGround(imgpath, null);
            chekbox.loadTextureBackGroundDisabled(imgpath, null);
            chekbox.loadTextureBackGroundSelected(imgpath, null);
            chekbox.loadTextureFrontCross(imgpath, null);
            chekbox.loadTextureFrontCrossDisabled(imgpath, null);
        };
        ui_pifu.prototype.updateSpine = function () {
            this.m_node.removeAllChildren(true);
            var skinconfig = this.m_skinlist[this.m_curKey];
            this.m_spine = game.spineMgr.getMe().createSpinePlay(skinconfig.spine, "daiji", true, this.m_node, cc.p(0, 0), 1);
            this.m_spine.setSkin(skinconfig.skin);
            var fightweapons = game.fileMgr.getMe().m_play_doc[game.dataMgr.getMe().getCurHero() + "_weapon"];
            if (fightweapons[0]) {
                var weaponconfig = game.dataMgr.getMe().getWeaponconfig(fightweapons[0].name);
                this.m_spine.replaceAttachmentImage("wuqi", weaponconfig.roleBujian);
            }
            else {
                this.m_spine.replaceAttachmentImage("wuqi", "shitou");
            }
            this.updatedes();
        };
        ui_pifu.prototype.updatedes = function () {
            var skinconfig = this.m_skinlist[this.m_curKey];
            var name = ccui.helper.seekWidgetByName(this.m_root, "name");
            var des = ccui.helper.seekWidgetByName(this.m_root, "miaoshu");
            var teshu = ccui.helper.seekWidgetByName(this.m_root, "teshu");
            var gongji = ccui.helper.seekWidgetByTag(this.m_root, 1251);
            var LoadingBar_2_gongji = ccui.helper.seekWidgetByName(gongji, "LoadingBar_2");
            var hp = ccui.helper.seekWidgetByTag(this.m_root, 1250);
            var xueliang = ccui.helper.seekWidgetByTag(this.m_root, 1246);
            var LoadingBar_2_xueliang = ccui.helper.seekWidgetByName(xueliang, "LoadingBar_2");
            var atk = ccui.helper.seekWidgetByTag(this.m_root, 1255);
            var jianshang = ccui.helper.seekWidgetByTag(this.m_root, 1241);
            var LoadingBar_2_jianshang = ccui.helper.seekWidgetByName(jianshang, "LoadingBar_2");
            var def = ccui.helper.seekWidgetByTag(this.m_root, 1245);
            var naili_img = ccui.helper.seekWidgetByTag(this.m_root, 1236);
            var LoadingBar_2_naili_img = ccui.helper.seekWidgetByName(naili_img, "LoadingBar_2");
            var naili = ccui.helper.seekWidgetByTag(this.m_root, 1240);
            var man = ccui.helper.seekWidgetByName(this.m_root, "nan");
            var male = ccui.helper.seekWidgetByName(this.m_root, "nv");
            var jinbi = ccui.helper.seekWidgetByTag(this.m_root, 1262);
            var zuansi = ccui.helper.seekWidgetByTag(this.m_root, 1217);
            var heroislock = game.itemMgr.getMe().getSkinislock(game.itemMgr.getMe().stringToType(skinconfig.name));
            if (heroislock) {
                zuansi.setVisible(false);
                jinbi.setVisible(false);
            }
            else if (skinconfig.jinbi == 1) {
                zuansi.setVisible(false);
                jinbi.setVisible(true);
                var num = ccui.helper.seekWidgetByTag(jinbi, 1263);
                if (num)
                    num.setString(game.itemMgr.getMe().getitemPricejinbi(skinconfig.name));
            }
            else {
                zuansi.setVisible(true);
                jinbi.setVisible(false);
                var num = ccui.helper.seekWidgetByTag(zuansi, 1218);
                if (num)
                    num.setString(game.itemMgr.getMe().getitemPriceZuansi(skinconfig.name));
            }
            name.setString(skinconfig.desName);
            des.setString(skinconfig.des);
            if (skinconfig.miaoshu) {
                teshu.setString(skinconfig.miaoshu);
            }
            hp.setString(skinconfig.hp);
            atk.setString(skinconfig.damage);
            def.setString(Number(skinconfig.damageRes.toFixed(2)) * 100 + "%");
            naili.setString(skinconfig.power);
            // isMale 1:男 0：女
            man.setVisible(skinconfig.isMale == 1);
            male.setVisible(skinconfig.isMale == 0);
            LoadingBar_2_gongji.setPercent(skinconfig.damage / (game.dataMgr.getMe().getSkinMax("damage")) * 100);
            LoadingBar_2_xueliang.setPercent(skinconfig.hp / (game.dataMgr.getMe().getSkinMax("hp")) * 100);
            LoadingBar_2_jianshang.setPercent(Number(skinconfig.damageRes.toFixed(2)) * 100);
            LoadingBar_2_naili_img.setPercent(skinconfig.power / (game.dataMgr.getMe().getSkinMax("power")) * 100);
        };
        ui_pifu.prototype.updatemoney = function () {
            var tili = ccui.helper.seekWidgetByTag(this.m_root, 1019);
            var zuansi = ccui.helper.seekWidgetByTag(this.m_root, 1017);
            var jinbi = ccui.helper.seekWidgetByTag(this.m_root, 1015);
            var maxenery = ccui.helper.seekWidgetByName(this.m_root, "zongshu");
            maxenery.setString("/" + game.g_max_energy);
            if (game.dataMgr.getMe().getViplevel() >= game.g_tilishangxianunlock) {
                maxenery.setString("/" + Number(game.g_max_energy * 2));
            }
            tili.setString(game.itemMgr.getMe().getItemnumbyType(game.e_item.e_tili));
            zuansi.setString(game.itemMgr.getMe().getItemnumbyType(game.e_item.e_zuanshi));
            jinbi.setString(game.itemMgr.getMe().getItemnumbyType(game.e_item.e_jinbi));
        };
        // left_Released() {
        //     if (this.m_curKey > 0) {
        //         this.m_curKey--
        //         this.updateSpine()
        //     }
        //     let node = this.m_CBaseKeyState.m_key.node;
        //     console.log("node:"+JSON.stringify(node));
        //     let per = (node.getPositionX()) / this.m_listView.getInnerContainer().getPositionX().width * 100 ;
        //     this.m_listView.jumpToPercentHorizontal(per);
        //     return super.left_Released();
        // }
        // right_Released() {
        //     if (this.m_curKey < this.m_skinlist.length - 1) {
        //         this.m_curKey++
        //         this.updateSpine()
        //     }
        //     // let p = cc.p(node:getPositionX)
        //     let node = this.m_CBaseKeyState.m_key.node;
        //     let per = (node.getPositionX())/this.m_listView.getInnerContainer().width * 100 ;
        //     console.log("per:" + per)
        //     this.m_listView.jumpToPercentHorizontal(per)
        //     return super.right_Released()
        // }
        ui_pifu.prototype.buySkinFun = function (sender, type) {
            switch (type) {
                case ccui.Widget.TOUCH_BEGAN:
                    this.m_curKey = sender.getUserData();
                    this.m_cursender = sender;
                    if (game.Version_mgr.getInstance().isPhone()) {
                        var texiao = ccui.helper.seekWidgetByName(sender, "uitexiao");
                        texiao.setVisible(true);
                        this.updateSpine();
                    }
                    break;
                case ccui.Widget.TOUCH_ENDED:
                    if (game.Version_mgr.getInstance().isPhone()) {
                        var texiao = ccui.helper.seekWidgetByName(sender, "uitexiao");
                        texiao.setVisible(false);
                    }
                    var _skindata = this.m_skinlist[this.m_curKey];
                    if (_skindata) {
                        var type_1 = game.itemMgr.getMe().stringToType(_skindata.name);
                        var jinbicost = game.itemMgr.getMe().getitemPricejinbi(_skindata.name);
                        var zuansicost = game.itemMgr.getMe().getitemPriceZuansi(_skindata.name);
                        if (!game.itemMgr.getMe().getSkinislock(type_1)) {
                            if (_skindata.jinbi == 1) {
                                if (jinbicost) {
                                    if (game.dataMgr.getMe().removeItemByType(game.e_item.e_jinbi, jinbicost)) {
                                        game.itemMgr.getMe().lockSkin(type_1);
                                        var suo = ccui.helper.seekWidgetByName(sender, "suo");
                                        suo.setVisible(false);
                                        this.updateSpine();
                                        game.ui_goumaichenggong.ShowOrHide(true, {
                                            name: "wupin",
                                            num: 1,
                                            icon: _skindata.icon,
                                            iconName: _skindata.desName
                                        });
                                    }
                                    else {
                                        // ui_messageBox2.ShowOrHide(true, "金币不足！是否花费" + zuansicost + "钻石购买皮肤？", () => {
                                        //     buy_mgr.getInstance().shoppingByDiamond(zuansicost,"解锁皮肤",ui_pifu.getMe().buySucceedCallBack,null)
                                        // });
                                        game.buy_mgr.getInstance().buySkin_buy(ui_pifu.getMe().buySucceedCallBack, ui_pifu.getMe(), _skindata.name);
                                    }
                                }
                            }
                            else {
                                game.buy_mgr.getInstance().buySkin_buy(ui_pifu.getMe().buySucceedCallBack, ui_pifu.getMe(), _skindata.name);
                            }
                        }
                    }
                    break;
                case ccui.Widget.TOUCH_CANCELED:
                    if (game.Version_mgr.getInstance().isPhone()) {
                        var texiao = ccui.helper.seekWidgetByName(sender, "uitexiao");
                        texiao.setVisible(false);
                    }
                    break;
            }
        };
        ui_pifu.prototype.buySucceedCallBack = function () {
            var _skindata = ui_pifu.getMe().m_skinlist[ui_pifu.getMe().m_curKey];
            var type = game.itemMgr.getMe().stringToType(_skindata.name);
            // let zuansicost: number = itemMgr.getMe().getitemPriceZuansi(_skindata.name);
            // httpMgr.getMe().sendMsg(g_httpType.type_httpShoppinglog,
            //     zuansicost + "钻石购买" + _skindata.desName);
            game.itemMgr.getMe().lockSkin(type);
            if (ui_pifu.getMe().m_cursender) {
                var suo = ccui.helper.seekWidgetByName(ui_pifu.getMe().m_cursender, "suo");
                suo.setVisible(false);
            }
            ui_pifu.getMe().updateSpine();
            game.ui_goumaichenggong.ShowOrHide(true, {
                name: "wupin",
                num: 1,
                icon: _skindata.icon,
                iconName: _skindata.desName
            });
        };
        ui_pifu.prototype.loop = function (t) {
            if (this.m_CBaseKeyState) {
                this.m_CBaseKeyState.loop(t);
                this.updatemoney();
            }
        };
        ui_pifu.prototype.onBack = function () {
            ui_pifu.ShowOrHide(false);
            game.ui_shop.ShowOrHide(true);
        };
        ui_pifu.g_instarn = null;
        ui_pifu.getMe = function () {
            return game.ui_pifu.g_instarn;
        };
        ui_pifu.ShowOrHide = function (flag) {
            game.UiBase.ShowOrHide(flag, game.ui_pifu, null, 1122);
        };
        return ui_pifu;
    }(game.UiBase));
    game.ui_pifu = ui_pifu;
})(game || (game = {}));
//# sourceMappingURL=ui_pifu.js.map