module game {

    export class ui_pifu extends game.UiBase {
        static g_instarn: ui_pifu = null;
        static getMe = function (): ui_pifu {
            return game.ui_pifu.g_instarn;
        };
        m_CBaseKeyState: BaseKeyState;
        static ShowOrHide = function (flag) {
            game.UiBase.ShowOrHide(flag, game.ui_pifu, null, 1122);
        };

        constructor() {
            super();
            this.m_des = "ui_pifu";
            this.m_CBaseKeyState = new BaseKeyState();
        }


        left(){
            this.m_CBaseKeyState.left();
            if (this.m_curKey > 0) {
                this.m_curKey--;
                this.updateSpine()
            }
            let node = this.m_CBaseKeyState.m_key.node;
            let per = Math.floor((node.getPositionX()-node.getContentSize().width/2)/this.m_listView.getInnerContainerSize().width*100);
            this.m_listView.jumpToPercentHorizontal(per)
        }
        right(){
            this.m_CBaseKeyState.right();
            if (this.m_curKey < this.m_skinlist.length - 1) {
                this.m_curKey++;
                this.updateSpine()
            }
            let node = this.m_CBaseKeyState.m_key.node;
            let per = Math.floor((node.getPositionX()+node.getContentSize().width/2)/this.m_listView.getInnerContainerSize().width*100);
            this.m_listView.jumpToPercentHorizontal(per)

        }

        m_skinlist: Array<skin_s> = null
        m_curKey: number = 0
        m_node: cc.Node = null
        m_listView: ccui.ListView = null;

        oninit(data) {
            let root = this._parseUIFile("shangcheng_pifu.json", 0);
            this.EnterUI();
            this.shipeiCenter(root);
            this.addChild(root);
            this.m_skinlist = new Array<skin_s>();

            this.m_listView = ccui.helper.seekWidgetByName(this.m_root, "ListView_1");
            this.m_node = ccui.helper.seekWidgetByName(this.m_root, "Node");
            let tuichu: ccui.CheckBox = ccui.helper.seekWidgetByName(this.m_root, "tuichu");
            if(!Version_mgr.getInstance().isPhone()){
                dataMgr.getMe().loadCheckBoximg(tuichu,"xingjietantantang/big/ui/image/ddt_ui138b.png")
            }
            tuichu.addTouchEventListener(this.tuichu_func, this);

            this.initUI();
            this.updateSpine();
            if (Version_mgr.getInstance().isPhone()) {
                let imag: ccui.Text = ccui.helper.seekWidgetByTag(this.m_root, 1264);
                imag.setVisible(false);
            } else {
                this.m_CBaseKeyState.init(this);
                this.m_CBaseKeyState.setCurKey_byId(0);
            }
            this.m_listView.jumpToPercentHorizontal(0);
        }

        tuichu_func(sender, type) {
            switch (type) {
                case ccui.Widget.TOUCH_ENDED:
                    this.onBack();
                    break;
            }
        }

        initUI() {
            //获取配置表的数据
            for (let p in g_pifu_config) {
                for (let k in g_shangcheng_config["pifu"]) {
                    if (p == g_shangcheng_config["pifu"][k]) {
                        console.log(g_pifu_config[p].name + "  spine:" + g_pifu_config[p].spine + "  skin:" + g_pifu_config[p].skin)
                        this.m_skinlist.push(cc.clone(g_pifu_config[p]))
                    }
                }

            }
            let button: ccui.CheckBox = ccui.helper.seekWidgetByName(this.m_listView, "tx_1");
            button.addTouchEventListener(this.buySkinFun, this);
            button.setUserData(0);
            for (let i = 0; i < this.m_skinlist.length; i++) {
                if (i == 0) {
                    let flag = itemMgr.getMe().getSkinislock(itemMgr.getMe().stringToType(this.m_skinlist[i].name));
                    let suo: ccui.ImageView = ccui.helper.seekWidgetByName(button, "suo");
                    let texiao: ccui.ImageView = ccui.helper.seekWidgetByName(button, "uitexiao");
                    if (Version_mgr.getInstance().isPhone()) {
                        texiao.setVisible(false);
                    } else {
                        this.m_CBaseKeyState.regNodeEx(button, i);
                    }
                    if (flag) {
                        suo.setVisible(false);
                    } else {
                        suo.setVisible(true);
                    }
                    this.loadImg(button, this.m_skinlist[i].icon);
                } else {
                    let copy_data = button.clone();
                    copy_data.setUserData(i);
                    let flag = itemMgr.getMe().getSkinislock(itemMgr.getMe().stringToType(this.m_skinlist[i].name));
                    let suo: ccui.ImageView = ccui.helper.seekWidgetByName(copy_data, "suo");
                    let texiao: ccui.ImageView = ccui.helper.seekWidgetByName(copy_data, "uitexiao");
                    copy_data.addTouchEventListener(this.buySkinFun, this);
                    if (Version_mgr.getInstance().isPhone()) {
                        texiao.setVisible(false);
                    } else {
                        this.m_CBaseKeyState.regNodeEx(copy_data, i);
                    }
                    if (flag) {
                        suo.setVisible(false);
                    } else {
                        suo.setVisible(true);
                    }
                    this.loadImg(copy_data, this.m_skinlist[i].icon);
                    this.m_listView.pushBackCustomItem(copy_data);
                }
            }
        }


        loadImg(chekbox: ccui.CheckBox, imgpath) {
            chekbox.loadTextureBackGround(imgpath, null)
            chekbox.loadTextureBackGroundDisabled(imgpath, null)
            chekbox.loadTextureBackGroundSelected(imgpath, null)
            chekbox.loadTextureFrontCross(imgpath, null)
            chekbox.loadTextureFrontCrossDisabled(imgpath, null)

        }





        m_spine: SkeletonAnimation_Ex = null;
        updateSpine() {
            this.m_node.removeAllChildren(true)
            let skinconfig: skin_s = this.m_skinlist[this.m_curKey]
            this.m_spine = spineMgr.getMe().createSpinePlay(skinconfig.spine, "daiji", true, this.m_node, cc.p(0, 0), 1)
            this.m_spine.setSkin(skinconfig.skin)
            let fightweapons = fileMgr.getMe().m_play_doc[dataMgr.getMe().getCurHero() + "_weapon"];
            if(fightweapons[0]){
                let weaponconfig:weaponconfig_s = dataMgr.getMe().getWeaponconfig(fightweapons[0].name);
                this.m_spine.replaceAttachmentImage("wuqi",weaponconfig.roleBujian)
            }else {
                this.m_spine.replaceAttachmentImage("wuqi","shitou");
            }
            this.updatedes()
        }

        updatedes() {
            let skinconfig: skin_s = this.m_skinlist[this.m_curKey]
            let name: ccui.Text = ccui.helper.seekWidgetByName(this.m_root, "name")
            let des: ccui.Text = ccui.helper.seekWidgetByName(this.m_root, "miaoshu")
            let teshu: ccui.Text = ccui.helper.seekWidgetByName(this.m_root, "teshu")

            let gongji: ccui.ImageView = ccui.helper.seekWidgetByTag(this.m_root, 1251)
            let LoadingBar_2_gongji: ccui.Loadingbar = ccui.helper.seekWidgetByName(gongji, "LoadingBar_2")
            let hp: ccui.Text = ccui.helper.seekWidgetByTag(this.m_root, 1250)

            let xueliang: ccui.ImageView = ccui.helper.seekWidgetByTag(this.m_root, 1246)
            let LoadingBar_2_xueliang: ccui.Loadingbar = ccui.helper.seekWidgetByName(xueliang, "LoadingBar_2")
            let atk: ccui.Text = ccui.helper.seekWidgetByTag(this.m_root, 1255)

            let jianshang: ccui.ImageView = ccui.helper.seekWidgetByTag(this.m_root, 1241)
            let LoadingBar_2_jianshang: ccui.Loadingbar = ccui.helper.seekWidgetByName(jianshang, "LoadingBar_2")
            let def: ccui.Text = ccui.helper.seekWidgetByTag(this.m_root, 1245)

            let naili_img: ccui.ImageView = ccui.helper.seekWidgetByTag(this.m_root, 1236)
            let LoadingBar_2_naili_img: ccui.Loadingbar = ccui.helper.seekWidgetByName(naili_img, "LoadingBar_2")
            let naili: ccui.Text = ccui.helper.seekWidgetByTag(this.m_root, 1240)
            let man: ccui.ImageView = ccui.helper.seekWidgetByName(this.m_root, "nan")
            let male: ccui.ImageView = ccui.helper.seekWidgetByName(this.m_root, "nv")

            let jinbi: ccui.ImageView = ccui.helper.seekWidgetByTag(this.m_root, 1262)
            let zuansi: ccui.ImageView = ccui.helper.seekWidgetByTag(this.m_root, 1217)

            let heroislock = itemMgr.getMe().getSkinislock(itemMgr.getMe().stringToType(skinconfig.name))
            if (heroislock) {
                zuansi.setVisible(false)
                jinbi.setVisible(false)
            }
            else if (skinconfig.jinbi == 1) {
                zuansi.setVisible(false)
                jinbi.setVisible(true)
                let num: ccui.Text = ccui.helper.seekWidgetByTag(jinbi, 1263)
                if (num)
                    num.setString(itemMgr.getMe().getitemPricejinbi(skinconfig.name))
            }
            else {
                zuansi.setVisible(true)
                jinbi.setVisible(false)
                let num: ccui.Text = ccui.helper.seekWidgetByTag(zuansi, 1218)
                if (num)
                    num.setString(itemMgr.getMe().getitemPriceZuansi(skinconfig.name))
            }

            name.setString(skinconfig.desName)
            des.setString(skinconfig.des);
            if (skinconfig.miaoshu) {
                teshu.setString(skinconfig.miaoshu)

            }
            hp.setString(skinconfig.hp)
            atk.setString(skinconfig.damage)
            def.setString(Number(skinconfig.damageRes.toFixed(2)) * 100 + "%")
            naili.setString(skinconfig.power)
            // isMale 1:男 0：女
            man.setVisible(skinconfig.isMale == 1)
            male.setVisible(skinconfig.isMale == 0)
            LoadingBar_2_gongji.setPercent(skinconfig.damage / (dataMgr.getMe().getSkinMax("damage")) * 100)
            LoadingBar_2_xueliang.setPercent(skinconfig.hp / (dataMgr.getMe().getSkinMax("hp")) * 100)
            LoadingBar_2_jianshang.setPercent(Number(skinconfig.damageRes.toFixed(2)) * 100)
            LoadingBar_2_naili_img.setPercent(skinconfig.power / (dataMgr.getMe().getSkinMax("power")) * 100)

        }

        updatemoney() {
            let tili: ccui.Text = ccui.helper.seekWidgetByTag(this.m_root, 1019)
            let zuansi: ccui.Text = ccui.helper.seekWidgetByTag(this.m_root, 1017)
            let jinbi: ccui.Text = ccui.helper.seekWidgetByTag(this.m_root, 1015)

            let maxenery:ccui.Text = ccui.helper.seekWidgetByName(this.m_root,"zongshu");
            maxenery.setString( "/" + g_max_energy);
            if(dataMgr.getMe().getViplevel() >= g_tilishangxianunlock){
                maxenery.setString("/" + Number(g_max_energy * 2))
            }

            tili.setString(itemMgr.getMe().getItemnumbyType(e_item.e_tili));
            zuansi.setString(itemMgr.getMe().getItemnumbyType(e_item.e_zuanshi));
            jinbi.setString(itemMgr.getMe().getItemnumbyType(e_item.e_jinbi));
        }
        // left_Released() {
        //     if (this.m_curKey > 0) {
        //         this.m_curKey--
        //         this.updateSpine()
        //     }
        //     let node = this.m_CBaseKeyState.m_key.node;
        //     console.log("node:"+JSON.stringify(node));
        //     let per = (node.getPositionX()) / this.m_listView.getInnerContainer().getPositionX().width * 100 ;
        //     this.m_listView.jumpToPercentHorizontal(per);
        //     return super.left_Released();
        // }
        // right_Released() {
        //     if (this.m_curKey < this.m_skinlist.length - 1) {
        //         this.m_curKey++
        //         this.updateSpine()
        //     }
        //     // let p = cc.p(node:getPositionX)
        //     let node = this.m_CBaseKeyState.m_key.node;
        //     let per = (node.getPositionX())/this.m_listView.getInnerContainer().width * 100 ;
        //     console.log("per:" + per)
        //     this.m_listView.jumpToPercentHorizontal(per)
        //     return super.right_Released()
        // }


        buySkinFun(sender, type) {
            switch (type) {
                case ccui.Widget.TOUCH_BEGAN:
                    this.m_curKey = sender.getUserData();
                    this.m_cursender = sender;
                    if (Version_mgr.getInstance().isPhone()) {
                        let texiao: ccui.ImageView = ccui.helper.seekWidgetByName(sender, "uitexiao");
                        texiao.setVisible(true);
                        this.updateSpine();
                    }
                    break;
                case ccui.Widget.TOUCH_ENDED:
                    if (Version_mgr.getInstance().isPhone()) {
                        let texiao: ccui.ImageView = ccui.helper.seekWidgetByName(sender, "uitexiao");
                        texiao.setVisible(false);
                    }
                    let _skindata: skin_s = this.m_skinlist[this.m_curKey];
                    if (_skindata) {
                        let type: e_item = itemMgr.getMe().stringToType(_skindata.name)
                        let jinbicost: number = itemMgr.getMe().getitemPricejinbi(_skindata.name)
                        let zuansicost: number = itemMgr.getMe().getitemPriceZuansi(_skindata.name)
                        if (!itemMgr.getMe().getSkinislock(type)) {
                            if (_skindata.jinbi == 1) {
                                if (jinbicost) {
                                    if (dataMgr.getMe().removeItemByType(e_item.e_jinbi, jinbicost)) {
                                        itemMgr.getMe().lockSkin(type);
                                        let suo: ccui.ImageView = ccui.helper.seekWidgetByName(sender, "suo");
                                        suo.setVisible(false);
                                        this.updateSpine();
                                        ui_goumaichenggong.ShowOrHide(true, {
                                            name: "wupin",
                                            num: 1,
                                            icon: _skindata.icon,
                                            iconName: _skindata.desName
                                        });
                                    } else {
                                        // ui_messageBox2.ShowOrHide(true, "金币不足！是否花费" + zuansicost + "钻石购买皮肤？", () => {
                                        //     buy_mgr.getInstance().shoppingByDiamond(zuansicost,"解锁皮肤",ui_pifu.getMe().buySucceedCallBack,null)
                                        // });
                                        buy_mgr.getInstance().buySkin_buy(ui_pifu.getMe().buySucceedCallBack,ui_pifu.getMe(),_skindata.name)
                                    }
                                }
                            }
                            else {
                                buy_mgr.getInstance().buySkin_buy(ui_pifu.getMe().buySucceedCallBack,ui_pifu.getMe(),_skindata.name)
                                // buy_mgr.getInstance().shoppingByDiamond(zuansicost,"解锁皮肤",ui_pifu.getMe().buySucceedCallBack,null)
                            }
                        }
                    }
                    break;
                case  ccui.Widget.TOUCH_CANCELED:
                    if (Version_mgr.getInstance().isPhone()) {
                        let texiao: ccui.ImageView = ccui.helper.seekWidgetByName(sender, "uitexiao");
                        texiao.setVisible(false);
                    }
                    break;
            }
        }
        m_cursender = null;//当前按钮
        buySucceedCallBack(){
            let _skindata: skin_s = ui_pifu.getMe().m_skinlist[ui_pifu.getMe().m_curKey];
            let type: e_item = itemMgr.getMe().stringToType(_skindata.name);
            // let zuansicost: number = itemMgr.getMe().getitemPriceZuansi(_skindata.name);
            // httpMgr.getMe().sendMsg(g_httpType.type_httpShoppinglog,
            //     zuansicost + "钻石购买" + _skindata.desName);
            itemMgr.getMe().lockSkin(type);
            if(ui_pifu.getMe().m_cursender){
                let suo: ccui.ImageView = ccui.helper.seekWidgetByName(ui_pifu.getMe().m_cursender, "suo");
                suo.setVisible(false);
            }
            ui_pifu.getMe().updateSpine();
            ui_goumaichenggong.ShowOrHide(true, {
                name: "wupin",
                num: 1,
                icon: _skindata.icon,
                iconName: _skindata.desName
            });
        }



        loop(t) {
            if (this.m_CBaseKeyState) {
                this.m_CBaseKeyState.loop(t)
                this.updatemoney();
            }
        }

        onBack() {
            ui_pifu.ShowOrHide(false);
            ui_shop.ShowOrHide(true);
        }

    }
}

