var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var EditBox = (function (_super) {
        __extends(EditBox, _super);
        function EditBox(placeholder, fontName, fontSize) {
            _super.call(this);
            this.hit = "";
            this.initBackGround();
            this.initTextField(placeholder, fontName, fontSize);
            this.initLight();
            this.addListener();
        }
        EditBox.prototype.initBackGround = function () {
            this.backGround = new cc.Sprite("xingjietantantang/big/ui/image/ddt_ui5.png");
            this.backGround.setAnchorPoint(0, 0.5);
            this.addChild(this.backGround);
        };
        EditBox.prototype.initTextField = function (placeholder, fontName, fontSize) {
            this.tf = new ccui.TextField(placeholder, fontName, fontSize);
            this.tf.setAnchorPoint(0, 0.5);
            this.tf.setMaxLengthEnabled(true);
            // 屏蔽默认点击,使用自定义点击
            this.tf.setTouchEnabled(false);
            this.tf.fontName = "Marker Felt";
            this.tf.fontSize = 30;
            this.tf.setTextColor(cc.color(0, 0, 0, 255));
            this.addChild(this.tf);
        };
        EditBox.prototype.initLight = function () {
            this.light = new cc.LabelTTF("|", "Arial", 25);
            this.light.setColor(cc.color(0, 0, 0));
            this.light.setAnchorPoint(0, 0.5);
            this.addChild(this.light);
            var seq = cc.sequence(cc.fadeIn(0.3), cc.delayTime(0.3), cc.fadeOut(0.3));
            var forever = cc.repeatForever(seq);
            this.light.runAction(forever);
            this.hiddenLight();
        };
        EditBox.prototype.setMaxLength = function () {
            this.tf.setMaxLength(length);
        };
        EditBox.prototype.setHit = function (strHit) {
            this.hit = strHit;
            this.tf.setPlaceHolder(this.hit);
        };
        EditBox.prototype.showHit = function () {
            this.tf.setPlaceHolder(this.hit);
        };
        EditBox.prototype.hiddenHit = function () {
            this.tf.setPlaceHolder("");
        };
        EditBox.prototype.setPasswordEnabled = function (enable) {
            this.tf.setPasswordEnabled(enable);
        };
        EditBox.prototype.setString = function (str) {
            this.tf.setString(str);
        };
        EditBox.prototype.getString = function () {
            return this.tf.getString();
        };
        // setPos(width, height) {
        //     this.x = width;
        //     this.y = height;
        // }
        EditBox.prototype.addListener = function () {
            // TextField 事件
            this.tf.addEventListener(this.textFieldEvent, this);
            // 点击事件
            // cc.eventManager.addListener(cc.EventListener.create({
            //     event: cc.EventListener.TOUCH_ONE_BY_ONE,
            //     onTouchBegan: this.onTouchBegan.bind(this)
            // }), this.backGround);
            var touchListener = {
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                onTouchBegan: this.onTouchBegan.bind(this)
            };
            cc.eventManager.addListener(touchListener, this.backGround);
        };
        EditBox.prototype.onTouchBegan = function (touch, event) {
            var pos = cc.p(touch.getLocationX(), touch.getLocationY());
            var target = event.getCurrentTarget();
            if (cc.rectContainsPoint(target.getBoundingBoxToWorld(), pos)) {
                setTimeout(function () {
                    cc.log("获取焦点");
                    this.tf.getVirtualRenderer().attachWithIME();
                }.bind(this), 0);
                this.showLight();
                return true;
            }
            else {
                setTimeout(function () {
                    cc.log("失去焦点");
                    this.tf.getVirtualRenderer().detachWithIME();
                    this.showHit();
                }.bind(this), 0);
                this.hiddenLight();
                return false;
            }
        };
        EditBox.prototype.showLight = function () {
            this.light.setVisible(true);
            var sv = this.tf.getString();
            if (!!sv && sv.length > 0) {
                this.light.setPositionX(this.tf.width - this.light.width * 0.5 + 1);
            }
            else {
                // 存在焦点
                this.light.setPositionX(this.light.width * 0.5);
                this.hiddenHit();
            }
        };
        EditBox.prototype.hiddenLight = function () {
            this.light.setVisible(false);
        };
        EditBox.prototype.textFieldEvent = function (textField, type) {
            switch (type) {
                case ccui.TextField.EVENT_ATTACH_WITH_IME:
                    cc.log("attach with IME");
                    this.showLight();
                    break;
                case ccui.TextField.EVENT_DETACH_WITH_IME:
                    cc.log("detach with IME");
                    this.hiddenLight();
                    break;
                case ccui.TextField.EVENT_INSERT_TEXT:
                    cc.log("insert words");
                    this.showLight();
                    break;
                case ccui.TextField.EVENT_DELETE_BACKWARD:
                    cc.log("delete word");
                    this.showLight();
                    break;
                default:
                    break;
            }
            cc.log(type);
        };
        return EditBox;
    }(game.xjNode));
    game.EditBox = EditBox;
})(game || (game = {}));
//# sourceMappingURL=ui_editbox.js.map