module game {
    export class EditBox extends xjNode {
        hit: string = "";
        tf: ccui.TextField;
        light: cc.LabelTTF;

        constructor(placeholder, fontName, fontSize) {
            super();
            this.initBackGround();
            this.initTextField(placeholder, fontName, fontSize);
            this.initLight();
            this.addListener();
        }
        backGround;
        initBackGround() {
            this.backGround = new cc.Sprite("xingjietantantang/big/ui/image/ddt_ui5.png");
            this.backGround.setAnchorPoint(0, 0.5);
            this.addChild(this.backGround);
        }

        initTextField(placeholder, fontName, fontSize) {
            this.tf = new ccui.TextField(placeholder, fontName, fontSize);
            this.tf.setAnchorPoint(0, 0.5);
            this.tf.setMaxLengthEnabled(true);
            // 屏蔽默认点击,使用自定义点击
            this.tf.setTouchEnabled(false);
            this.tf.fontName = "Marker Felt";
            this.tf.fontSize = 30;
            this.tf.setTextColor(cc.color(0, 0, 0, 255));
            this.addChild(this.tf);
        }

        initLight() {
            this.light = new cc.LabelTTF("|", "Arial", 25);
            this.light.setColor(cc.color(0, 0, 0));
            this.light.setAnchorPoint(0, 0.5);
            this.addChild(this.light);
            let seq = cc.sequence(cc.fadeIn(0.3), cc.delayTime(0.3), cc.fadeOut(0.3));
            let forever = cc.repeatForever(seq);
            this.light.runAction(forever);
            this.hiddenLight();
        }

        setMaxLength() {
            this.tf.setMaxLength(length);
        }

        setHit(strHit) {
            this.hit = strHit;
            this.tf.setPlaceHolder(this.hit)
        }

        showHit() {
            this.tf.setPlaceHolder(this.hit)
        }

        hiddenHit() {
            this.tf.setPlaceHolder("")
        }

        setPasswordEnabled(enable) {
            this.tf.setPasswordEnabled(enable);
        }

        setString(str) {
            this.tf.setString(str);
        }

        getString() {
            return this.tf.getString();
        }

        // setPos(width, height) {
        //     this.x = width;
        //     this.y = height;
        // }

        addListener() {
            // TextField 事件
            this.tf.addEventListener(this.textFieldEvent, this);
            // 点击事件
            // cc.eventManager.addListener(cc.EventListener.create({
            //     event: cc.EventListener.TOUCH_ONE_BY_ONE,
            //     onTouchBegan: this.onTouchBegan.bind(this)
            // }), this.backGround);

            let touchListener = {
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                onTouchBegan: this.onTouchBegan.bind(this)
            };
            cc.eventManager.addListener(touchListener, this.backGround);
        }

        onTouchBegan(touch, event) {
            let pos = cc.p(touch.getLocationX(), touch.getLocationY());
            let target = event.getCurrentTarget();
            if (cc.rectContainsPoint(target.getBoundingBoxToWorld(), pos)) {
                setTimeout(function () {
                    cc.log("获取焦点");
                    this.tf.getVirtualRenderer().attachWithIME();
                }.bind(this), 0);
                this.showLight();
                return true;
            } else {
                setTimeout(function () {
                    cc.log("失去焦点");
                    this.tf.getVirtualRenderer().detachWithIME();
                    this.showHit();
                }.bind(this), 0);
                this.hiddenLight();
                return false;
            }
        }

        showLight() {
            this.light.setVisible(true);
            let sv = this.tf.getString();
            if (!!sv && sv.length > 0) {
                this.light.setPositionX(this.tf.width - this.light.width * 0.5 + 1);
            } else {
                // 存在焦点

                this.light.setPositionX(this.light.width * 0.5);
                this.hiddenHit();
            }
        }

        hiddenLight() {
            this.light.setVisible(false);
        }

        textFieldEvent(textField, type) {
            switch (type) {
                case ccui.TextField.EVENT_ATTACH_WITH_IME:
                    cc.log("attach with IME");
                    this.showLight();
                    break;
                case ccui.TextField.EVENT_DETACH_WITH_IME:
                    cc.log("detach with IME");
                    this.hiddenLight();
                    break;
                case ccui.TextField.EVENT_INSERT_TEXT:
                    cc.log("insert words");
                    this.showLight();
                    break;
                case ccui.TextField.EVENT_DELETE_BACKWARD:
                    cc.log("delete word");
                    this.showLight();
                    break;
                default:
                    break;
            }
            cc.log(type);
        }
    }
}