module game {

    export class AwardsData {
        des: string;
        icon: string;
        name: string;
        award: AwardData = new AwardData();
        awardEx: string;
    }

    export class AwardData {
        name:string;
        type: e_item;
        num: number;
        icon:string;
    }

    export class viplevelupMgr {
        static g_stance: viplevelupMgr = null;

        static getMe(): viplevelupMgr {
            if (game.viplevelupMgr.g_stance == null) {
                viplevelupMgr.g_stance = new viplevelupMgr();
            }
            return viplevelupMgr.g_stance;
        };

        private m_awardMap: Map<number, AwardsData> = new Map<number, AwardsData>();
        m_index: number = 0;

        putAwards(level: number) {
            let data = g_vip_config[level];
            let award: AwardsData = new AwardsData();
            award.name = data.name;
            award.des = data.des;
            award.icon = data.icon;
            award.award.type = data.jiangli;
            award.award.num = data.jiangliNum;
            award.awardEx = data.awardEx;
            award.award.icon = data.jiangliicon;
            award.award.name = data.jiangliname;
            this.m_awardMap.set(level, award);
        }

        addAward() {
            let data: AwardsData;
            let awardEx;
            for (let i = 0; i < this.m_awardMap.size; ++i) {
                data = this.m_awardMap.getByIndex(i);
                awardEx = data.awardEx;
                dataMgr.getMe().addItemByType(data.award.type, data.award.num);
                if (awardEx) {
                    if (awardEx == "rongyu") {
                        dataMgr.getMe().addRongyu(500);
                    }
                    else if (awardEx == "skin_nan") {
                        itemMgr.getMe().lockSkin(itemMgr.getMe().stringToType("pifu_nan_2"));
                    }
                    else if (awardEx == "skin_nv") {
                        itemMgr.getMe().lockSkin(itemMgr.getMe().stringToType("pifu_nv_2"));
                    }
                    else if (awardEx == "weapon") {
                        itemMgr.getMe().setWeaponLock("wuqi21");
                        itemMgr.getMe().setWeaponLock("wuqi21_1");
                        dataMgr.getMe().addTittleNum(e_chenghao.e_1, 2);
                    }
                }
            }
            fileMgr.savePlayInfo_callback();
        }

        updateUI() {
            let data: AwardsData = this.m_awardMap.getByIndex(this.m_index);
            let level = this.m_awardMap.getKey(this.m_index);
            if (data) {
                ui_VipEffectEx.ShowOrHide(true, {
                    level: level, callback: () => {
                        ui_messageBox.ShowOrHide(true, data.des, () => {
                            ui_vipjianglihuodeEx.ShowOrHide(true,{name:data.award.name,num:data.award.num,icon:data.award.icon,callback:()=>{
                                viplevelupMgr.getMe().m_index++;
                                    viplevelupMgr.getMe().updateUI();
                                }});
                        });
                    }
                });
            }
        }

        addVipExp(exp) {
            this.m_index = 0;
            this.m_awardMap.clear();
            let vipLevel = dataMgr.getMe().getViplevel();
            let maxVipLevel = dataMgr.getMe().getMaxVIPLevel();
            let Versiondiamond: number = Version_mgr.getInstance().getRmbPriceByTag("1").diamond;
            let s_Exp = fileMgr.getMe().m_play_doc.coreData.vipscore + exp;
            let max = this.getMaxchongzhiNum();
            if (isNaN(exp)) {
                cc.log("is NaN");
                return;
            }
            if (exp < 0) {
                return;
            }
            if (vipLevel >= maxVipLevel) {
                console.log("viplevel is full");
                return;
            }
            if (s_Exp > max) {
                s_Exp = max;
            }
            let levelArr = this.getlevelupNum(s_Exp, Versiondiamond, vipLevel, maxVipLevel);
            for (let p = 0; p < levelArr.length; ++p) {

                this.putAwards(levelArr[p]);
                // let jiangli: number = g_vip_config[levels[p]].jiangliNum;
                // let gold_data = this.getGold(levels[p], jiangli);
                // let diamond_data = this.getdiamond(levels[p], jiangli);
                // let yaoji_data = this.getYaoji(levels[p], jiangli);
                // let rongyu_data = this.getRongyu(levels[p]);
                // let skin_data = this.getSkin(levels[p]);
                // let weapon_data = this.getWeapon(levels[p]);
                // if (gold_data) {
                //     awards.push(gold_data);
                // }
                // if (diamond_data) {
                //     awards.push(diamond_data);
                // }
                // if (yaoji_data) {
                //     awards.push(yaoji_data);
                // }
                // if (rongyu_data) {
                //     awards.push(rongyu_data);
                // }
                // if (skin_data) {
                //     awards.push(skin_data);
                // }
                // if (weapon_data) {
                //     awards.push(weapon_data);
                // }
                // this.m_awardMap.set(levels[p], awards)
            }
            let l = levelArr[levelArr.length - 1];
            if(l != null){
                fileMgr.getMe().m_play_doc.coreData.viplevel = levelArr[levelArr.length - 1];
            }
            fileMgr.getMe().m_play_doc.coreData.vipscore = s_Exp;

            // let index: number = 0;
            // for (let k = 0; k < levelArr.length; ++k) {
            //     this.m_AwardMapUI.set(index++, levels[k]);
            //     this.m_AwardMapUI.set(index++, g_vip_config[levels[k]].des);
            //     this.m_AwardMapUI.set(index++, this.m_awardMap.get(levels[k]));
            // }


            // ui_Viptexiao.ShowOrHide(true,)
            // ui_vipjianglihuode.ShowOrHide(true,)
            // ui_messageBox.ShowOrHide(true, g_vip_config[dataMgr.getMe().getViplevel()].des);
            // fileMgr.savePlayInfo_callback();
            this.addAward();
            this.updateUI();
        }


        //获得升级vip等级的数组
        getlevelupNum(exp, Versiondiamond, vipLevel: number, maxVipLevel) {
            let levelnum = [];//存放vip等级
            for (let i: number = vipLevel; i < maxVipLevel; ++i) {
                let nextexp = g_vip_config[i + 1].chongzhi * Versiondiamond;
                if (exp >= nextexp) {
                    levelnum.push(i + 1);
                } else {
                    break;
                }
            }
            levelnum.sort(function (a, b) {
                return a - b;
            });
            return levelnum;
        }

        //总计vip升级经验
        getMaxchongzhiNum() {
            let maxdiamond: number = 0;
            for (let i = 1; i <= dataMgr.getMe().getMaxVIPLevel(); ++i) {
                let Versiondiamond: number = Version_mgr.getInstance().getRmbPriceByTag("1").diamond;
                let chongzhi: number = g_vip_config[i].chongzhi * Versiondiamond;
                maxdiamond += chongzhi;
            }
            return maxdiamond
        }

        //vip奖励钻石或者金币或者药水
        // getGold(level: number, jiangli: number) {
        //     let awrad: Awards = new Awards();
        //     if (g_vip_config[level].jiangli == "jinbi") {
        // dataMgr.getMe().addItemByType(e_item.e_jinbi, jiangli);
        //         awrad.name = "金币";
        //         awrad.icon = "xingjietantantang/big/ui/image/ddt_ui163.png";
        //         awrad.num = jiangli;
        //         return awrad
        //     }
        //     return null;
        // }

        //
        // getYaoji(level: number, jiangli: number) {
        //     let awrad: Awards = new Awards();
        //     if (g_vip_config[level].jiangli.indexOf("yaoji") > -1) {
        //         dataMgr.getMe().addItemByType(e_item["e_" + g_vip_config[level].jiangli], jiangli);
        //         let conf = g_vip_config[level];
        //         awrad.name = g_daoju_nan[conf.jiangli].desName;
        //         awrad.icon = g_daoju_nan[conf.jiangli].icon;
        //         awrad.num = jiangli;
        //         return awrad
        //     }
        //     return null;
        // }
        //
        //
        // getdiamond(level: number, jiangli: number) {
        //     let awrad: Awards = new Awards();
        //     if (g_vip_config[level].jiangli == "zuanshi") {
        //         dataMgr.getMe().addDiamond(jiangli);
        //         awrad.name = "钻石";
        //         awrad.icon = "xingjietantantang/big/ui/image/ddt_ui164.png";
        //         awrad.num = jiangli;
        //         return awrad;
        //     }
        //     return null;
        // }
        //
        //
        // getRongyu(level: number) {
        //     let awrad: Awards = new Awards();
        //     if (level == 5) {
        //         dataMgr.getMe().addRongyu(500);
        //         awrad.name = "荣誉值";
        //         awrad.icon = "xingjietantantang/big/ui/image/ddt_ui165.png";
        //         awrad.num = 500;
        //         return awrad;
        //     }
        //     return null;
        // }
        //
        // getSkin(level: number) {
        //     let awrad: Awards = new Awards();
        //     if (level == 6) {
        //         itemMgr.getMe().lockSkin(itemMgr.getMe().stringToType("pifu_nv_2"));
        //         awrad.name = g_daoju_nan["pifu_nv_2"].desName;
        //         awrad.icon = g_daoju_nan["pifu_nv_2"].icon;
        //         awrad.num = 1;
        //         return awrad;
        //     } else if (level == 7) {
        //         itemMgr.getMe().lockSkin(itemMgr.getMe().stringToType("pifu_nan_2"));
        //         awrad.name = g_daoju_nan["pifu_nan_2"].desName;
        //         awrad.icon = g_daoju_nan["pifu_nan_2"].icon;
        //         awrad.num = 1;
        //         return awrad
        //     }
        //     return null;
        // }
        //
        // getWeapon(level: number) {
        //     let awrad: Awards = new Awards();
        //     if (level == 8) {
        //         itemMgr.getMe().setWeaponLock("wuqi21");
        //         itemMgr.getMe().setWeaponLock("wuqi21_1");
        //         awrad.name = g_daoju_nan["wuqi21"].desName;
        //         awrad.icon = g_daoju_nan["wuqi21"].icon;
        //         awrad.num = 2;
        //         dataMgr.getMe().addTittleNum(e_chenghao.e_1, 2);
        //         return awrad
        //     }
        //     return null;
        // }
    }
}